local _, L = ...
local mediaFolder = "Interface\\AddOns\\".._.."\\Media\\"
local LMB, RMB = CreateAtlasMarkup("NPE_LeftClick", 18, 18), CreateAtlasMarkup("NPE_RightClick", 18,18)


local match = string.match

L.TEX_WORLD_RAID_MARKERS = {
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_2:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_4:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_6:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:14:14|t",
  "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:14:14|t",
}

local onlyOutOfCombat = "|cffff0000 Plz setup this option only if you are out of combat.|r"

----------------------------------
-- Interrupt priority table
----------------------------------
L.inperruptSpellTable = {
	[183752]	= {priority = 16, cd = 15, mark = 3}, -- DEMONHUNTER Disrupt 3s 10y 30 fury take energy
	[1766]		= {priority = 15, cd = 15, mark = 1}, -- ROGUE Kick 5s 5y
	[106839]	= {priority = 14, cd = 15, mark = 6}, -- DRUID Skull Bash 4s 13y
	[96231]		= {priority = 13, cd = 15, mark = 3}, -- PALADIN Rebuke 4s 5y
	[6552]		= {priority = 12, cd = 15, mark = 8}, -- WARRIOR Pummel 4s 5y
	[116705]	= {priority = 11, cd = 15, mark = 4}, -- MONK Spear Hand Strike 4s 5y
	[47528]		= {priority = 10, cd = 15, mark = 8}, -- DEATHKNIGHT Mind Freeze 3s 15y
	[187707]	= {priority = 9,  cd = 15, mark = 4}, -- HUNTER Muzzle 3s 5y
	[57994]		= {priority = 8,  cd = 12, mark = 8}, -- SHAMAN Wind Shear 3s 30y
	[2139]		= {priority = 7,  cd = 24, mark = 6}, -- MAGE Counter Spell 6s 40y
	[147362]	= {priority = 6,  cd = 24, mark = 4}, -- HUNTER Counter Shot 3s 40y
	[119910]	= {priority = 5,  cd = 24, mark = 7}, -- WARRLOCK Spell Lock Command Demon
	[19647]		= {priority = 4,  cd = 24, mark = 7}, -- WARRLOCK Spell Lock if used from pet bar
	[132409]	= {priority = 3,  cd = 24, mark = 7}, -- WARRLOCK Spell Lock Command Demon Sacrifice
	[15487]		= {priority = 2,  cd = 45, mark = 5}, -- PRIEST Silence 4s
	[78675]		= {priority = 1,  cd = 60, mark = 6}, -- DRUID Solar Beam 8s 45y
}

----------------------------------
-- Diminish tables
----------------------------------
L.diminishSpellTable = {
["Stun"] = {
-- Death Knight
	[210141]	= true, -- Zombie Explosion
	[108194]	= true, -- Asphyxiate (Unholy)
	[221562]	= true, -- Asphyxiate (Blood)
	[91800]		= true, -- Gnaw (Ghoul)
	[91797]		= true, -- Monstrous Blow (Mutated Ghoul)
	[287254]	= true, -- Dead of Winter
-- Demon Hunter
	[179057]	= true, -- Chaos Nova
	--  [213491]  = true, -- Demonic Trample (Only DRs with itself once)
	[205630]	= true, -- Illidan's Grasp (Primary effect)
	[208618]	= true, -- Illidan's Grasp (Secondary effect)
	[211881]	= true, -- Fel Eruption
	[200166]	= true, -- Metamorphosis (PvE stun effect)
-- Druid
	[203123]	= true, -- Maim
	[163505]	= true, -- Rake (Prowl)
	[5211]		= true, -- Mighty Bash
	[202244]	= true, -- Overrun
-- Hunter
	[24394]		= true, -- Intimidation
-- Monk
	[119381]	= true, -- Leg Sweep
	[202346]	= true, -- Double Barrel
-- Paladin
	[853]		= true, -- Hammer of Justice
-- Priest
	[64044]		= true, -- Psychic Horror
	[200200]	= true, -- Holy Word: Chastise Censure
-- rogue	
	[1833]		= true, -- Cheap Shot
	[408]		= true, -- Kidney Shot
	[199804]	= true, -- Between the Eyes
-- Shaman
	[118905]	= true, -- Static Charge (Capacitor Totem)
	[118345]	= true, -- Pulverize
	[305485]	= true, -- Lightning Lasso
-- Warlock
	[89766]		= true, -- Axe Toss
	[171017]	= true, -- Meteor Strike (Infernal)
	[171018]	= true, -- Meteor Strike (Abyssal)
	--[22703]	= true, -- Infernal Awakening (udajne nerobi DR)
	[30283]		= true, -- Shadowfury
-- warrior
	[46968]		= true, -- Shockwave
	[132168]	= true, -- Shockwave (Protection)
	[145047]	= true, -- Shockwave (Proving Grounds PvE)
	[132169]	= true, -- Storm Bolt
	[199085]	= true, -- Warpath - Leap stun
-- odpad
	--	[213688]  = true, -- Fel Cleave (udajne nerobi DR)
	[20549]		= true, -- War Stomp (Tauren) racial
	[255723]	= true, -- Bull Rush (Highmountain Tauren) vraj 255654
	[287712]	= true, -- Haymaker (Kul Tiran)
	[280061]	= true, -- Brainsmasher Brew (Item)
	[245638]	= true, -- Thick Shell (Item)
	},
["Disorient"] = {
	[207167]	= true, -- Blinding Sleet
	[207685]	= true, -- Sigil of Misery
	[33786]		= true, -- Cyclone
	[209753]	= true, -- Cyclone (Honor talent)
	[31661]		= true, -- Dragon's Breath
	[198909]	= true, -- Song of Chi-ji
	[202274]	= true, -- Incendiary Brew
	[105421]	= true, -- Blinding Light
	[605]		= true, -- Mind Control
	[8122]		= true, -- Psychic Scream
	[226943]	= true, -- Mind Bomb
	[2094]		= true, -- Blind
	[118699]	= true, -- Fear
	[261589]	= true, -- Seduction (Grimoire of Sacrifice)
	[6358]		= true, -- Seduction (Succubus)
	[5246]		= true, -- Intimidating Shout
	[35474]		= true, -- Drums of Panic (Item)
	[269186]	= true, -- Holographic Horror Projector (Item)
	[280062]	= true, -- Unluckydo (Item)
	[267026]	= true, -- Giant Flower (Item)
	[243576]	= true, -- Sticky Starfish (Item)
	},
["Incapacitate"] = {
	[217832]	= true, -- Imprison
	[221527]	= true, -- Imprison (Honor talent)
	[2637]		= true, -- Hibernate
	[99]		= true, -- Incapacitating Roar
	[3355]		= true, -- Freezing Trap
	[203337]	= true, -- Freezing Trap (Honor talent)
	[213691]	= true, -- Scatter Shot
	[118]		= true, -- Polymorph
	[28271]		= true, -- Polymorph (Turtle)
	[28272]		= true, -- Polymorph (Pig)
	[61025]		= true, -- Polymorph (Snake)
	[61305]		= true, -- Polymorph (Black Cat)
	[61780]		= true, -- Polymorph (Turkey)
	[61721]		= true, -- Polymorph (Rabbit)
	[126819]	= true, -- Polymorph (Porcupine)
	[161353]	= true, -- Polymorph (Polar Bear Cub)
	[161354]	= true, -- Polymorph (Monkey)
	[161355]	= true, -- Polymorph (Penguin)
	[161372]	= true, -- Polymorph (Peacock)
	[277787]	= true, -- Polymorph (Baby Direhorn)
	[277792]	= true, -- Polymorph (Bumblebee)
	[82691]		= true, -- Ring of Frost
	[115078]	= true, -- Paralysis
	[20066]		= true, -- Repentance
	[9484]		= true, -- Shackle Undead
	[200196]	= true, -- Holy Word: Chastise
	[1776]		= true, -- Gouge
	[6770]		= true, -- Sap
	[51514]		= true, -- Hex
	[196942]	= true, -- Hex (Voodoo Totem)
	[210873]	= true, -- Hex (Raptor)
	[211004]	= true, -- Hex (Spider)
	[211010]	= true, -- Hex (Snake)
	[211015]	= true, -- Hex (Cockroach)
	[269352]	= true, -- Hex (Skeletal Hatchling)
	[309328]	= true, -- Hex (Living Honey)
	[277778]	= true, -- Hex (Zandalari Tendonripper)
	[277784]	= true, -- Hex (Wicker Mongrel)
	[197214]	= true, -- Sundering
	[710]		= true, -- Banish
	[6789]		= true, -- Mortal Coil
	[107079]	= true, -- Quaking Palm (Pandaren racial)
	[89637]		= true, -- Big Daddy (Item)
	[255228]	= true, -- Polymorphed (Organic Discombobulation Grenade) (Item)
	[71988]		= true, -- Vile Fumes (Item)
	},
["Root"] = {
	[204085]	= true, -- Deathchill (Chains of Ice)
	[233395]	= true, -- Deathchill (Remorseless Winter)
	[339]		= true, -- Entangling Roots
	[170855]	= true, -- Entangling Roots (Nature's Grasp)
--  [45334]		= true, -- Immobilized (Wild Charge, doesn't seem to DR)
	[102359]	= true, -- Mass Entanglement
	[117526]	= true, -- Binding Shot (Note: debuff says stun but it's actually a root)
	[162480]	= true, -- Steel Trap
--  [190927]	= "root_harpoon", -- Harpoon (TODO: check if DRs with itself)
	[212638]	= true, -- Tracker's Net
	[201158]	= true, -- Super Sticky Tar
	[122]		= true, -- Frost Nova
	[33395]		= true, -- Freeze
	[198121]	= true, -- Frostbite
	[220107]	= true, -- Frostbite (Water Elemental? needs testing)
	[233582]	= true, -- Entrenched in Flame
	[116706]	= true, -- Disable
	[64695]		= true, -- Earthgrab (Totem effect)
	[39965]		= true, -- Frost Grenade (Item)
	[75148]		= true, -- Embersilk Net (Item)
	[55536]		= true, -- Frostweave Net (Item)
	[268966]	= true, -- Hooked Deep Sea Net (Item)
	[270399]	= true, -- Unleashed Roots (Item)
	[270196]	= true, -- Chains of Light (Item)
	[267024]	= true, -- Stranglevines (Item)
	},
}



----------------------------------
-- Default config
----------------------------------
L.defaults = {
profile = {
	newsMessage					= 	"- only repair any code\n",
									
	nameplateGlobalScale			= 1,
	nameplate_alpha					= 0.4,
	nameplateOccludedAlphaMult		= 1,
	nameplateMaxDistance 			= 100,
	nameplateTargetRadialPosition 	= 2,
	nameplateOtherAtBase			= 0,
	sound_channel					= "Master",
	nameplateLargerScale			= 1,
	nameplateLargeTopInset			= 0.07,
	nameplateLargeBottomInset		= 0.10,
	nameplateOtherTopInset			= 0.07,
	nameplateOtherBottomInset		= 0.10,
	
	widget_show						= true,
	widget_scale					= .7,
	nameplateMotion					= 1,
	nameplateOverlapV 				= 0.8,
	nameplateOverlapH 				= 0.6,
	nameplateMotionSpeed			= 0.15,
	
	nameplateMinAlpha 				= 0.8,
	nameplateMinAlphaDistance		= 10,
	nameplateMaxAlpha 				= 1,
	nameplateMaxAlphaDistance		= 40,
	nameplateTargetBehindMaxDistance = 15,
	nameplateMaxScale				= 1,
	nameplateMaxScaleDistance		= 10,
	nameplateMinScale				= 1,
	nameplateMinScaleDistance		= 10,
	

-- Name setup
	name_translate			= true,
	class_color_friendly	= true,
	class_color_enemy		= true,
	show_honor_level		= false,
	name_short				= true,
		name_short_lenght	= 25,
	name_text_alpha_hb		= 0,
	name_text_alpha_nohb	= .7,
	name_point				= "TOP",
	name_relativePoint		= "BOTTOM",
	name_posun_X			= 0,
	name_posun_Y			= -2,
	name_font_npc				= "np_font_1",
		name_fontsize_npc		= 7,
		name_font_flag_npc		= 'OUTLINE',
	name_font_players			= "Dajova",
		name_fontsize_players	= 9,
		name_font_flag_players	= 'OUTLINE',
	name_font_target			= "np_font_1",
		name_fontsize_target 	= 7,
		name_font_flag_target	= 'OUTLINE',
	
	
-- Health and Power
	hp_enable				= true,
		hp_font_color		= {191/255, 228/255, 118/255, 1},
		hp_font				= "Dajova",
		hp_fontsize			= 8,
		hp_font_flag		= 'OUTLINE',
		hp_point			= "BOTTOMRIGHT",
		hp_relativePoint	= "BOTTOMRIGHT",
		hp_posun_X			= 0,
		hp_posun_Y			= -3,
		hp_format			= 2,
	healthbar_show		= { ["player"] = true,	["enemy"] = false,	["friendly"] = false},
		healthbar_smooth		= true,
		healthbar_shadow		= { ["player"] = true,	["enemy"] = true,	["friendly"] = true},
		healthbar_shadow_color	= { ["player"] = {0/255, 0/255, 0/255, 1},	["enemy"] = {0/255, 0/255, 0/255, 1},	["friendly"] = {0/255, 0/255, 0/255, 1}},
		healthbar_texture		= { ["player"] = "np_target2",	["enemy"] = "np_target2",	["friendly"] = "np_target2"},
		healthbar_bg_texture	= { ["player"] = "np_target2",	["enemy"] = "np_target2",	["friendly"] = "np_target2"},
		healthbar_div_bg		= { ["player"] = 3,	["enemy"] = 3,	["friendly"] = 3},
		healthbar_width			= { ["player"] = 110,	["enemy"] = 90,	["friendly"] = 90},
		healthbar_height		= { ["player"] = 10,	["enemy"] = 9,	["friendly"] = 9},
		healthbar_bg_alpha		= { ["player"] = .8,	["enemy"] = .8,	["friendly"] = .8},
		healthbar_class_color	= { ["player"] = true,	["enemy"] = true,	["friendly"] = true},
		healthbar_border_top	= { ["player"] = true,	["enemy"] = false,	["friendly"] = true},
		healthbar_border_bottom	= { ["player"] = true,	["enemy"] = true,	["friendly"] = true},
		healthbar_border_left	= { ["player"] = true,	["enemy"] = false,	["friendly"] = true},
		healthbar_border_right	= { ["player"] = true,	["enemy"] = false,	["friendly"] = true},
		healthbar_spark			= { ["player"] = true,	["enemy"] = true,	["friendly"] = true},
		healthbar_bg_offset		= 5,
		healthbar_dps_color_1	= {0/255, 128/255, 255/255, 1},
		healthbar_dps_color_2	= {0/255, 128/255, 255/255, 1},
		healthbar_dps_color_3	= {0/255, 128/255, 255/255, 1},
		healthbar_dps_color_4	= {255/255, 0/255, 0/255, 1},
		dps_value_color_1		= .2,
		dps_value_color_2		= .3,
	powerbar_alltime			= false,
		powerbar_smooth			= true,
		powerbar_texture		= "np_cb_texture",
		powerbar_bg_texture		= "np_cb_texture",
		powerbar_Y				= -1,
		powerbar_height			= 3,
	-- Personal nameplate
	nameplatepersonalShowAlways			= true,
	nameplatePersonalShowInCombat		= true,
	nameplatePersonalShowWithTarget		= true,
	self_healthbar_texture				= "np_pb_texture",
	self_healthbar_bg_texture			= "mMedia2g",
	self_healthbar_bg_color				= {1, 0, 0, 1},
	self_powerbar_texture				= "np_hb_texture_2",
	self_powerbar_width					= 90,
	self_powerbar_height				= 5,
	self_unitframe_flash				= true,
	self_unitframe_warning				= 0.5,
	self_unitframe_scale				= 1.3,
	nameplateSelfAlpha 					= 1,
	nameplateSelfScale 					= 1,
	nameplateSelfTopInset				= 0.7,
	nameplateSelfBottomInset			= 0.12,
	nameplatePersonalHideDelayAlpha		= 0.45,
	nameplatePersonalHideDelaySeconds	= 3,
	
	selfClickThrough				= true,
	friendlyClickThrough			= false,
	enemyClickThrough				= false,
	baseNamePlateWidth				= 90,
	baseNamePlateHeight				= 10,
	nameplateShowEnemyGuardians		= true,
	nameplateShowEnemyMinions		= true,
	nameplateShowEnemyMinus			= true,
	nameplateShowEnemyPets			= true,
	nameplateShowEnemyTotems		= true,
	nameplateShowFriendlyGuardians	= false,
	nameplateShowFriendlyMinions	= false,
	nameplateShowFriendlyNPCs		= false,
	nameplateShowFriendlyPets		= false,
	nameplateShowFriendlyTotems		= false,
	
	
-- Target, mouseover, focus
	target_overlap_show				= false,
		target_overlap				= "np_target3",
		target_overlap_blend		= "ALPHAKEY",
		target_overlap_color		= {255/255, 0/255, 0/255, .99},
		target_overlap_flip			= "BOTTOMLEFT",
		target_overlap_offset		= 3,
	target_healthbar_scale			= 1.6,
	nameplateSelectedScale			= 1,
	target_highlight				= .1,
	target_healthbar 				= true,
		target_healthbar_texture	= "pHish31",
	target_shadow					= false,
		target_shadow_color			= {255/255, 128/255, 0/255, 1},
		target_shadow_flash			= false,
	target_glow						= true,
		target_glow_width			= 10,
		target_glow_height			= 1,
		target_glow_number			= 8,
		target_glow_border			= false,
		target_glow_xOffset			= 1,
		target_glow_yOffset			= 1,
		target_glow_speed			= .25,
		target_glow_color			= {255/255, 255/255, 0/255, 1},
	mouseover_enable				= true,
		mouseover_healthbar_scale	= 1,
		mouseover_highlight			= .25,
		mouseover_shadow			= false,
		mouseover_shadow_color		= {255/255, 255/255, 255/255, 1},
	focus_enable					= true,
		focus_healthbar_scale		= 1.4,
		focus_shadow				= true,
		focus_shadow_color			= {0/255, 255/255, 255/255, 1},
		focus_healthbar				= true,
		focus_healthbar_texture		= "mMedia2c",

-- Resource bar
	player_resource_type				= 3,
		player_resource_pine			= "target",
		player_resource_position_width	= {["player"] = 140,	["target"] = 150,	["screen"] = 300},
		player_resource_position_height	= {["player"] = 8, 	["target"] = 8,		["screen"] = 20},
		player_resource_position_space	= {["player"] = 2, 	["target"] = 3,		["screen"] = 4},
		player_resource_position_y		= {["player"] = 2, 	["target"] = -5,		["screen"] = 525},
		
		player_resource_texture			= "np_cb_texture",
		player_resource_sound_enable	= true,	
		player_resource_sound			= "np_resource_sound",
		player_resource_color			= {	[1] = {0, 1, 0, 1},
											[2] = {0, 1, 0, 1},
											[3] = {0, 1, 0, 1},
											[4] = {0, 1, 0, 1},
											[5] = {0, 1, 0, 1},
											[6] = {1, 1, 0, 1}},
		player_resource_color_full		= {.8, .8, 1, 1},
		player_resource_color_empty		= {.3, .3, .6, 1},
		party_health_bars_dynamic_size	= true,
		party_kick_bars_shadow			= false,
		player_resource_spell_CD		= nil,


-- CasrBar
	cb_show_spellName		= false,
	cb_show_kickerName		= true,
	cb_kicker_spam			= true,
	cb_show_CD				= true,
	cb_show_spark			= true,
	cb_friendly_show		= false,
	cb_target_hide			= false,
	cb_schoolColor			= false,
	cb_type					= 4,
	cb_alpha				= 1,
	cb_target_scale			= 1.2,
	
	-- type 1
	cb_1_size_X				= 34,
	cb_1_size_Y				= 22,
	cb_1_offset				= 4,
	cb_1_posun_X			= 0,
	cb_1_posun_Y			= 0,
	-- type 2
	cb_2_icon_size_X		= 22,
	cb_2_icon_size_Y		= 14,
	cb_2_icon_posun_X		= 0,
	cb_2_icon_posun_Y		= 4,
	cb_2_align				= "CENTER",
	cb_2_offset				= -1,
	-- type 3
	cb_3_size_Y				= 4,
	cb_3_icon_position		= 1,
	-- type 4
	cb_4_size_X				= 28,
	cb_4_size_Y				= 18,
	cb_4_posun_X			= 0,
	cb_4_posun_Y			= 0,
	-- for all
	cb_texture				= {[1] = "np_cb_texture", 	[2] = "np_cb_out_line2", 	[3] = "np_cb_texture", 	[4] = "np_cb_texture"},
	cb_sb_alpha 				= {[1] = 1, 					[2] = .8, 					[3] = .8, 				[4] = .7},
	cb_sb_shadow			= {[1] = true, 				[2] = false, 				[3] = true,				[4] = true},
	cb_texture_bg			= {[1] = "np_cb_texture", 	[2] = "np_cb_out_line2",		[3] = "np_cb_texture",	[4] = "np_cb_texture"},
	cb_bg_alpha 				= {[1] = .8, 				[2] = .8, 					[3] = .8,				[4] = .4},
	cb_font					= "np_font_1",
	cb_fontsize  			= 7,
	cb_CD_font_flag			= 'OUTLINE',
	cb_CD_font				= "np_font_1",
	cb_CD_fontsize  			= 13,
	cb_font_flag				= 'OUTLINE',
	cb_kicker_font				= "np_font_1",
	cb_kicker_fontsize			= 8,
	cb_kicker_font_flag			= 'OUTLINE',
	cb_kickerNameBGTexture		= "np_om_texture",
	cb_kicker_texture_color		= {0/255, 0/255, 0/255, 1},
	cb_startCastColor			= {0.2, 1, 0.2},
	cb_startChannelColor		= {1, 1, 0.2},
	cb_finishedCastColor		= {1, 1, 1},
	cb_failedCastColor			= {0.4, 0.4, 1},
	cb_nonInterruptibleColor 	= {1, 0, 0},
	cb_finishedColorSameAsStart	= true,
	cb_flashColorSameAsStart 	= true,
	cb_colorSchool_offset		= 3,
	cb_schoolColors = {
		[0] =	{color = {178/255,	178/255,	178/255, 1}, name = "Unknown"},
		[1] =	{color = {255/255,	255/255,	0/255, 1}, name = "Physical"},
		[2] =	{color = {255/255,	228/255,	128/255, 1}, name = "Holy"},
		[3] =	{color = {255/255,	228/255,	128/255, 1}, name = "Holystrike"},
		[4] =	{color = {255/255,	128/255,	0/255, 1}, name = "Fire"},
		[5] =	{color = {237/255,	72/255,		28/255, 1}, name = "Flamestrike"},
		[6] =	{color = {237/255,	28/255,		36/255, 1}, name = "Holyfire"},
		[8] =	{color = {76/255,	255/255, 	76/255, 1}, name = "Nature"},
		[9] =	{color = {0/255,		158/255,	0/255, 1}, name = "Stormstrike"},
		[10] =	{color = {0/255,		158/255,	0/255, 1}, name = "Holystorm"},
		[12] =	{color = {237/255,	72/255,		28/255, 1}, name = "Firestorm"},
		[16] =	{color = {128/255,	255/255,	255/255, 1}, name = "Frost"},
		[17] =	{color = {0/255,		191/255,	255/255, 1}, name = "Froststrike"},
		[18] =	{color = {255/255,	162/255,	0/255, 1}, name = "Holyfrost"},
		[20] =	{color = {237/255,	72/255,		28/255, 1}, name = "Frostfire"},
		[24] =	{color = {0/255,		191/255,	255/255, 1}, name = "Froststorm"},
		[28] =	{color = {255/255,	162/255,	0/255, 1}, name = "Elemental"},
		[32] =	{color = {128/255,	128/255, 	255/255, 1}, name = "Shadow"},
		[33] =	{color = {102/255,	45/255,		140/255, 1}, name = "Shadowstrike"},
		[34] =	{color = {102/255,	45/255,		140/255, 1}, name = "Twilight"},
		[36] =	{color = {102/255,	45/255,		140/255, 1}, name = "Shadowflame"},
		[40] =	{color = {102/255,	45/255,		140/255, 1}, name = "Plague"},
		[48] =	{color = {147/255,	39/255,		143/255, 1}, name = "Shadowfrost"},
		[64] =	{color = {255/255,	128/255,	255/255, 1}, name = "Arcane"},
		[65] =	{color = {176/255,	102/255,	255/255, 1}, name = "Spellstrike"},
		[66] =	{color = {176/255,	102/255,	255/255, 1}, name = "Divine"},
		[68] =	{color = {176/255,	102/255,	255/255, 1}, name = "Spellfire"},
		[72] =	{color = {252/255,	165/255,	241/255, 1}, name = "Astral"},
		[80] =	{color = {176/255,	102/255,	255/255, 1}, name = "Spellfrost"},
		[96] =	{color = {102/255,	45/255,		140/255, 1}, name = "Spellshadow"},
		[124] =	{color = {212/255,	0/255,		85/255, 1}, name = "Chromatic"},
		[126] =	{color = {213/255,	133/255,	255/255, 1}, name = "Magic"},
		[127] =	{color = {212/255,	0/255,		85/255, 1}, name = "Chaos"},
	},
	
-- Auras
	aura_debuff_show		= true,
	aura_buff_show			= true,
	aura_self_show			= true,
	aura_stun_show			= true,
	aura_bar_show			= true,
	aura_show_timer_icon	= true,
	aura_show_timer_bar		= false,
	aura_show_cd			= false,
	aura_info				= true,
	aura_dispel_spam		= true,
	aura_space_X			= 3,
	aura_bar_position		= "TOP",
	
	aura_icon_debuff_width		= 22,
	aura_icon_debuff_height		= 12,
	aura_bar_debuff_height		= 6,
	aura_icon_debuff_max		= 5,
	aura_bar_debuff_Y			= 2,
	
	aura_icon_buff_width		= 22,
	aura_icon_buff_height		= 12,
	aura_icon_buff_dispelable_size =	1.2,
	aura_icon_buff_max			= 5,
	aura_buff_Y					= 2,
	
	aura_icon_self_width		= 24,
	aura_icon_self_height		= 14,
	aura_icon_self_max			= 4,
	aura_self_Y					= 1,
	
	aura_stun_size_width		= 23,
	aura_stun_size_height		= 14,
	
-- Trheat setup
	threat_show				= true,
	threat_show_as_bar		= false,
	threat_show_onlyingroup	= true,
	threat_show_perc		= 80,
	threat_flash			= false,
	threat_flash_time		= .4,
	threat_color_noaggro	= {180/255, 180/255, 180/255, 1},
	threat_color_1 			= {128/255, 255/255, 0/255, 1},
	threat_color_2 			= {255/255, 255/255, 0/255, 1},
	threat_color_3 			= {255/255, 0/255, 128/255, 1},
	threat_color_4 			= {255/255, 0/255, 0/255, 1},
	threat_color_offtank 	= {128/255, 0/255, 255/255, 1},
	threat_color_execute 	= {255/255, 0/255, 0/255, 1},
	threat_execute_value	= 0,
	
-- Quest setup
	quest_detection			= true,
		quest_text			= false,
		quest_value			= true,
		quest_value_full	= false,
		quest_icon			= true,
		quest_icon_extended	= true,
		quest_max_alpha		= true,
		quest_icon_x		= -2,
		quest_icon_y		= 0,
		quest_color			= true,
		quest_name_color	= {0/255, 255/255, 255/255, 1},	
		quest_sound_enable	= true,	
		quest_sound			= "np_sound_quest",
		quest_font			= "Dajova",
		quest_fontsize		= 8,
		quest_font_flag		= 'OUTLINE',
		quest_party			= true,
		
		--vignetteeventelite, Callings-Available "countdown-swords" charactercreate-icon-dice GarrMission_CurrencyIcon-Xp
		quest_icon_type = {
						["default"] 	= {"questlegendary", true, 14, 14},
						["item"]		= {"Banker", true, 14, 14},
						["object"]		= {"ChallengeMode-icon-chest", true, 14, 14},
						["monster"]		= {"jailerstower-scenario-skull3", true, 14, 14},
						["reputation"] 	= {"objectivewidget-icon-left", true, 14, 14},
						["log"] 		= {"Callings-Available", true, 14, 14},
						["event"] 		= {"titleprestige-starglow", true, 14, 14},
						["player"] 		= {"trivialquests", true, 14, 14},
						["progressbar"] = {"vignetteloot", false, 14, 14},
						},


-- Extension
	diminish_enable			= true,
	show_range				= false,
	healer_detection		= false,
	cut_scene				= true,
	video_scene				= true,
	fizzle_sound			= true,
	menupanel				= true,
	healer_detection_sound	= "np_healer_sound",
	diminish_type			= "Stun",
	diminish_spam_enable	= false,
	diminish_color			= { [1] = {0/255, 255/255, 0/255, 1},
								[2]	= {255/255, 255/255, 0/255, 1},
								[3]	= {255/255, 0/255, 0/255, 1},},
	creature_icon_enable	= true,
	creature_icon_point		= "LEFT",
	creature_icon_relativePoint	= "BOTTOMLEFT",
	creature_icon_posun_X		= 0,
	creature_icon_posun_Y		= 0,
	creature_new_style		= true,
	creature_boss_enable	= true,
	creature_rare_enable	= true,
	creature_elite_enable	= true,
	creature_other_enable	= false,
	creature_color 			= {	["boss"] = {255/255, 0/255, 0/255, 1},
								["rare"] = {255/255, 255/255, 255/255, 1},
								["elite"] = {255/255, 128/255, 0/255, 1},
								["other"] = {100/255, 100/255, 100/255, 1},},
	creature_size			= {	["boss"] = 16,
								["rare"] = 16,
								["elite"] = 12,
								["other"] = 12,},

	mark_animation			= true,
	mark_healthbar			= false,
	mark_border				= true,
	mark_show				= true,
	mark_type				= 'default',
	mark_size				= 20,
	mark_point				= "RIGHT",
	mark_relativePoint		= "LEFT",
	mark_posun_X			= -2,
	mark_posun_Y			= 0,
	mark_color				= {	[1] = {255/255, 255/255, 0/255, 1},
								[2] = {255/255, 128/255, 0/255, 1},
								[3] = {128/255, 0/255, 255/255, 1},
								[4]	= {0/255, 255/255, 0/255, 1},
								[5]	= {128/255, 128/255, 128/255, 1},
								[6]	= {0/255, 128/255, 255/255, 1},
								[7]	= {255/255, 0/255, 0/255, 1},
								[8] = {255/255, 255/255, 255/255, 1},},
	range_font				= "Avant Garde",
	range_fontsize			= 7,
	range_font_flag			= 'OUTLINE',
	range_only_on_target	= true,
	range_font_color		= {0/255, 255/255, 0/255, 1},
	range_format			= 1,
	range_point				= "BOTTOMLEFT",
	range_relativePoint		= "BOTTOMLEFT",
	range_posun_X			= 1,
	range_posun_Y			= -3,
	
	gcd_showSpellActivity		= false,
	gcd_anim_speed 				= 0.6,
	gcd_anim_duration 			= 5,
	gcd_anim_max 				= 5,
	gcd_anim_icon_size			= 19,
	gcd_anim_icon_scale			= 3,
	gcd_showSpellActivity_spam	= false,
	
	classSpell_ToD				= true,
	classSpell_ToD_color		= {255/255, 128/255, 0/255, 1},
	classSpell_SR				= true,
	classSpell_SR_sound_file 	= "Reflect",
		
-- M+ Setup
	mythic_plus_enable			= true,
	mythic_percent_show			= false,
	mythic_scale				= true,
	mythic_desc					= true,
	mythic_sound				= true,
	mythic_colored				= true,
	mythic_stack_bolster		= true,
	mythic_push_key				= true,
	mythic_NPC_infoPanel		= false,
	mythic_spellCD				= true,
	mythic_spellCD_trackedOnly	= false,
	mythic_spellCD_iconSize		= true,
	mythic_spellCD_CD			= true,
	mythic_spellCD_timer		= true,
	mythic_spellCD_flash		= true,
	mythic_spellCD_flash_time	= 2,
	mythic_spellCD_desaturated	= true,
	mythic_spellCD_border		= true,
	mythic_spellCD_border_color	= {0/255, 255/255, 0/255, 1},
	mythic_spellCD_minTime		= 5,
	mythic_spellCD_alpha_noCD	= 1,
	mythic_spellCD_alpha_onCD	= .5,
	mythic_spellCD_width		= 20,
	mythic_spellCD_height		= 16,
	mythic_spellCD_space		= 4,
	mythic_spellCD_fontsize		= 9,
	mythic_spellCD_font			= "np_font_1",
	mythic_spellCD_font_flag	= 'OUTLINE',
	mythic_spellCD_font_color	= {255/255, 255/255, 0/255, 1},
	
	mythic_text_panel_unlock		= false,
	mythic_auto_mark				= false,
	mythic_auto_mark_groupleader	= true,
	mythic_mark_maxDistance			= 100,
	mythic_target_warning			= true,
	mythic_target_show_all			= true,
	mythic_target_cast_mark			= false,
	mythic_target_cast_sound		= true,
	mythic_target_cast_sound_file	= "Warning",
	mythic_target_say				= false,
	mythic_target_text				= "TARGET ME!",
	mythic_target_flash				= true,
	mythic_target_flash_color		= {255/255, 255/255, 0/255, 1},
	mythic_target_flash_speed		= .12,
	mythic_target_cb_border			= true,
	mythic_target_cb_border_color	= {255/255, 255/255, 0/255, 1},
	mythic_target_maxAlpha			= true,
	mythic_focus_warning			= true,
	mythic_focus_sound_file			= "Burp",
	mythic_focus_flash				= true,
	mythic_focus_flash_color		= {0/255, 255/255, 255/255, 1},
	mythic_focus_flash_speed		= .12,
	mythic_percent_font				= "np_font_1",
	mythic_percent_fontsize			= 7,
	mythic_percent_font_flag		= 'OUTLINE',
	mythic_percent_color			= {0/255, 200/255, 255/255, 1},
	mythic_desc_font				= "np_font_1",
	mythic_desc_fontsize			= 7,
	mythic_desc_font_flag			= 'OUTLINE',
	mythic_desc_color				= {255/255, 255/255, 255/255, 1},
	mythic_kicker_prediction		= true,
	mythic_kicker_bar_show			= true,
	mythic_kicker_mark_show			= true,
	mythic_kicker_mark_groupleader	= false,
	mythic_kicker_info_show			= true,
	mythic_kicker_no_long_CD		= true,

	selfPlayerInfo = {
	['SHAMAN'] = 
	{	[1] = {kickSpell = 'Wind Shear',		enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Wind Shear',		enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Wind Shear',		enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = true, Curse = true, Disease = false, Poison = false}, classSpell = {spellID = nil, ready = false}},},
	['HUNTER'] = 
	{	[1] = {kickSpell = 'Counter Shot',	enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Counter Shot',	enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Muzzle',			enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},},
	['DEATHKNIGHT'] = 
	{	[1] = {kickSpell = 'Mind Freeze',	enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Mind Freeze',	enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Mind Freeze',	enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},},
	['PALADIN'] = 
	{	[1] = {kickSpell = 'Rebuke',		enumPowerType = Enum.PowerType.HolyPower,	powerToken = "HOLY_POWER",	dispelableDebuffTable = {classHasDispell = true, Magic = true, Curse = false, Disease = true, Poison = true}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Rebuke',		enumPowerType = Enum.PowerType.HolyPower,	powerToken = "HOLY_POWER",	dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = false, Disease = true, Poison = true}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Rebuke',		enumPowerType = Enum.PowerType.HolyPower,	powerToken = "HOLY_POWER",	dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = false, Disease = true, Poison = true}, classSpell = {spellID = nil, ready = false}},},
	['ROGUE'] = 
	{	[1] = {kickSpell = 'Kick',			enumPowerType = Enum.PowerType.ComboPoints,	powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Kick',			enumPowerType = Enum.PowerType.ComboPoints,	powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Kick',			enumPowerType = Enum.PowerType.ComboPoints,	powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},},
	['WARRIOR'] = 
	{	[1] = {kickSpell = 'Pummel',		enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = 23920, ready = false}},
		[2] = {kickSpell = 'Pummel',		enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = 23920, ready = false}},
		[3] = {kickSpell = 'Pummel',		enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = 23920, ready = false}},},
	['MONK'] = 
	{	[1] = {kickSpell = 'Spear Hand Strike',	enumPowerType = nil,					powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = false, Disease = true, Poison = true}, classSpell = {spellID = 322109, ready = false}},
		[2] = {kickSpell = nil, 			enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = true, Curse = false, Disease = true, Poison = true}, classSpell = {spellID = 322109, ready = false}},
		[3] = {kickSpell = 'Spear Hand Strike', enumPowerType = Enum.PowerType.Chi,		powerToken = "CHI",			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = false, Disease = true, Poison = true}, classSpell = {spellID = 322109, ready = false}},},	
	['MAGE'] = 
	{	[1] = {kickSpell = 'Counterspell',	enumPowerType = Enum.PowerType.ArcaneCharges, powerToken = "ARCANE_CHARGES", dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Counterspell',	enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Counterspell',	enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = false}, classSpell = {spellID = nil, ready = false}},},	
	['PRIEST'] = 
	{	[1] = {kickSpell = nil,				enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = true, Curse = false, Disease = true, Poison = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = nil,				enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = true, Curse = false, Disease = true, Poison = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Silence',		enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = false, Disease = true, Poison = false}, classSpell = {spellID = nil, ready = false}},},	
	['DRUID'] = 
	{	[1] = {kickSpell = 'Solar Beam',	enumPowerType = Enum.PowerType.ComboPoints, powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = true}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Skull Bash',	enumPowerType = Enum.PowerType.ComboPoints, powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = true}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Skull Bash',	enumPowerType = Enum.PowerType.ComboPoints, powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = true, Magic = false, Curse = true, Disease = false, Poison = true}, classSpell = {spellID = nil, ready = false}},
		[4] = {kickSpell = nil,				enumPowerType = Enum.PowerType.ComboPoints, powerToken = "COMBO_POINTS", dispelableDebuffTable = {classHasDispell = true, Magic = true, Curse = true, Disease = false, Poison = true}, classSpell = {spellID = nil, ready = false}},},		
	['WARLOCK'] = 
	{	[1] = {kickSpell = 'Command Demon', enumPowerType = Enum.PowerType.SoulShards,	powerToken = "SOUL_SHARDS",	dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Command Demon', enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[3] = {kickSpell = 'Command Demon', enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},},
	['DEMONHUNTER'] = 
	{	[1] = {kickSpell = 'Disrupt',		enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},
		[2] = {kickSpell = 'Disrupt',		enumPowerType = nil,						powerToken = nil,			dispelableDebuffTable = {classHasDispell = false}, classSpell = {spellID = nil, ready = false}},},					
	}
},
}

local font_flags_table = {
	[""] = "None",
	["OUTLINE"] = "Outline",
	["THICKOUTLINE"] = "Thick outline",
	["MONOCHROME"] = "Monochrome",
	["OUTLINEMONOCHROME"] = "Outlined monochrome",
}

local sound_channel_table = {
	["Master"] = "Master",
	["SFX"] = "SFX",
	["Ambience"] = "Ambience",
	["Music"] = "Music",
	["Dialog"] = "Dialog",
}

local radial_position_table = {
	[0] = "Disable",
	[1] = "Target Only",
	[2] = "All In Combat",
}

local np_position_table = {
	[0] = "All is UP",
	[1] = "Enemy is DOWN",
	[2] = "All is DOWN",
}

local player_resource_table = {
	["player"] = "on player",
	["target"] = "on target",
	["screen"] = "on screen",
}

local threat_table = {
	[1] = "Tank colors Aene",
	[2] = "Tank colors Bigvont",
}

local castbar_type_table = {
	[1] = "Icon frame in castbar",
	[2] = "Castbar in health bar",
	[3] = "Castbar under health bar",
	[4] = "Castbar in icon frame",
}

local hp_format_table = {
	[0] = "PercHP",
	[1] = "CurrHP - PercHP",
	[2] = "CurrHP",
	[3] = "CurrHP / MaxHP",
}

local range_format_table = {
	[0] = "min",
	[1] = "max",
	[2] = "min - max",
}

local anchor_position_table = {
	["TOP"]			= "TOP",
	["TOPLEFT"]		= "TOPLEFT",
	["TOPRIGHT"]	= "TOPRIGHT",
	["BOTTOM"]		= "BOTTOM",
	["BOTTOMLEFT"]	= "BOTTOMLEFT",
	["BOTTOMRIGHT"]	= "BOTTOMRIGHT",
	["LEFT"]		= "LEFT",
	["RIGHT"]		= "RIGHT",
	["CENTER"]		= "CENTER",
}

local justifyH_position_table = {
	["LEFT"]		= "LEFT",
	["RIGHT"]		= "RIGHT",
	["CENTER"]		= "CENTER",
}

local target_overlap_blend_table = {
	["DISABLE"]		= "DISABLE",		-- opaque texture
	["BLEND"]		= "BLEND",		-- normal painting on top of the background, obeying alpha channels if present in the image (uses alpha)
	["ALPHAKEY"]	= "ALPHAKEY",	-- one-bit alpha
	["ADD"]			= "ADD",			-- additive blend
	["MOD"]			= "MOD",			-- modulating blend
}

--left, right, top, bottom
local texture_flip_table = {
	["TOPLEFT"]		= "TOPLEFT",
	["TOPRIGHT"]	= "TOPRIGHT",
	["BOTTOMLEFT"]	= "BOTTOMLEFT",
	["BOTTOMRIGHT"]	= "BOTTOMRIGHT",
}

local cb_align_table = {
	["LEFT"]	= "LEFT",
	["CENTER"]	= "CENTER",
	["RIGHT"]	= "RIGHT",
}

L.texture_flip_table = {
	["TOPLEFT"]		= {0, 1, 0, 1},
	["TOPRIGHT"]	= {1, 0, 0, 1},
	["BOTTOMLEFT"]	= {0, 1, 1, 0},
	["BOTTOMRIGHT"]	= {1, 0, 1, 0},
	}
	
local diminish_type_table = {
	["Stun"]			= "Stun",
	["Disorient"]		= "Disorient",
	["Incapacitate"]	= "Incapacitate",
	["Root"]			= "Root",
}

local mark_type_table = {
	["default"] = "Default",
	["type_1"] = "Type 1",
	["type_2"] = "Type 2",
}

local class_bar_table = {
	[0] = "Disable",
	[1] = "Class bar (Runes, Chi, ...)",
	[2] = "Party health bars",
	[3] = "Party kick CD bars",
}

function L.Get(key)
	if L.config and L.config[key] ~= nil then
		return L.config[key]
	else
		return L.defaults[key]
	end
end

function L.Set(key, value)
	L.config = L.config or {}
	L.config[key] = value
end

function L.GetFromSavedVariabiles(table)
	local id = table[#table]
	return ( L.config and L.config[id] )
end

function L.GetFromDefaultOrSavedVariabiles(table)
	local id = table[#table]
	return ( L.config and L.config[id] ) or L.defaults[id]
end

setmetatable(L, {
	__call = function(self, input, newValue)
		return L.Get(input) or self[input]
	end,
})

L.options = {
	type = 'group',
	name = "ver : ".._G.GetAddOnMetadata("Nameplates", "Version").."|cff40cc40 Aene|r - E Q U I L I B R I U M BurningBlade EU - I apologize for my English",
	args = {
		basic_page = {
			type = 'group',
			name = "News and help",
			childGroups = "tab",
			inline = false,
			order = 1,
			args = {
				help1 = {
					type = "group",
					order = 1,
					name = "News",
					args = {
						test = {
							type = 'execute',
							name = 'TEST',
							order = 1.1,
							hidden = true,
							func = function()
								MyTest()
							end,
						},
						help1 =  {
							type = "description",
							fontSize = "medium",
							order = 1.2,
							name = "|cff00ff00What is new on last version :|r\n"..L.defaults.profile.newsMessage,
						},
						help2 =  {
							type = "description",
							fontSize = "medium",
							order = 1.4,
							name = "\n\n\n|cff00ff00Thanks :\n",
						},
						help3 =  {
							type = "description",
							fontSize = "medium",
							order = 1.5,
							name = "- |cff0080fficons8.com|r for free icons\n"..
							"- |cff0080ffIshayu|r for code how translate cyrillic names of russian players to the latin\n"..
							"- |cff0080ffKaelten|r and others authors for ACE3\n"..
							"- |cff0080ffdooez and Stanzilla|r for LibCustomGlow\n"..
							"- |cff0080ffMitchnull|r for LibRangeCheck\n"..
							"- |cff0080ffZork|r - from rRaidManager addon i learn how to create side panel\n"..
							"- |cff0080ffMunkDev|r - from Immersion addon i learn how to create config\n"..
							"- |cff0080ffstarshipx|r - from CommentatorTargetFrame addon i learn how to create Spell GCD frame\n"..
							"- |cff0080ffSense - www.twitch.tv/snse |r - Blockable and Reflectable spreadsheet\n",
						},
					},
				},
				help2 = {
					type = "group",
					order = 2,
					name = "Marking",
					args = {
						text =  {
							type = "description",
							order = 1.1,
							fontSize = "small",
							name = "|cff00ff00Instructions :|r\n"..
							"- create macro |cff0080ff/m|r with this command |cff0080ff/np mark|r and move him to action bar, set any free keybind\n"..
							"- in dungeon, target any NPC, right click on setup panel icon |TInterface\\AddOns\\Nameplates\\Media\\icons\\config:20:20|t\n"..
							"- or left click on setup panel icon |TInterface\\AddOns\\Nameplates\\Media\\icons\\config:20:20|t, select |cff00ffffM+ Database > Select instance > Select NPC|r\n"..
							"- set any number to NPC description field for example 431 (if you use any nonumber character this desctiption has been ignored for marking function)\n"..
							"- now click to action bar or use keybind to run macro, addon marked this NPC by distance, first take green mark, second, purple, and last yellow, if exist.\n\n"..
							"- another option is enable auto marking when you start combat |cff00ffff M+ Setup > Enable auto marking|r.\n\n"..
							"|cff00ff00Tips :|r\n"..
							"- if you push any modifier key (shift, ctrl, alt) when you use macro |cff0080ff/np mark|r addon try unmark all existing visible raid marks on units.\n"..
							"- if you hide description field on nameplate |cff00ffff M+ Setup > Description|r marking function still work.",
						},
					},
				},
				help3 = {
					type = "group",
					order = 3,
					name = "Target warning",
					args = {
						text =  {
							type = "description",
							fontSize = "medium",
							order = 1.1,
							name = "|cff00ff00Instructions :|r\n"..
							"- this function help you or ppl in your party avoid any NPC abilites, or decrease dmg taken from this abilites\n\n"..
							"|cff00ff00For example :|r\n"..
							"- second boss in Freehold Captain eudora have ability Powder Shot\n"..
							"- select |cff00ffff M+ Database > Select instance > Freehold > Captai eudora > Select spell > Powder Shot|r\n"..
							"- and enable |cff00ffffTarget|r\n"..
							"- when boss start casting this spell on you, addon warning you (by predefined warnings)\n"..
							"- if you are on low HP, use Shadowmeld, or enable any defensive ability\n"..
							"- for healer or tank addon showed on nameplate name who is target and he have chance using any defensive ability on you\n\n"..
							"|cff00ff00Tips and rules:|r\n"..
							"- spell target functions you must enable in |cff00ffff M+ Setup > Spell warning|r\n"..
							"- this showed you more setup for warnings, setup for play sound, skull mark on you, text spam, flash screen, or color for castbar border animation\n"..
							"- tank still see only target name, others warnings is disabled (spam)\n",
						},
					},
				},
				help4 = {
					type = "group",
					order = 4,
					name = "Kicker prediction",
					args = {
						text =  {
							type = "description",
							fontSize = "medium",
							order = 1.1,
							name = "|cff00ff00Instructions :|r\n"..
							"- show your or party kick cooldown that status bar on unit, by priority who dont have CD or have the smallest CD to kick\n\n"..
							"|cff00ff00For example :|r\n"..
							"- second boss in the Shrine of the Storm Galecaller Faye have spell Slicing Blast, this ability must be kicked by 3 ppl from your party\n"..
							"- select |cff00ffff M+ Database > Select instance > Shrine of the Storm > Galecaller Faye|r\n"..
							"- and enable |cff00ffffKick bar|r for this NPC\n"..
							"- if anyone from your party use kick ability, addon search and show CD next free kicker and mark \n"..
							"this NPC by predfined mark (if this option is enabled)\n\n"..
							"|cff00ff00Tips and rules:|r\n"..
							"- function kicker prediction you must enable in |cff00ffff M+ Setup > Kicker prediction|r\n"..
							"- for more settings go |cff00ffff M+ Setup > Kicker prediction setup|r\n"..
							"- disabling kicker prediction dont affected Party kick CD bars on Resource bar\n\n"..
							"If you need change kick spell, priority or mark color for any class, you must edit file config.lua table L.inperruptSpellTable "..
							"[183752] = {priority = 16, cd = 15, mark = 3}",
						},
					},
				},
				help5 = {
					type = "group",
					order = 5,
					name = "NPC Spell CD",
					args = {
						text =  {
							type = "description",
							fontSize = "medium",
							order = 1.1,
							name = "|cff00ff00What is this :|r\n"..
							"- addon trying calculate a show NPC spells CD on nameplate in M+ Dungeons\n\n"..
							"|cff00ff00For example :|r\n"..
							"- if nameplate is showed addon show all knowed spells this NPC under nameplate\n"..
							"- if spell CD is unknown (nil) shadow border is white\n"..
							"- if spell is not on CD and is possible to NPC use him, shadow border is green (default)\n"..
							"- if spell is on CD, spell icon is desaturated (default) and you see timer or spell CD clock\n"..
							"\n\n"..
							"|cff00ff00Tips and rules:|r\n"..
							"- you have full access to settings all in |cff00ffff M+ Setup > NPC Spell CD|r\n"..
							"- for enable taracked any specific cast goto |cff00ffff M+ Database > Select Instance > Select NPC > Select spell|r and setup TRACKED, YOUR PREDICTED TIME or LOCK TIME\n"..
							"- TRACKED spell is still showed\n"..
							"- if time is locked by LOCK TIME addon dont change this value in prediction\n"..
							"- exist upredictable spells, where have any internal blizzard CD but if you interrupt this spell, NPC start cast him again and again, ... for this spells set your correct time to PREDICTED TIME and lock this value by LOCK TIME",
						},
					},
				},
				help6 = {
					type = "group",
					order = 6,
					name = "M+ Database",
					args = {
						text =  {
							type = "description",
							fontSize = "medium",
							order = 1.1,
							name = "|cff00ff00Instructions :|r\n"..
							"- M+ Databaze is here to allow you to adapt the nameplates in M+ instances according to your ideas as much as possible.\n\n"..
							"|cff00ff00How to work :|r\n"..
							"- if M+ Database is empty when wow was started (was completely deleted, or when the addon was used for the first time) my default version is loaded\n"..
							"- in M+ Database you have the possibility to rearrange anything so that it suits and your game style, or your group setup (kicks, marking, ...)\n"..
							"- if you want to return to the default Database for any reason, use the button below |cffFF0000Reset to Default|r\n"..
							"- M+ instances of the current season type are automatically created and recorded to the M+ Database after entering the given dungeon\n"..
							"- you can also add other types (for example raid, Torghast or old dungeons), so that when you are in a given instance, you will get a button in the M+ Database section ADD INSTANCE\n"..
							"- for quick setup and adjustment in saved dungeons, try turning on the function in |cff00ffffM+ Setup > NPC infoPanel|r how it works you can try down with the button |cffFFFF32SHOW infoPanel|r"..
							"\n\n\n"..
							"|cff00ff00For all zones :|r\n"..
							"- select any enemy unit that your target, in menuPanel left klick on |TInterface\\AddOns\\Nameplates\\Media\\icons\\target:16:16|t,"..
							" this step add your target to M+ Database > For all zones, another left klick remove him from M+ Database\n"..
							"- right klick on |TInterface\\AddOns\\Nameplates\\Media\\icons\\target:20:20|t open config for this unit\n"..
							"- this reskin is superior for all another changes on nameplates\n\n"..
							"|cff00ff00Tips :|r\n"..
							"I use it for spawn Explosives, Manifestation of Pride or when i searched any NPC in open world.\n\n\n", 
						},
						reset = {
							type = 'execute',
							name = '|cffFF0000Reset to Default|r',
							desc = 'Reset M+ Database to defaults values.',
							order = 1.4,
							func = function()
								StaticPopupDialogs["RESET_DUNGEONS_DATA"] = {
									text = "You still want to reset all data in |cff0080ffM+ Database|r to default?",
									button1 = "Yes",
									button2 = "No",
									OnAccept = function()
										MythicNPCData = nil
										ReloadUI()
									end,
									timeout = 0,
									whileDead = true,
									showAlert = true,
									exclusive = true,
									hideOnEscape = true,
									preferredIndex = 3,
								}
								StaticPopup_Show("RESET_DUNGEONS_DATA")
							end,
						},
						test = {
							type = 'execute',
							name = 'SHOW infoPanel',
							desc = 'Warning this is real NPC from M+ Database',
							order = 1.5,
							func = function()
								if myNPCInfoPanelFrameBase:IsShown() then
									L.options.args.basic_page.args.help6.args.test.name = "SHOW infoPanel"
									npcInfoPanelMixin:HideNPCInfoPanel()
								else
									L.options.args.basic_page.args.help6.args.test.name = "HIDE infoPanel"
									npcInfoPanelMixin:ShowNPCInfoPanel(164558, 377)
								end
							end,
						},
					},
				},
			},
		},
		general = {
			type = 'group',
			name = 'General setup',
			order = 2,
			args = {
				nameplateGlobalScale = {
					type = 'range',
					name = 'Global scale',
					desc = 'Increase or decrease scale for all nameplates. (no for self nameplate). I not recommend changing this setting',
					min = 0.1,
					max = 2,
					step = 0.01,
					isPercent = true,
					order = 1.1,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.nameplateGlobalScale = val
						SetCVar("nameplateGlobalScale", val);
					end,
				},
				nameplate_alpha = {
					type = 'range',
					name = 'Global alpha',
					desc = 'Set alpha for all nameplates (without target and players)',
					min = 0,
					max = 1,
					step = 0.05,
					isPercent = true,
					order = 1.2,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						if L.config.nameplate_alpha ~= val then
							L.config.nameplate_alpha = val
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
						end
					end,
				},
				nameplateOccludedAlphaMult = {
					type = 'range',
					name = 'OccludedAlphaMult',
					desc = 'Set alpha for nameplates behind any object.',
					min = 0,
					max = 1,
					step = .01,
					isPercent = true,
					order = 1.3,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						SetCVar("nameplateOccludedAlphaMult", val)
						L.config.nameplateOccludedAlphaMult = val
					end,
				},
				nameplateMaxDistance = {
					type = 'range',
					name = 'Set max distance',
					desc = 'Max distance for showing nameplate. Blocked by blizzard from 8.3.5',
					min = 0,
					max = 100,
					step = 1,
					order = 1.4,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						SetCVar("nameplateMaxDistance", val)
						L.config.nameplateMaxDistance = val
					end,
				},
				nameplateTargetRadialPosition  = {
					type = 'select',
					name = 'Radial position',
					desc = 'When target is off screen, position its nameplate radially around sides and bottom.',
					order = 1.5,
					style = 'dropdown',
					values = radial_position_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						SetCVar("nameplateTargetRadialPosition", val)
						L.config.nameplateTargetRadialPosition = val
					end,
				},
				nameplateOtherAtBase  = {
					type = 'select',
					name = 'Nameplate position',
					desc = 'Position other nameplates at the base, rather than overhead',
					order = 1.6,
					style = 'dropdown',
					values = np_position_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						SetCVar("nameplateOtherAtBase", val)
						L.config.nameplateOtherAtBase = val
					end,
				},
				sound_channel  = {
					type = 'select',
					name = 'Sound channel',
					desc = 'Select channel for playing all sounds used by this addon.',
					order = 1.9,
					style = 'dropdown',
					values = sound_channel_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.sound_channel  = val
					end,
				},
				large_nameplate_setup = {
					type = 'group',
					name = 'Boss nameplate setup',
					inline = true,
					order = 3,
					args = {
						nameplateLargerScale = {
							type = 'range',
							name = 'Boss scale',
							desc = 'Increase or decrease scale for large (boss) nameplates.',
							min = 0.1,
							max = 2,
							step = 0.01,
							isPercent = true,
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.nameplateLargerScale = val
								SetCVar("nameplateLargerScale", val);
							end,
						},
						nameplateLargeTopInset = {
							type = 'range',
							name = 'Top inset',
							desc = 'The inset from the top (in screen percent) that the large nameplate is clamped to.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 1.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateLargeTopInset", val)
								L.config.nameplateLargeTopInset = val
							end,
						},
						nameplateLargeBottomInset = {
							type = 'range',
							name = 'Bottom inset',
							desc = 'The inset from the bottom (in screen percent) that the large nameplate is clamped to.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 1.3,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateLargeBottomInset", val)
								L.config.nameplateLargeBottomInset = val
							end,
						},
					},
				},
				other_nameplate_setup = {
					type = 'group',
					name = 'Others (non boss) nameplate setup',
					inline = true,
					order = 4,
					args = {
						nameplateOtherTopInset = {
							type = 'range',
							name = 'Top inset',
							desc = 'The inset from the top (in screen percent) that the non-self nameplates are clamped to.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateOtherTopInset", val)
								L.config.nameplateOtherTopInset = val
							end,
						},
						nameplateOtherBottomInset = {
							type = 'range',
							name = 'Bottom inset',
							desc = 'The inset from the bottom (in screen percent) that the non-self nameplates are clamped to.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 1.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateOtherBottomInset", val)
								L.config.nameplateOtherBottomInset = val
							end,
						},
					},
				},
				widget_setup = {
					type = 'group',
					name = 'Widgets setup',
					inline = true,
					order = 6,
					args = {
						widget_show = {
							type = 'toggle',
							name = 'Enable widgets',
							desc = 'Show blizzards widgets on nameplates. (recommend /reload)',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.widget_show = val
								namePlateMixin:UpdateNamePlateByOptions("widget")
							end,
						},
						widget_scale = {
							type = 'range',
							name = 'Scale',
							desc = 'Set this scale for all widgets. (recommend /reload)',
							min = .1,
							max = 1,
							step = .01,
							order = 1.2,
							disabled = function() return not L('widget_show') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.widget_scale = val
								namePlateMixin:UpdateNamePlateByOptions("widget")
							end,
						},
					},
				},
				overlap_setup = {
					type = 'group',
					name = 'Overlaping setup',
					inline = true,
					order = 7,
					args = {
						nameplateMotion = {
							type = 'toggle',
							name = 'Enable overlapping',
							desc = 'Setup overlapping (true) or stacking (false) nameplates.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMotion", val)
								L.config.nameplateMotion = val
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "small",
						},
						nameplateMotionSpeed = {
							type = 'range',
							name = 'nameplateMotionSpeed',
							desc = 'Controls the rate at which nameplate animates into their target locations.',
							min = 0,
							max = 0.3,
							step = .005,
							order = 2.1,
							disabled = function() return not L('nameplateMotion') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMotionSpeed", val)
								L.config.nameplateMotionSpeed = val
							end,
						},
						nameplateOverlapV = {
							type = 'range',
							name = 'nameplateOverlapV',
							desc = 'Percentage amount for vertical overlap of nameplates',
							min = 0,
							max = 1,
							step = .01,
							order = 2.2,
							disabled = function() return not L('nameplateMotion') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateOverlapV", val)
								L.config.nameplateOverlapV = val
							end,
						},
						nameplateOverlapH = {
							type = 'range',
							name = 'nameplateOverlapH',
							desc = 'Percentage amount for horizontal overlap of nameplates',
							min = 0,
							max = 1,
							step = .01,
							order = 2.3,
							disabled = function() return not L('nameplateMotion') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateOverlapH", val)
								L.config.nameplateOverlapH = val
							end,
						},
					},
				},
				extended = {
					type = 'group',
					name = 'Extended CVars setup',
					inline = true,
					order = 8,
					args = {
						nameplateMinAlpha = {
							type = 'range',
							name = 'nameplateMinAlpha',
							desc = 'The minimum alpha of nameplates.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 3.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMinAlpha", val)
								L.config.nameplateMinAlpha = val
							end,
						},
						nameplateMinAlphaDistance = {
							type = 'range',
							name = 'nameplateMinAlphaDistance',
							desc = 'The distance from the max distance that nameplates will reach their minimum alpha',
							min = 0,
							max = 100,
							step = 1,
							order = 3.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMinAlphaDistance", val)
								L.config.nameplateMinAlphaDistance = val
							end,
						},
						spacer33 =  {
							type = "description", order = 3.3, name = " ", fontSize = "medium",
						},
						nameplateMaxAlpha = {
							type = 'range',
							name = 'nameplateMaxAlpha',
							desc = 'The max alpha of nameplates.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 4.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMaxAlpha", val)
								L.config.nameplateMaxAlpha = val
							end,
						},
						nameplateMaxAlphaDistance = {
							type = 'range',
							name = 'nameplateMaxAlphaDistance',
							desc = 'The distance from the camera that nameplates will reach their maximum alpha.',
							min = 0,
							max = 100,
							step = 1,
							order = 4.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMaxAlphaDistance", val)
								L.config.nameplateMaxAlphaDistance = val
							end,
						},
						nameplateTargetBehindMaxDistance = {
							type = 'range',
							name = 'nameplateTargetBehindMaxDistance',
							desc = 'The max distance to show the target nameplate when the target is behind the camera.',
							min = 0,
							max = 100,
							step = 1,
							order = 4.3,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateTargetBehindMaxDistance", val)
								L.config.nameplateTargetBehindMaxDistance = val
							end,
						},
						spacer44 = {
							type = "description", order = 4.4, name = " ", fontSize = "medium",
						},
						nameplateMaxScale = {
							type = 'range',
							name = 'nameplateMaxScale',
							desc = 'The max scale of nameplates.',
							min = 0,
							max = 2,
							step = 0.05,
							isPercent = true,
							order = 5.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMaxScale", val)
								L.config.nameplateMaxScale = val
							end,
						},
						nameplateMaxScaleDistance = {
							type = 'range',
							name = 'nameplateMaxScaleDistance',
							desc = 'The distance from the camera that nameplates will reach their maximum scale.',
							min = 0,
							max = 100,
							step = 1,
							order = 5.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMaxScaleDistance", val)
								L.config.nameplateMaxScaleDistance = val
							end,
						},
						spacer53 =  {
							type = "description", order = 5.3, name = " ", fontSize = "medium",
						},
						nameplateMinScale = {
							type = 'range',
							name = 'nameplateMinScale',
							desc = 'The minimum scale of nameplates.',
							min = 0.05,
							max = 2,
							step = 0.05,
							isPercent = true,
							order = 6.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMinScale", val)
								L.config.nameplateMinScale = val
							end,
						},
						nameplateMinScaleDistance = {
							type = 'range',
							name = 'nameplateMinScaleDistance',
							desc = 'The distance from the max distance that nameplates will reach their minimum scale.',
							min = 0,
							max = 100,
							step = 1,
							order = 6.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								SetCVar("nameplateMinScaleDistance", val)
								L.config.nameplateMinScaleDistance = val
							end,
						},
						spacer63 =  {
							type = "description", order = 6.3, name = " ", fontSize = "medium",
						},
					},
				},
			},
		},
		name_setup = {
			type = 'group',
			name = 'Name setup',
			order = 3,
			args = {
				name_translate = {
					type = 'toggle',
					name = 'Translate russian name',
					desc = 'Translate russian name from cyrilic to latin. Translate name begin with this mark -!-',
					order = 1.1,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.name_translate = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				class_color_friendly = {
					type = 'toggle',
					name = 'Class color on friendly',
					desc = 'Use class name color on friendly player nameplate by class.',
					order = 1.2,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.class_color_friendly = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				class_color_enemy = {
					type = 'toggle',
					name = 'Class color on enemy',
					desc = 'Use class name color on enemy player nameplate by class',
					order = 1.3,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.class_color_enemy = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				show_honor_level = {
					type = 'toggle',
					name = 'Honor level icon',
					desc = 'Show honor level that icon on players name. Only in PVP mode.',
					order = 2.1,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.show_honor_level = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				name_short = {
					type = 'toggle',
					name = 'Change length name',
					desc = 'Change max name size for all nameplates.',
					order = 2.2,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.name_short = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				name_short_lenght = {
					type = 'range',
					name = 'Max. lenght name',
					desc = 'Set number for max unit name size.',
					min = 15,
					max = 50,
					step = 1,
					order = 2.3,
					disabled = function() return not L('name_short') end,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						if L.config.name_short_lenght ~= val then
							L.config.name_short_lenght = val
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
						end
					end,
				},
				name_point = {
					type = 'select',
					name = 'Point',
					style = 'dropdown',
					order = 3.1,
					values = anchor_position_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.name_point  = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				name_relativePoint = {
					type = 'select',
					name = 'relativePoint',
					style = 'dropdown',
					order = 3.2,
					values = anchor_position_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.name_relativePoint  = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				name_text_alpha_hb = {
					type = 'range',
					name = 'Name alpha with HB',
					desc = 'Name alpha if health bar is showed',
					min = 0,
					max = 1,
					step = .05,
					isPercent = true,
					order = 3.3,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						if L.config.name_text_alpha_hb ~= val then
							L.config.name_text_alpha_hb = val
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
						end
					end,
				},
				name_posun_X = {
					type = 'range',
					name = 'position X',
					desc = 'Setup X position for raidMarks.',
					min = -30,
					max = 30,
					step = 1,
					order = 4.1,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.name_posun_X = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				name_posun_Y = {
					type = 'range',
					name = 'position Y',
					desc = 'Setup Y position for raidMarks.',
					min = -30,
					max = 30,
					step = 1,
					order = 4.2,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.name_posun_Y = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end,
				},
				name_text_alpha_nohb = {
					type = 'range',
					name = 'Name alpha without HB',
					desc = 'Name alpha if health bar is not showed',
					min = 0,
					max = 1,
					step = .05,
					isPercent = true,
					order = 4.3,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						if L.config.name_text_alpha_nohb ~= val then
							L.config.name_text_alpha_nohb = val
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
						end
					end,
				},				
				name_font_setup = {
					type = 'group',
					name = 'Name font setup',
					inline = true,
					order = 6,
					args = {
						name_font_npc = {
							type = "select",
							name = 'Name font for NPC',
							dialogControl = 'LSM30_Font',
							order = 1.1,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.name_font_npc = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						name_fontsize_npc = {
							type = 'range',
							name = 'Font size for NPC',
							min = 5,
							max = 20,
							step = 1,
							order = 1.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								if L.config.name_fontsize_npc ~= val then
									L.config.name_fontsize_npc = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
									namePlateMixin:SetBaseNamePlateSize()
								end
							end,
						},
						name_font_flag_npc  = {
							type = 'select',
							name = 'Font flags for NPC',
							order = 1.3,
							style = 'dropdown',
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.name_font_flag_npc = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						name_font_players = {
							type = "select",
							name = 'Name font for players',
							dialogControl = 'LSM30_Font',
							order = 2.1,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.name_font_players = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						name_fontsize_players = {
							type = 'range',
							name = 'Font size for players',
							min = 5,
							max = 20,
							step = 1,
							order = 2.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								if L.config.name_fontsize_players ~= val then
									L.config.name_fontsize_players = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
									namePlateMixin:SetBaseNamePlateSize()
								end
							end,
						},
						name_font_flag_players  = {
							type = 'select',
							name = 'Font flags for players',
							order = 2.3,
							style = 'dropdown',
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.name_font_flag_players  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						name_font_target = {
							type = "select",
							name = 'Name font for target',
							dialogControl = 'LSM30_Font',
							order = 3.1,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.name_font_target = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						name_fontsize_target = {
							type = 'range',
							name = 'Font size for target',
							min = 5,
							max = 20,
							step = 1,
							order = 3.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								if L.config.name_fontsize_target ~= val then
									L.config.name_fontsize_target = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						name_font_flag_target  = {
							type = 'select',
							name = 'Font flags for target',
							order = 3.3,
							style = 'dropdown',
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.name_font_flag_target  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
					},
				},
			},
		},
		health_power_setup = {
			type = 'group',
			name = "Health and power bar",
			childGroups = "tab",
			inline = false,
			order = 4,
			args = {
				general = {
					type = "group",
					order = 1,
					name = "General",
					args = {
						healthbar_smooth = {
							type = 'toggle',
							name = 'Health bar smooth',
							desc = 'Enable smooth for health bar.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.healthbar_smooth = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						powerbar_smooth = {
							type = 'toggle',
							name = 'Power bar smooth',
							desc = 'Enable smooth for power bar.',
							order = 1.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.powerbar_smooth = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						hp_enable = {
							type = 'toggle',
							name = 'Health points',
							desc = 'Show health points on health bar.',
							order = 1.3,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.hp_enable = val
								namePlateMixin:UpdateNamePlateByOptions("hp_enable")
								ButtonHP:SetButtonState(L.config.hp_enable and "PUSHED" or "NORMAL", L.config.hp_enable and true or false)
							end,
						},
						--[[baseNamePlateWidth = {
							type = 'range',
							name = 'Clickable area width',
							desc = 'Set width for mouse click active area for all nameplates. Plz dont change this value. The best value for this option is health bar width.',
							min = 50,
							max = 150,
							step = 1,
							order = 2.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.baseNamePlateWidth = val
								namePlateMixin:SetBaseNamePlateSize()
							end,
						},]]--
						baseNamePlateHeight = {
							type = 'range',
							name = 'Clickable area height',
							desc = 'Increase height for mouse click active area for friendly and enemy nameplates.  Plz dont change this value. The best value for this option 10.',
							min = 0,
							max = 50,
							step = 1,
							order = 2.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.baseNamePlateHeight = val
								namePlateMixin:SetBaseNamePlateSize()
							end,
						},						
						healthbar_bg_offset = {
							type = 'range',
							name = 'Shadow border offset',
							desc = 'Size for shadow border.',
							min = 1,
							max = 15,
							step = 1,
							order = 2.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.healthbar_bg_offset = val
								namePlateMixin:UpdateNamePlateByOptions("bars")
							end,
						},
						hp_font_setup = {
							type = 'group',
							name = 'Health points font setup',
							inline = true,
							order = 4,
							hidden = function() return not L('hp_enable') end,
							args = {
								hp_font = {
									type = "select",
									name = 'Health points font',
									desc = 'Select font for health points.',
									dialogControl = 'LSM30_Font',
									order = 1.1,
									values = AceGUIWidgetLSMlists.font,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_font = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_fontsize = {
									type = 'range',
									name = 'Font size',
									desc = 'Setup font size for health points.',
									min = 5,
									max = 30,
									step = 1,
									order = 1.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_fontsize = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_font_flag  = {
									type = 'select',
									name = 'Font flags',
									desc = 'Select font flag for health points.',
									order = 1.3,
									style = 'dropdown',
									values = font_flags_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_font_flag  = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_font_color = {
									type = "color",
									name = "Color",
									desc = 'Select color for health points.',
									width = "half",
									hasAlpha = true,
									order = 1.4,
									get = function() return unpack(L.config.hp_font_color) end,
									set = function(_,...)
										L.config.hp_font_color = {...}
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_point = {
									type = 'select',
									name = 'Point',
									style = 'dropdown',
									order = 2.1,
									values = anchor_position_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_point  = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_relativePoint = {
									type = 'select',
									name = 'relativePoint',
									style = 'dropdown',
									order = 2.2,
									values = anchor_position_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_relativePoint  = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_format  = {
									type = 'select',
									name = 'Format',
									desc = 'Select showed format for health points.',
									style = 'dropdown',
									order = 2.3,
									values = hp_format_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_format  = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_posun_X = {
									type = 'range',
									name = 'HP position X',
									desc = 'Setup X position for healht points.',
									min = -20,
									max = 20,
									step = 1,
									order = 3.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_posun_X = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
								hp_posun_Y = {
									type = 'range',
									name = 'HP position Y',
									desc = 'Setup Y position for healht points.',
									min = -20,
									max = 20,
									step = 1,
									order = 3.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.hp_posun_Y = val
										namePlateMixin:UpdateNamePlateByOptions("hp_enable")
									end,
								},
							},
						},
					},
				},
				self = {
					type = "group",
					order = 2,
					name = "Self",
					args = {
						self_bar_setup = {
							type = 'group',
							name = 'Setup player personal bar',
							inline = true,
							order = 2,
							args = {
								nameplatepersonalShowAlways = {
									type = 'toggle',
									name = 'Show Always',
									desc = 'Show always personal(player) nameplate.'..onlyOutOfCombat,
									order = 1.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplatePersonalShowAlways", val and 1 or 0)
										--SetCVar("nameplateShowSelf", val and 1 or 0)
										L.config.nameplatepersonalShowAlways = val
									end,
								},
								nameplatePersonalShowInCombat = {
									type = 'toggle',
									name = 'Show in combat',
									desc = 'Show personal(player) nameplate in combat.'..onlyOutOfCombat,
									order = 1.2,
									get = L.GetFromSavedVariabiles,
									disabled = function() return L('nameplatepersonalShowAlways') end,
									set = function(_, val)
										SetCVar("nameplatePersonalShowInCombat", val and 1 or 0)
										L.config.nameplatePersonalShowInCombat = val
									end,
								},
								nameplatePersonalShowWithTarget = {
									type = 'toggle',
									name = 'Show with target',
									desc = 'Show personal(player) nameplate when player have target.'..onlyOutOfCombat,
									order = 1.3,
									get = L.GetFromSavedVariabiles,
									disabled = function() return L('nameplatepersonalShowAlways') end,
									set = function(_, val)
										SetCVar("nameplatePersonalShowWithTarget", val and 1 or 0)
										L.config.nameplatePersonalShowWithTarget = val
									end,
								},
								self_healthbar_shadow = {
									type = 'toggle',
									name = 'Shadow',
									desc = 'Enable shadow border for player health bar.',
									order = 1.5,
									get = function() return L.config.healthbar_shadow["player"] end,
									set = function(_, val)
										L.config.healthbar_shadow["player"] = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								healthbar_shadow_color = {
									type = "color",
									name = "Color",
									desc = 'Select color for shadow border on health bar.',
									hasAlpha = true,
									width = 'half',
									order = 1.6,
									disabled = function() return not L.config.healthbar_shadow["player"] end,
									get = function() return unpack(L.config.healthbar_shadow_color["player"]) end,
									set = function(_,...)
										L.config.healthbar_shadow_color["player"] = {...}
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								healthbar_spark = {
									type = 'toggle',
									name = 'Spark',
									desc = 'Show spark on healtth bar.',
									width = 'half',
									order = 1.7,
									get = function() return L.config.healthbar_spark["player"] end,
									set = function(_, val)
										L.config.healthbar_spark["player"] = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								selfClickThrough = {
									type = 'toggle',
									name = 'selfClickThrough',
									desc = 'Disable mouse on self nameplate (personal)',
									order = 1.8,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										C_NamePlate.SetNamePlateSelfClickThrough(val)
										L.config.selfClickThrough = val
									end,
								},
								spacer19 =  {
									type = "description", order = 1.9, name = " ", fontSize = "medium",
								},
								self_healthbar_width = {
									type = 'range',
									name = 'Health bar width',
									desc = 'Player health bar width',
									min = 20,
									max = 200,
									step = 1,
									order = 2.1,
									get = function() return L.config.healthbar_width["player"] end,
									set = function(_, val)
										L.config.healthbar_width["player"] = val
										namePlateMixin:UpdateSelfNamePlate()
										namePlateMixin:SetBaseNamePlateSize()
									end,
								},
								self_healthbar_height = {
									type = 'range',
									name = 'Health bar height',
									desc = 'Player health bar height',
									min = 2,
									max = 20,
									step = 1,
									order = 2.2,
									get = function() return L.config.healthbar_height["player"] end,
									set = function(_, val)
										L.config.healthbar_height["player"] = val
										namePlateMixin:UpdateSelfNamePlate()
										namePlateMixin:SetBaseNamePlateSize()
									end,
								},
								spacer29 =  {
									type = "description", order = 2.9, name = " ", fontSize = "medium",
								},
								self_healthbar_texture = {
									type = "select",
									name = 'Health bar texture',
									desc = 'Player health bar texture',
									dialogControl = 'LSM30_Statusbar',
									order = 3.1,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_healthbar_texture = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								self_healthbar_bg_texture = {
									type = "select",
									name = 'Health bar BG texture',
									desc = 'Self player health bar background texture',
									dialogControl = 'LSM30_Statusbar',
									order = 3.2,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_healthbar_bg_texture = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								self_healthbar_bg_color = {
									type = "color",
									name = "BG color",
									order = 3.3,
									hasAlpha = true,
									get = function() return unpack(L.config.self_healthbar_bg_color); end,
									set = function(_,...)
										L.config.self_healthbar_bg_color = {...};
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								self_powerbar_width = {
									type = 'range',
									name = 'Power bar width',
									desc = 'Player power bar width',
									min = 20,
									max = 200,
									step = 1,
									order = 3.4,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_powerbar_width = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								self_powerbar_height = {
									type = 'range',
									name = 'Power bar height',
									desc = 'Player power bar height',
									min = 2,
									max = 20,
									step = 1,
									order = 3.5,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_powerbar_height = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
								spacer39 =  {
									type = "description", order = 3.9, name = " ", fontSize = "medium",
								},
								self_powerbar_texture = {
									type = "select",
									name = 'Power bar texture',
									dialogControl = 'LSM30_Statusbar',
									order = 4.1,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_powerbar_texture = val
										namePlateMixin:UpdateSelfNamePlate()
									end,
								},
							},
						},
						self_bar_flash_setup = {
							type = 'group',
							name = 'Setup warning by health points',
							inline = true,
							order = 3,
							args = {
								self_unitframe_warning = {
									type = 'range',
									name = 'Value',
									desc = 'Self player health points value for enable warning. Set to 0 disable this warning function.',
									min = 0,
									max = 0.9,
									step = .05,
									isPercent = true,
									order = 1.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_unitframe_warning = val
									end,
								},
								self_unitframe_scale = {
									type = 'range',
									name = 'Scale',
									desc = 'Increase self nameplate size if HP is under %',
									min = 1,
									max = 2,
									step = .05,
									isPercent = true,
									order = 1.2,
									disabled = function() return not (L.config.self_unitframe_warning > 0 and true or false) end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.self_unitframe_scale = val
									end,
								},
								self_unitframe_flash = {
									type = 'toggle',
									name = 'Enable flash',
									desc = 'Flash self nameplate if health points is under setuped value',
									order = 1.3,
									disabled = function() return not (L.config.self_unitframe_warning > 0 and true or false) end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.self_unitframe_flash = val
									end,
								},
							},
						},
						self_bar_ext_setup = {
							type = 'group',
							name = 'Extendend setup for self nameplate.',
							inline = true,
							order = 5,
							args = {
								nameplateSelfScale = {
									type = 'range',
									name = 'Self nameplate scale',
									desc = 'Self nameplate scale.',
									min = 0.5,
									max = 2,
									step = .1,
									isPercent = true,
									order = 7.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateSelfScale", val)
										L.config.nameplateSelfScale = val
									end,
								},
								nameplateSelfAlpha = {
									type = 'range',
									name = 'Self nameplate alpha',
									desc = 'Self nameplate alpha',
									min = 0,
									max = 1,
									step = .05,
									isPercent = true,
									order = 7.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateSelfAlpha", val)
										L.config.nameplateSelfAlpha = val
									end,
								},
								spacer73 =  {
									type = "description", order = 7.3, name = " ", fontSize = "medium",
								},
								nameplateSelfTopInset = {
									type = 'range',
									name = 'Top Inset',
									desc = 'The inset from the top (in screen percent) that the self nameplate is clamped to.',
									min = 0,
									max = 1,
									step = .01,
									isPercent = true,
									order = 8.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateSelfTopInset", val)
										L.config.nameplateSelfTopInset = val
									end,
								},
								nameplateSelfBottomInset = {
									type = 'range',
									name = 'Bottom Inset',
									desc = 'The inset from the bottom (in screen percent) that the self nameplate is clamped to.',
									min = 0,
									max = 1,
									step = .01,
									isPercent = true,
									order = 8.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateSelfBottomInset", val)
										L.config.nameplateSelfBottomInset = val
									end,
								},
								spacer83 =  {
									type = "description", order = 8.3, name = " ", fontSize = "medium",
								},
								nameplatePersonalHideDelayAlpha = {
									type = 'range',
									name = 'Alpha Delay',
									desc = 'Determines the alpha of the personal nameplate after no visibility conditions are met (during the period of time specified by NameplatePersonalHideDelaySeconds).',
									min = 0,
									max = 1,
									step = .01,
									order = 8.4,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplatePersonalHideDelayAlpha", val)
										L.config.nameplatePersonalHideDelayAlpha = val
									end,
								},
								nameplatePersonalHideDelaySeconds = {
									type = 'range',
									name = 'Hide Delay',
									desc = 'Determines the length of time in seconds that the personal nameplate will be visible after no visibility conditions are met.',
									min = 0.1,
									max = 10,
									step = .1,
									order = 8.5,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplatePersonalHideDelaySeconds", val)
										L.config.nameplatePersonalHideDelaySeconds = val
									end,
								},
							},
						},
					},
				},
				enemy = {
					type = "group",
					order = 3,
					name = "Enemy",
					args = {
						hb_bar_setup = {
							type = 'group',
							name = 'Setup health bar',
							inline = true,
							order = 1,
							args = {
								healthbar_alltime = {
									type = 'toggle',
									name = 'Always show health bar',
									desc = 'Show health bars all time.',
									order = 1.1,
									get = function() return L.config.healthbar_show["enemy"] end,
									set = function(_, val)
										L.config.healthbar_show["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								spacer19 =  {
									type = "description", order = 1.9, name = " ", fontSize = "medium",
								},
								healthbar_shadow = {
									type = 'toggle',
									name = 'Shadow',
									desc = 'Show shadow border all time on all health bars.',
									width = 'half',
									order = 2.1,
									get = function() return L.config.healthbar_shadow["enemy"] end,
									set = function(_, val)
										L.config.healthbar_shadow["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								healthbar_shadow_color = {
									type = "color",
									name = "Color",
									desc = 'Select color for shadow border on health bar.',
									hasAlpha = true,
									width = 'half',
									order = 2.2,
									disabled = function() return not L.config.healthbar_shadow["enemy"] end,
									get = function() return unpack(L.config.healthbar_shadow_color["enemy"]) end,
									set = function(_,...)
										L.config.healthbar_shadow_color["enemy"] = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								healthbar_class_color = {
									type = 'toggle',
									name = 'Class color',
									desc = 'Use class color for enemy unit health bar.',
									order = 2.3,
									get = function() return L.config.healthbar_class_color["enemy"] end,
									set = function(_, val)
										L.config.healthbar_class_color["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_spark = {
									type = 'toggle',
									name = 'Spark',
									desc = 'Show spark on healtth bar.',
									width = 'half',
									order = 2.4,
									get = function() return L.config.healthbar_spark["enemy"] end,
									set = function(_, val)
										L.config.healthbar_spark["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								enemyClickThrough = {
									type = 'toggle',
									name = 'enemyClickThrough',
									desc = 'Disable mouse on enemy nameplate. You must /reloadui.',
									order = 2.5,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										C_NamePlate.SetNamePlateEnemyClickThrough(val)
										L.config.enemyClickThrough = val
									end,
								},
								healthbar_border_top = {
									type = 'toggle',
									name = 'TOP',
									desc = 'Use class color on border for enemy unit health bar.',
									width = 'half',
									order = 2.6,
									get = function() return L.config.healthbar_border_top["enemy"] end,
									set = function(_, val)
										L.config.healthbar_border_top["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_border_bottom = {
									type = 'toggle',
									name = 'BOTTOM',
									desc = 'Use class color on border for enemy unit health bar.',
									width = 'half',
									order = 2.7,
									get = function() return L.config.healthbar_border_bottom["enemy"] end,
									set = function(_, val)
										L.config.healthbar_border_bottom["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_border_left = {
									type = 'toggle',
									name = 'LEFT',
									desc = 'Use class color on border for enemy unit health bar.',
									width = 'half',
									order = 2.8,
									get = function() return L.config.healthbar_border_left["enemy"] end,
									set = function(_, val)
										L.config.healthbar_border_left["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_border_right = {
									type = 'toggle',
									name = 'RIGHT',
									desc = 'Use class color on border for enemy unit health bar.',
									width = 'half',
									order = 2.9,
									get = function() return L.config.healthbar_border_right["enemy"] end,
									set = function(_, val)
										L.config.healthbar_border_right["enemy"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								spacer30 =  {
									type = "description", order = 3.0, name = " ", fontSize = "medium",
								},
								healthbar_texture = {
									type = "select",
									name = 'Health bar texture',
									desc = 'Select health bar texture for all nameplate.',
									dialogControl = 'LSM30_Statusbar',
									order = 3.1,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = function() return L.config.healthbar_texture["enemy"] end,
									set = function(_, val)
										if L.config.healthbar_texture["enemy"] ~= val then
											L.config.healthbar_texture["enemy"] = val
											namePlateMixin:UpdateNamePlateByOptions("bars")
										end
									end,
								},
								healthbar_bg_texture = {
									type = "select",
									name = 'Health bar background',
									desc = 'Select health bar background texture.',
									dialogControl = 'LSM30_Statusbar',
									order = 3.2,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = function() return L.config.healthbar_bg_texture["enemy"] end,
									set = function(_, val)
										if L.config.L.config.healthbar_bg_texture["enemy"] ~= val then
											L.config.L.config.healthbar_bg_texture["enemy"] = val
											namePlateMixin:UpdateNamePlateByOptions("bars")
										end
									end,
								},
								healthbar_div_bg = {
									type = 'range',
									name = 'BG color',
									desc = 'Health bar background color (health bar color / this value)',
									min = 1,
									max = 10,
									step = 0.1,
									order = 3.3,
									get = function() return L.config.healthbar_div_bg["enemy"] end,
									set = function(_, val)
										if L.config.healthbar_div_bg["enemy"] ~= val then
											L.config.healthbar_div_bg["enemy"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								healthbar_width = {
									type = 'range',
									name = 'Health bar width',
									desc = 'Setup for health bar width.',
									min = 20,
									max = 150,
									step = 1,
									order = 3.4,
									get = function() return L.config.healthbar_width["enemy"] end,
									set = function(_, val)
										if L.config.healthbar_width["enemy"] ~= val then
											L.config.healthbar_width["enemy"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
											namePlateMixin:SetBaseNamePlateSize()
											namePlateMixin:UpdateMyTarget()
										end
									end,
								},
								healthbar_height = {
									type = 'range',
									name = 'Health bar height',
									desc = 'Setup for health bar height.',
									min = 1,
									max = 15,
									step = 1,
									order = 3.5,
									get = function() return L.config.healthbar_height["enemy"] end,
									set = function(_, val)
										if L.config.healthbar_height["enemy"] ~= val then
											L.config.healthbar_height["enemy"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
											namePlateMixin:SetBaseNamePlateSize()
											namePlateMixin:UpdateMyTarget()
										end
									end,
								},
								healthbar_bg_alpha = {
									type = 'range',
									name = 'BG alpha',
									desc = 'Setup alpha for health bar background.',
									min = 0,
									max = 1,
									step = 0.05,
									isPercent = true,
									order = 3.6,
									get = function() return L.config.healthbar_bg_alpha["enemy"] end,
									set = function(_, val)
										if L.config.healthbar_bg_alpha["enemy"] ~= val then
											L.config.healthbar_bg_alpha["enemy"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
							},
						},
						healthbar_dps_colors_setup = {
							type = 'group',
							name = 'Setup health bar colors by unit health.',
							inline = true,
							order = 2,
							args = {
								healthbar_dps_color_1 = {
									type = "color",
									name = "Color 1",
									desc = 'Color from 0% HP to first range.',
									hasAlpha = true,
									width = 'half',
									order = 1.1,
									get = function() return unpack(L.config.healthbar_dps_color_1) end,
									set = function(_,...)
										L.config.healthbar_dps_color_1 = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								dps_value_color_1 = {
									type = 'range',
									name = 'First range',
									desc = '',
									min = 0,
									max = L('dps_value_color_2'),
									step = .01,
									isPercent = true,
									order = 1.2,
									disabled = function() return L('threat_enable') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if val < L.config.dps_value_color_2 then
											L.options.args.health_power_setup.args.enemy.args.healthbar_dps_colors_setup.args.dps_value_color_2.min = val
											L.config.dps_value_color_1 = val
										end
									end,
								},
								healthbar_dps_color_2 = {
									type = "color",
									name = "Color 2",
									desc = 'Color from first range to second range.',
									hasAlpha = true,
									width = 'half',
									order = 1.3,
									get = function() return unpack(L.config.healthbar_dps_color_2) end,
									set = function(_,...)
										L.config.healthbar_dps_color_2 = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								dps_value_color_2 = {
									type = 'range',
									name = 'Second range',
									desc = '',
									min = L('dps_value_color_1'),
									max = 1,
									step = .01,
									isPercent = true,
									order = 1.4,
									disabled = function() return L('threat_enable') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if val > L.config.dps_value_color_1 then
											L.options.args.health_power_setup.args.enemy.args.healthbar_dps_colors_setup.args.dps_value_color_1.max = val
											L.config.dps_value_color_2 = val
										end
									end,
								},
								healthbar_dps_color_3 = {
									type = "color",
									name = "Color 3",
									desc = 'Color from second range to 100% HP.',
									hasAlpha = true,
									width = 'half',
									order = 1.5,
									get = function() return unpack(L.config.healthbar_dps_color_3) end,
									set = function(_,...)
										L.config.healthbar_dps_color_3 = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								healthbar_dps_color_4 = {
									type = "color",
									name = "Color 4",
									desc = 'Color if you have aggro and you are in group.',
									hasAlpha = true,
									width = 'half',
									order = 1.6,
									get = function() return unpack(L.config.healthbar_dps_color_4) end,
									set = function(_,...)
										L.config.healthbar_dps_color_4 = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
						power_bar_setup = {
							type = 'group',
							name = 'Setup power bar',
							inline = true,
							order = 3,
							args = {
								powerbar_alltime = {
									type = 'toggle',
									name = 'Always show power bar',
									desc = 'Show power bar all time, or only if unit is BOSS or unit have +2 lvl more that you (M+ boss) and power is between 0 and max.',
									order = 1.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.powerbar_alltime = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								spacer13 =  {
									type = "description", order = 1.3, name = " ", fontSize = "medium",
								},
								powerbar_texture = {
									type = "select",
									name = 'Power bar texture',
									desc = 'Select power bar texture',
									dialogControl = 'LSM30_Statusbar',
									order = 2.1,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.powerbar_texture = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								powerbar_bg_texture = {
									type = "select",
									name = 'Power bar background',
									desc = 'Select power bar background texture',
									dialogControl = 'LSM30_Statusbar',
									order = 2.2,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.powerbar_bg_texture = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								spacer29 =  {
									type = "description", order = 2.9, name = " ", fontSize = "medium",
								},
								powerbar_Y = {
									type = 'range',
									name = 'Power bar position Y',
									desc = 'Setup Y position for power bar.',
									min = -15,
									max = 15,
									step = 1,
									order = 3.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.powerbar_Y = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								powerbar_height = {
									type = 'range',
									name = 'Power bar height',
									desc = 'Setup for power bar height.',
									min = 1,
									max = 15,
									step = 1,
									order = 3.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.powerbar_height = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
							},
						},
						extended = {
							type = 'group',
							name = 'Extended CVars setup',
							inline = true,
							order = 4,
							args = {
								spacer10 =  {
									type = "description", order = 1.0, name = "|cffFFD000nameplateShowEnemy :|r", fontSize = "medium",
								},
								nameplateShowEnemyGuardians = {
									type = 'toggle',
									name = 'Guardians',
									desc = 'SetCVar nameplateShowEnemyGuardians',
									order = 1.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowEnemyGuardians", val and 1 or 0)
										L.config.nameplateShowEnemyGuardians = val
									end,
								},
								nameplateShowEnemyMinions = {
									type = 'toggle',
									name = 'Minions',
									desc = 'SetCVar nameplateShowEnemyMinions',
									width = 'half',
									order = 1.2,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowEnemyMinions", val and 1 or 0)
										L.config.nameplateShowEnemyMinions = val
									end,
								},
								nameplateShowEnemyPets = {
									type = 'toggle',
									name = 'Pets',
									desc = 'SetCVar',
									width = 'half',
									order = 1.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowEnemyPets", val and 1 or 0)
										L.config.nameplateShowEnemyPets = val
									end,
								},
								nameplateShowEnemyTotems = {
									type = 'toggle',
									name = 'Totems',
									desc = 'SetCVar nameplateShowEnemyTotems',
									width = 'half',
									order = 1.4,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowEnemyTotems", val and 1 or 0)
										L.config.nameplateShowEnemyTotems = val
									end,
								},
								nameplateShowEnemyMinus = {
									type = 'toggle',
									name = 'Minus',
									desc = 'SetCVar nameplateShowEnemyMinus',
									width = 'half',
									order = 1.5,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowEnemyMinus", val and 1 or 0)
										L.config.nameplateShowEnemyMinus = val
									end,
								},
							},
						},
					},
				},
				friend = {
					type = "group",
					order = 4,
					name = "Friendly",
					args = {
						hb_friendly_bar_setup = {
							type = 'group',
							name = 'Setup friendly health bar',
							inline = true,
							order = 1,
							args = {
								hb_friendly_show = {
									type = 'toggle',
									name = 'Always show health bar',
									desc = 'Show health bar on friendly players. If is possible.',
									order = 1.1,
									get = function() return L.config.healthbar_show["friendly"] end,
									set = function(_, val)
										L.config.healthbar_show["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								spacer19 =  {
									type = "description", order = 1.9, name = " ", fontSize = "medium",
								},
								healthbar_shadow = {
									type = 'toggle',
									name = 'Shadow',
									desc = 'Show shadow border all time on friendly health bars.',
									width = 'half',
									order = 2.1,
									get = function() return L.config.healthbar_shadow["friendly"] end,
									set = function(_, val)
										L.config.healthbar_shadow["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								healthbar_shadow_color = {
									type = "color",
									name = "Color",
									desc = 'Select color for shadow border on health bar.',
									hasAlpha = true,
									width = 'half',
									order = 2.2,
									disabled = function() return not L.config.healthbar_shadow["friendly"] end,
									get = function() return unpack(L.config.healthbar_shadow_color["friendly"]) end,
									set = function(_,...)
										L.config.healthbar_shadow_color["friendly"] = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								healthbar_class_color = {
									type = 'toggle',
									name = 'Class color',
									desc = 'Use class color for friendly unit health bar.',
									order = 2.3,
									get = function() return L.config.healthbar_class_color["friendly"] end,
									set = function(_, val)
										L.config.healthbar_class_color["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_spark = {
									type = 'toggle',
									name = 'Spark',
									desc = 'Show spark on health bar.',
									width = 'half',
									order = 2.4,
									get = function() return L.config.healthbar_spark["friendly"] end,
									set = function(_, val)
										L.config.healthbar_spark["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								friendlyClickThrough = {
									type = 'toggle',
									name = 'friendlyClickThrough',
									desc = 'Disable mouse on friendly nameplate. You must /reloadui.',
									order = 2.5,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										C_NamePlate.SetNamePlateFriendlyClickThrough(val)
										L.config.friendlyClickThrough = val
									end,
								},
								healthbar_border_top = {
									type = 'toggle',
									name = 'TOP',
									desc = 'Use class color on border for friendly unit health bar.',
									width = 'half',
									order = 2.6,
									get = function() return L.config.healthbar_border_top["friendly"] end,
									set = function(_, val)
										L.config.healthbar_border_top["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_border_bottom = {
									type = 'toggle',
									name = 'BOTTOM',
									desc = 'Use class color on border for friendly unit health bar.',
									width = 'half',
									order = 2.7,
									get = function() return L.config.healthbar_border_bottom["friendly"] end,
									set = function(_, val)
										L.config.healthbar_border_bottom["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_border_left = {
									type = 'toggle',
									name = 'LEFT',
									desc = 'Use class color on border for friendly unit health bar.',
									width = 'half',
									order = 2.8,
									get = function() return L.config.healthbar_border_left["friendly"] end,
									set = function(_, val)
										L.config.healthbar_border_left["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								healthbar_border_right = {
									type = 'toggle',
									name = 'RIGHT',
									desc = 'Use class color on border for friendly unit health bar.',
									width = 'half',
									order = 2.9,
									get = function() return L.config.healthbar_border_right["friendly"] end,
									set = function(_, val)
										L.config.healthbar_border_right["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								spacer30 =  {
									type = "description", order = 3.0, name = " ", fontSize = "medium",
								},
								hb_friendly_texture = {
									type = "select",
									name = 'Health bar texture',
									desc = 'Select health bar texture for all nameplate.',
									dialogControl = 'LSM30_Statusbar',
									order = 3.1,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = function() return L.config.healthbar_texture["friendly"] end,
									set = function(_, val)
										L.config.healthbar_texture["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								hb_friendly__bg_texture = {
									type = "select",
									name = 'Health bar background',
									desc = 'Select health bar background texture.',
									dialogControl = 'LSM30_Statusbar',
									order = 3.2,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = function() return L.config.healthbar_bg_texture["friendly"] end,
									set = function(_, val)
										L.config.healthbar_bg_texture["friendly"] = val
										namePlateMixin:UpdateNamePlateByOptions("bars")
									end,
								},
								hb_friendly_div_bg = {
									type = 'range',
									name = 'BG color',
									desc = 'Health bar background color (health bar color / this value)',
									min = 1,
									max = 10,
									step = 0.1,
									order = 3.3,
									get = function() return L.config.healthbar_div_bg["friendly"] end,
									set = function(_, val)
										if L.config.healthbar_div_bg["friendly"] ~= val then
											L.config.healthbar_div_bg["friendly"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								hb_friendly_width = {
									type = 'range',
									name = 'Health bar width',
									desc = 'Setup for health bar width.',
									min = 20,
									max = 150,
									step = 1,
									order = 3.4,
									get = function() return L.config.healthbar_width["friendly"] end,
									set = function(_, val)
										if L.config.healthbar_width["friendly"] ~= val then
											L.config.healthbar_width["friendly"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
											namePlateMixin:SetBaseNamePlateSize()
											namePlateMixin:UpdateMyTarget()
										end
									end,
								},
								hb_friendly_height = {
									type = 'range',
									name = 'Health bar height',
									desc = 'Setup for health bar height.',
									min = 1,
									max = 15,
									step = 1,
									order = 3.5,
									get = function() return L.config.healthbar_height["friendly"] end,
									set = function(_, val)
										if L.config.healthbar_height["friendly"] ~= val then
											L.config.healthbar_height["friendly"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
											namePlateMixin:SetBaseNamePlateSize()
											namePlateMixin:UpdateMyTarget()
										end
									end,
								},
								hb_friendly_bg_alpha = {
									type = 'range',
									name = 'BG alpha',
									desc = 'Setup alpha for health bar background.',
									min = 0,
									max = 1,
									step = 0.05,
									isPercent = true,
									order = 3.6,
									get = function() return L.config.healthbar_bg_alpha["friendly"] end,
									set = function(_, val)
										if L.config.healthbar_bg_alpha["friendly"] ~= val then
											L.config.healthbar_bg_alpha["friendly"] = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
							},
						},
						extended = {
							type = 'group',
							name = 'Extended CVars setup',
							inline = true,
							order = 2,
							args = {
								spacer20 = {
									type = "description", order = 2.0, name = "|cffFFD000nameplateShowFriendly:|r", fontSize = "medium",
								},
								nameplateShowFriendlyGuardians = {
									type = 'toggle',
									name = 'Guardians',
									desc = 'SetCVar nameplateShowFriendlyGuardian',
									order = 2.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowFriendlyGuardians", val and 1 or 0)
										L.config.nameplateShowFriendlyGuardians = val
									end,
								},
								nameplateShowFriendlyMinions = {
									type = 'toggle',
									name = 'Minions',
									desc = 'SetCVar nameplateShowFriendlyMinions',
									width = 'half',
									order = 2.2,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowFriendlyMinions", val and 1 or 0)
										L.config.nameplateShowFriendlyMinions = val
									end,
								},
								nameplateShowFriendlyPets = {
									type = 'toggle',
									name = 'Pets',
									desc = 'SetCVar nameplateShowFriendlyPets',
									width = 'half',
									order = 2.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowFriendlyPets", val and 1 or 0)
										L.config.nameplateShowFriendlyPets = val
									end,
								},
								nameplateShowFriendlyTotems = {
									type = 'toggle',
									name = 'Totems',
									desc = 'SetCVar nameplateShowFriendlyTotems',
									width = 'half',
									order = 2.4,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowFriendlyTotems", val and 1 or 0)
										L.config.nameplateShowFriendlyTotems = val
									end,
								},
								nameplateShowFriendlyNPCs = {
									type = 'toggle',
									name = 'Friendly NPCs',
									desc = 'SetCVar nameplateShowFriendlyNPCs',
									order = 2.5,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										SetCVar("nameplateShowFriendlyNPCs", val)
										L.config.nameplateShowFriendlyNPCs = val
									end,
								},
							},
						},
					},
				},
			},
		},
		mo_target = {
			type = 'group',
			name = "Target mouseover focus",
			childGroups = "tab",
			inline = false,
			order = 5,
			args = {
				target_setup = {
					type = "group",
					order = 1,
					name = "Target",
					args = {
						target_overlap_show = {
							type = 'toggle',
							name = 'Overlap texture',
							desc = 'Show overlap texture on target health bar',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.target_overlap_show = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						target_glow = {
							type = 'toggle',
							name = 'Animated glow',
							desc = 'Enable glow animation on target health bar',
							order = 1.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.target_glow = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						target_shadow = {
							type = 'toggle',
							name = 'Shadow border',
							desc = 'Show shadow border on target health bar',
							order = 1.3,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.target_shadow = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "medium",
						},
						target_healthbar_scale = {
							type = 'range',
							name = 'Target health bar scale',
							desc = 'Increase health bar size if unit is target.',
							min = 1,
							max = 2,
							step = 0.05,
							isPercent = true,
							order = 2.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.target_healthbar_scale = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						nameplateSelectedScale = {
							type = 'range',
							name = 'Target global scale',
							desc = 'Increase size all namplate elements if unit is target. Plz dont use this setup, destroing PixelUtil functions.',
							min = 1,
							max = 2,
							step = 0.05,
							isPercent = true,
							order = 2.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.nameplateSelectedScale = val
								SetCVar("nameplateSelectedScale", val)
							end,
						},
						target_highlight = {
							type = 'range',
							name = 'Highlight',
							desc = 'Highlight color for on target health bar. (HB color + this value)',
							min = 0,
							max = 1,
							step = .05,
							order = 2.3,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.target_highlight = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						target_healthbar = {
							type = 'toggle',
							name = 'healthBar texture',
							desc = 'Change healthBar texture if unit is your focus.',
							order = 2.5,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.target_healthbar = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						target_healthbar_texture = {
							type = "select",
							name = 'Texture',
							desc = 'Select focus healthBar texture',
							dialogControl = 'LSM30_Statusbar',
							order = 2.6,
							disabled = function() return not L('target_healthbar') end,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.target_healthbar_texture = val
								namePlateMixin:UpdateMyTarget()
							end,
						},
						target_overlap_setup = {
							type = 'group',
							name = 'Target overlap texture',
							inline = true,
							order = 3,
							hidden = function() return not L('target_overlap_show') end,
							args = {
								target_overlap = {
									type = "select",
									name = 'Texture',
									desc = 'Select texture for target health bar',
									dialogControl = 'LSM30_Statusbar',
									order = 1.2,
									values = AceGUIWidgetLSMlists.statusbar,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.target_overlap = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_overlap_blend  = {
									type = 'select',
									name = 'Blend mode',
									style = 'dropdown',
									order = 1.3,
									values = target_overlap_blend_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.target_overlap_blend = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_overlap_color = {
									type = 'color',
									name = 'Texture color',
									desc = 'Select color for texture on target health bar',
									hasAlpha = true,
									order = 1.4,
									get = function() return unpack(L.config.target_overlap_color) end,
									set = function(_,...)
										L.config.target_overlap_color = {...}
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_overlap_flip  = {
									type = 'select',
									name = 'Flip texture',
									style = 'dropdown',
									order = 1.5,
									values = texture_flip_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.target_overlap_flip = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_overlap_offset = {
									type = 'range',
									name = 'Target texture offset',
									desc = 'Increase target texture size.',
									min = -5,
									max = 5,
									step = 1,
									order = 1.6,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_overlap_offset = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
							},
						},
						target_shadow_setup = {
							type = 'group',
							name = 'Target shadow setup',
							inline = true,
							order = 4,
							hidden = function() return not L('target_shadow') end,
							args = {
								target_shadow_color = {
									type = 'color',
									name = 'Shadow border color',
									desc = 'Select color for shadow border on target health bar',
									hasAlpha = true,
									order = 1.2,
									get = function() return unpack(L.config.target_shadow_color) end,
									set = function(_,...)
										L.config.target_shadow_color = {...}
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_shadow_flash = {
									type = 'toggle',
									name = 'Flash',
									desc = 'Enable flashing shadow border on target health bar',
									order = 1.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_shadow_flash = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
							},
						},
						target_glow_setup = {
							type = 'group',
							name = 'Target glow setup',
							inline = true,
							order = 5,
							hidden = function() return not L('target_glow') end,
							args = {
								target_glow_width = {
									type = 'range',
									name = 'Width',
									desc = 'Width',
									min = 1,
									max = 20,
									step = 1,
									order = 1.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_width = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_height = {
									type = 'range',
									name = 'Height',
									desc = 'Height',
									min = 1,
									max = 5,
									step = 1,
									order = 1.2,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_height = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_number = {
									type = 'range',
									name = 'Number',
									desc = 'Number',
									min = 1,
									max = 30,
									step = 1,
									order = 1.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_number = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_border = {
									type = 'toggle',
									name = 'Border',
									desc = 'Show border under glow from LibCustomGlow.',
									width = 'half',
									order = 1.4,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_border = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_xOffset = {
									type = 'range',
									name = 'xOffset',
									desc = 'xOffset',
									min = 1,
									max = 20,
									step = 1,
									order = 2.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_xOffset = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_yOffset = {
									type = 'range',
									name = 'yOffset',
									desc = 'yOffset',
									min = 1,
									max = 20,
									step = 1,
									order = 2.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_yOffset = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_speed = {
									type = 'range',
									name = 'Speed',
									desc = 'Speed',
									min = .05,
									max = .5,
									step = .01,
									order = 2.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.target_glow_speed = val
										namePlateMixin:UpdateMyTarget()
									end,
								},
								target_glow_color = {
									type = 'color',
									name = 'Color',
									desc = 'Select color for animation border.',
									hasAlpha = true,
									width = 'half',
									order = 2.4,
									get = function() return unpack(L.config.target_glow_color) end,
									set = function(_,...)
										L.config.target_glow_color = {...}
										namePlateMixin:UpdateMyTarget()
									end,
								},
							},
						},
					},
				},
				mouseover_setup = {
					type = "group",
					order = 2,
					name = "Mouseover",
					args = {
						mouseover_enable = {
							type = 'toggle',
							name = 'Mouseover extensions',
							desc = 'Enable mouseover extensions for nameplates.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mouseover_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer13 =  {
							type = "description", order = 1.3, name = " ", fontSize = "medium",
						},
						mouseover_healthbar_scale = {
							type = 'range',
							name = 'Health bar scale',
							desc = 'Increase health bar size if unit is over mouse.',
							min = 1,
							max = 2,
							step = .05,
							isPercent = true,
							order = 2.1,
							hidden = function() return not L('mouseover_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								if L.config.mouseover_healthbar_scale ~= val then
									L.config.mouseover_healthbar_scale = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						mouseover_highlight = {
							type = 'range',
							name = 'Highlight',
							desc = 'Highlight color for on mouseover health bar. (HB color + this value)',
							min = .1,
							max = 1,
							step = .05,
							order = 2.2,
							hidden = function() return not L('mouseover_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								if L.config.mouseover_highlight ~= val then
									L.config.mouseover_highlight = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						spacer23 =  {
							type = "description", order = 2.3, name = " ", fontSize = "medium",
						},
						mouseover_shadow = {
							type = 'toggle',
							name = 'Shadow border',
							desc = 'Show shadow border on mouseover health bar',
							order = 3.1,
							hidden = function() return not L('mouseover_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mouseover_shadow = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mouseover_shadow_color = {
							type = "color",
							name = "Shadow border color",
							desc = 'Select color for shadow border on mouseover health bar',
							hasAlpha = true,
							disabled = function() return not L('mouseover_shadow') end,
							hidden = function() return not L('mouseover_enable') end,
							order = 3.2,
							get = function() return unpack(L.config.mouseover_shadow_color) end,
							set = function(_,...)
								L.config.mouseover_shadow_color = {...}
							end,
						},
					},
				},
				focus_setup = {
					type = "group",
					order = 3,
					name = "Focus",
					args = {
						focus_enable = {
							type = 'toggle',
							name = 'Focus extensions',
							desc = 'Enable focus extensions on nameplates.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.focus_enable = val
								namePlateMixin:UpdateMyFocus()
							end,
						},
						spacer13 =  {
							type = "description", order = 1.3, name = " ", fontSize = "medium",
						},
						focus_healthbar_scale = {
							type = 'range',
							name = 'Health bar scale',
							desc = 'Increase health bar size if unit is your focus.',
							min = 1,
							max = 2,
							step = .05,
							isPercent = true,
							order = 2.1,
							hidden = function() return not L('focus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								if L.config.focus_healthbar_scale ~= val then
									L.config.focus_healthbar_scale = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						spacer29 =  {
							type = "description", order = 2.9, name = " ", fontSize = "medium",
						},
						focus_shadow = {
							type = 'toggle',
							name = 'Shadow border',
							desc = 'Show shadow border on focus health bar',
							order = 3.1,
							hidden = function() return not L('focus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.focus_shadow = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						focus_shadow_color = {
							type = "color",
							name = "Shadow border color",
							desc = 'Select color for shadow border on focus unit health bar',
							hasAlpha = true,
							order = 3.2,
							disabled = function() return not L('focus_shadow') end,
							hidden = function() return not L('focus_enable') end,
							get = function() return unpack(L.config.focus_shadow_color) end,
							set = function(_, ...)
								L.config.focus_shadow_color = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer39 =  {
								type = "description", order = 3.9, name = " ", fontSize = "medium",
						},
						focus_healthbar = {
							type = 'toggle',
							name = 'healthBar texture',
							desc = 'Change healthBar texture if unit is your focus.',
							order = 4.1,
							hidden = function() return not L('focus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.focus_healthbar = val
								namePlateMixin:UpdateMyFocus()
							end,
						},
						focus_healthbar_texture = {
							type = "select",
							name = 'Texture',
							desc = 'Select focus healthBar texture',
							dialogControl = 'LSM30_Statusbar',
							order = 4.2,
							disabled = function() return not L('focus_healthbar') end,
							hidden = function() return not L('focus_enable') end,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.focus_healthbar_texture = val
								namePlateMixin:UpdateMyFocus()
							end,
						},
					},
				},
			},
		},
		resource_bar = {
			type = 'group',
			name = 'Resource bar',
			order = 6,
			args = {
				player_resource_type  = {
					type = 'select',
					name = 'Player resource type',
					desc = 'Select player resource type, or disable him.',
					style = 'dropdown',
					order = 1.1,
					values = class_bar_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.player_resource_type = val
						classBarMixin:UpdateClassBar()
					end,
				},
				player_resource_pine = {
					type = 'select',
					name = 'Player resource position',
					desc = 'Position for player resource bar.',
					style = 'dropdown',
					order = 1.2,
					disabled = function() return L.config.player_resource_type == 0 end,
					values = player_resource_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.player_resource_pine = val
						classBarMixin:UpdateClassBar()
					end,
				},
				player_resource_texture = {
					type = "select",
					name = 'Resource bar texture',
					dialogControl = 'LSM30_Statusbar',
					order = 1.3,
					values = AceGUIWidgetLSMlists.statusbar,
					style = "dropdown",
					disabled = function() return L.config.player_resource_type == 0 end,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.player_resource_texture = val
						classBarMixin:UpdateClassBar()
					end,
				},
				player_resource_by_pine = {
					type = 'group',
					name = 'Resource bar setup by bar position.',
					inline = true,
					order = 2,
					--	hidden = function() return L.config.player_resource_pine ~= 'player' end,
					disabled = function() return L.config.player_resource_type == 0 end,
					args = {
						player_resource_width = {
							type = 'range',
							name = 'Width',
							min = 40,
							max = 400,
							step = 1,
							order = 1.1,
							get = function() return L.config.player_resource_position_width[L.config.player_resource_pine] end,
							set = function(_, val)
								L.config.player_resource_position_width[L.config.player_resource_pine] = val
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_height = {
							type = 'range',
							name = 'Height',
							min = 2,
							max = 40,
							step = 1,
							order = 1.2,
							get = function() return L.config.player_resource_position_height[L.config.player_resource_pine] end,
							set = function(_, val)
								L.config.player_resource_position_height[L.config.player_resource_pine] = val
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_space = {
							type = 'range',
							name = 'Space',
							min = 1,
							max = 10,
							step = 1,
							order = 1.3,
							get = function() return L.config.player_resource_position_space[L.config.player_resource_pine] end,
							set = function(_, val)
								L.config.player_resource_position_space[L.config.player_resource_pine] = val
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_Y = {
							type = 'range',
							name = 'Y position',
							min = -525,
							max = 525,
							step = 1,
							order = 1.4,
							get = function() return L.config.player_resource_position_y[L.config.player_resource_pine] end,
							set = function(_, val)
								L.config.player_resource_position_y[L.config.player_resource_pine] = val
								classBarMixin:UpdateClassBar()
							end,
						},
					},
				},
				player_resource_color_setup = {
					type = 'group',
					name = 'Resource color (cp, chi, ...)',
					inline = true,
					hidden = function() return L.config.player_resource_type ~= 1 end,
					order = 5,
					args = {
						player_resource_color_1	 = {
							type = "color",
							name = "color 1",
							hasAlpha = true,
							width = 'half',
							order = 1.1,
							get = function() return unpack(L.config.player_resource_color[1]); end,
							set = function(_,...)
								L.config.player_resource_color[1] = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_color_2	 = {
							type = "color",
							name = "color 2",
							hasAlpha = true,
							width = 'half',
							order = 1.2,
							get = function() return unpack(L.config.player_resource_color[2]); end,
							set = function(_,...)
								L.config.player_resource_color[2] = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_color_3	 = {
							type = "color",
							name = "color 3",
							hasAlpha = true,
							width = 'half',
							order = 1.3,
							get = function() return unpack(L.config.player_resource_color[3]); end,
							set = function(_,...)
								L.config.player_resource_color[3] = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_color_4	 = {
							type = "color",
							name = "color 4",
							hasAlpha = true,
							width = 'half',
							order = 1.4,
							get = function() return unpack(L.config.player_resource_color[4]); end,
							set = function(_,...)
								L.config.player_resource_color[4] = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_color_5	 = {
							type = "color",
							name = "color 5",
							hasAlpha = true,
							width = 'half',
							order = 1.5,
							get = function() return unpack(L.config.player_resource_color[5]); end,
							set = function(_,...)
								L.config.player_resource_color[5] = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_color_6	 = {
							type = "color",
							name = "color 6",
							hasAlpha = true,
							width = 'half',
							order = 1.6,
							get = function() return unpack(L.config.player_resource_color[6]); end,
							set = function(_,...)
								L.config.player_resource_color[6] = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "medium",
						},	
						player_resource_color_full	 = {
							type = "color",
							name = "Full rune",
							hasAlpha = true,
							width = 'half',
							order = 2.1,
							get = function() return unpack(L.config.player_resource_color_full); end,
							set = function(_,...)
								L.config.player_resource_color_full = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						player_resource_color_empty	 = {
							type = "color",
							name = "Empty rune",
							hasAlpha = true,
							order = 2.2,
							get = function() return unpack(L.config.player_resource_color_empty); end,
							set = function(_,...)
								L.config.player_resource_color_empty = {...}
								classBarMixin:UpdateClassBar()
							end,
						},
						spacer23 =  {
							type = "description", order = 2.3, name = " ", fontSize = "medium",
						},
						player_resource_sound_enable = {
							type = 'toggle',
							name = 'Player resource sound',
							desc = 'Play this sound file if resource is full.',
							order = 3.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.player_resource_sound_enable = val
							end,
						},
						player_resource_sound = {
							type = "select",
							name = 'Select sound',
							dialogControl = 'LSM30_Sound',
							order = 3.2,
							disabled = function() return not L('player_resource_sound_enable') end,
							values = AceGUIWidgetLSMlists.sound,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.player_resource_sound = val
							end,
						},
						
					},
				},
				party_health_bars_setup = {
					type = 'group',
					name = 'Party health bars',
					inline = true,
					order = 6,
					hidden = function() return L.config.player_resource_type ~= 2 end,
					args = {
						party_health_bars_dynamic_size = {
							type = 'toggle',
							name = 'Dynamic size',
							desc = 'party_health_bars_dynamic_size',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.party_health_bars_dynamic_size = val
							end,
						},
					},
				},
				party_kick_cd_setup = {
					type = 'group',
					name = 'Party kick CD bars',
					inline = true,
					order = 7,
					hidden = function() return L.config.player_resource_type ~= 3 end,
					args = {
						party_kick_bars_shadow = {
							type = 'toggle',
							name = 'Enable shadow',
							desc = 'Show shadow around kick CD bar if his kick spell is ready for use.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.party_kick_bars_shadow = val
								classBarMixin:UpdateClassBar()
							end,
						},
					},
				},
				player_cd_setup = {
					type = 'group',
					name = 'Player CD setup',
					inline = true,
					order = 8,
					hidden = function() return L.config.player_resource_type ~= 4 end,
					args = {
						player_CD = {
							type = 'input',
							name = "Spell ID",
							desc = "Spell ID.",
							order = 1.1,
							get = function(_)
								return L.config.player_resource_spell_CD
							end,
							set = function(_, val)
								if (val) then
									L.config.player_resource_spell_CD = val
									classBarMixin:UpdateClassBar()
								end
							end,
						},
					},
				},
			},
		},
		cast_bar = {
			type = 'group',
			name = 'Cast bar',
			order = 8,
			args = {
				cb_show_spellName = {
					type = 'toggle',
					name = 'Show spell name',
					desc = 'Show spell name on cast bar.',
					order = 1.1,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_show_spellName = val
					end,
				},
				cb_show_kickerName = {
					type = 'toggle',
					name = 'Kicker name',
					desc = 'Show kicker name on cast bar.',
					order = 1.2,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_show_kickerName = val
					end,
				},
				cb_kicker_spam = {
					type = 'toggle',
					name = 'Enable chat spam',
					desc = 'Only for me, show who kick in chat.',
					order = 1.3,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_kicker_spam = val
					end,
				},
				cb_show_CD = {
					type = 'toggle',
					name = 'Show kick CD',
					desc = 'Show player kick cooldown on castbar.',
					order = 1.4,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_show_CD = val
						namePlateMixin:UpdateNamePlateByOptions("castbar")
					end,
				},
				cb_show_spark = {
					type = 'toggle',
					name = 'Show spark',
					desc = 'Show spark on castbar statusbar.',
					order = 1.5,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_show_spark = val
						namePlateMixin:UpdateNamePlateByOptions("castbar")
					end,
				},
				cb_friendly_show = {
					type = 'toggle',
					name = 'Friendly player castbar',
					desc = 'Show friendly players castbars.',
					order = 1.6,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_friendly_show = val
						namePlateMixin:UpdateNamePlateByOptions("castbar")
					end,
				},
				cb_target_hide = {
					type = 'toggle',
					name = 'Hide target castbar',
					desc = 'Hide castbar on target.',
					order = 1.7,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_target_hide = val
					end,
				},
				cb_schoolColor = {
					type = 'toggle',
					name = 'School color',
					desc = 'Use school color for castBar shadow border.',
					order = 1.8,
					get = L.GetFromSavedVariabiles,
					set = function(_, val)
						L.config.cb_schoolColor = val
						namePlateMixin:UpdateNamePlateByOptions("castbar")
					end,
				},
				spacer19 =  {
					type = "description", order = 1.9, name = " ", fontSize = "small",
				},
				cb_type = {
					type = 'select',
					name = 'Castbar type',
					desc = 'Change castbar type.',
					style = 'dropdown',
					order = 3.1,
					values = castbar_type_table,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.cb_type = val
						namePlateMixin:UpdateNamePlateByOptions("castbar")
					end,
				},
				cb_alpha = {
					type = 'range',
					name = 'Castbar global alpha',
					desc = 'Set basic alpha for all castbar elements.',
					min = 0,
					max = 1,
					step = .05,
					isPercent = true,
					order = 3.2,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.cb_alpha = val
					end,
				},
				cb_target_scale = {
					type = 'range',
					name = 'Castbar target scale',
					desc = 'Scale for castbar if is your target.',
					min = 1,
					max = 2,
					step = .05,
					isPercent = true,
					order = 3.3,
					get = L.GetFromDefaultOrSavedVariabiles,
					set = function(_, val)
						L.config.cb_target_scale = val
					end,
				},
				cb_type_1 = {
					type = 'group',
					name = 'Cast bar type 1 setup',
					inline = true,
					order = 4,
					hidden = function() return not (L.config.cb_type == 1) end,
					args = {
						cb_1_size_X = {
							type = 'range',
							name = 'Castbar width',
							min = 20,
							max = 50,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_1_size_X = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_1_size_Y = {
							type = 'range',
							name = 'Castbar height',
							min = 15,
							max = 40,
							step = 1,
							order = 1.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_1_size_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_1_offset = {
							type = 'range',
							name = 'Castbar offset',
							min = 1,
							max = 10,
							step = 1,
							order = 1.3,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_1_offset = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_1_posun_X = {
							type = 'range',
							name = 'Castbar position X',
							min = -100,
							max = 100,
							step = 1,
							order = 2.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_1_posun_X = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_1_posun_Y = {
							type = 'range',
							name = 'Castbar position Y',
							min = -100,
							max = 100,
							step = 1,
							order = 2.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_1_posun_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						spacer23 =  {
							type = "description", order = 2.3, name = " ", fontSize = "small",
						},
						cb_texture = {
							type = "select",
							name = 'Statusbar texture',
							dialogControl = 'LSM30_Statusbar',
							order = 3.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_sb_alpha = {
							type = 'range',
							name = 'Statusbar alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 3.2,
							get = function() return L.config.cb_sb_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_alpha[L.config.cb_type] = val
							 end,
						},
						cb_sb_shadow = {
							type = 'toggle',
							name = 'Shadow',
							desc = 'Show shadow border on castBar. This setup is ignored if you have enabled School color.',
							order = 3.3,
							get = function() return L.config.cb_sb_shadow[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_shadow[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},	
						spacer39 = {
							type = "description", order = 3.9, name = " ", fontSize = "small",
						},
						cb_texture_bg = {
							type = "select",
							name = 'Background texture',
							dialogControl = 'LSM30_Statusbar',
							order = 4.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture_bg[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture_bg[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_bg_alpha = {
							type = 'range',
							name = 'Background alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 4.2,
							get = function() return L.config.cb_bg_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_bg_alpha[L.config.cb_type] = val
							 end,
						},
					},
				},
				cb_type_2 = {
					type = 'group',
					name = 'Cast bar type 2 setup',
					inline = true,
					order = 5,
					hidden = function() return not (L.config.cb_type == 2) end,
					args = {
						cb_2_icon_size_X = {
							type = 'range',
							name = 'Castbar icon size X',
							min = 10,
							max = 50,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_2_icon_size_X = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_2_icon_size_Y = {
							type = 'range',
							name = 'Castbar icon size Y',
							min = 10,
							max = 50,
							step = 1,
							order = 1.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_2_icon_size_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_2_align = {
							type = 'select',
							name = 'Align',
							style = 'dropdown',
							order = 1.3,
							values = cb_align_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_2_align = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_2_icon_posun_X = {
							type = 'range',
							name = 'Castbar icon position X',
							min = -100,
							max = 100,
							step = 1,
							order = 1.4,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_2_icon_posun_X = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_2_icon_posun_Y = {
							type = 'range',
							name = 'Castbar icon position Y',
							min = -50,
							max = 50,
							step = 1,
							order = 1.5,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_2_icon_posun_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_2_offset = {
							type = 'range',
							name = 'Castbar offset',
							min = -10,
							max = 10,
							step = 1,
							order = 1.6,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_2_offset = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						spacer19 = {
							type = "description", order = 1.9, name = " ", fontSize = "small",
						},
						cb_texture = {
							type = "select",
							name = 'Statusbar texture',
							dialogControl = 'LSM30_Statusbar',
							order = 2.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_sb_alpha = {
							type = 'range',
							name = 'Statusbar alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 2.2,
							get = function() return L.config.cb_sb_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_alpha[L.config.cb_type] = val
							 end,
						},
						cb_sb_shadow = {
							type = 'toggle',
							name = 'Shadow',
							desc = 'Show shadow border on castBar. This setup is ignored if you have enabled School color.',
							order = 2.3,
							get = function() return L.config.cb_sb_shadow[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_shadow[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},	
						spacer29 = {
							type = "description", order = 2.9, name = " ", fontSize = "small",
						},
						cb_texture_bg = {
							type = "select",
							name = 'Background texture',
							dialogControl = 'LSM30_Statusbar',
							order = 3.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture_bg[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture_bg[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_bg_alpha = {
							type = 'range',
							name = 'Background alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 3.2,
							get = function() return L.config.cb_bg_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_bg_alpha[L.config.cb_type] = val
							 end,
						},
					},
				},
				cb_type_3 = {
					type = 'group',
					name = 'Cast bar type 3 setup',
					inline = true,
					order = 6,
					hidden = function() return not (L.config.cb_type == 3) end,
					args = {
						cb_3_size_Y = {
							type = 'range',
							name = 'Castbar height',
							min = 1,
							max = 30,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_3_size_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_3_icon_position  = {
							type = 'toggle',
							name = 'Icon on left',
							desc = 'Show icon on left side, or right side.',
							order = 1.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.cb_3_icon_position  = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						spacer13 =  {
							type = "description", order = 1.3, name = " ", fontSize = "small",
						},
						cb_texture = {
							type = "select",
							name = 'Statusbar texture',
							dialogControl = 'LSM30_Statusbar',
							order = 2.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_sb_alpha = {
							type = 'range',
							name = 'Statusbar alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 2.2,
							get = function() return L.config.cb_sb_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_alpha[L.config.cb_type] = val
							 end,
						},
						cb_sb_shadow = {
							type = 'toggle',
							name = 'Shadow',
							desc = 'Show shadow border on castBar. This setup is ignored if you have enabled School color.',
							order = 2.3,
							get = function() return L.config.cb_sb_shadow[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_shadow[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},	
						spacer29 = {
							type = "description", order = 2.9, name = " ", fontSize = "small",
						},
						cb_texture_bg = {
							type = "select",
							name = 'Background texture',
							dialogControl = 'LSM30_Statusbar',
							order = 3.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture_bg[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture_bg[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},	
						cb_bg_alpha = {
							type = 'range',
							name = 'Background alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 3.3,
							get = function() return L.config.cb_bg_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_bg_alpha[L.config.cb_type] = val
							 end,
						},
					},
				},
				cb_type_4 = {
					type = 'group',
					name = 'Cast bar type 4 setup',
					inline = true,
					order = 7,
					hidden = function() return not (L.config.cb_type == 4) end,
					args = {
						cb_4_size_X = {
							type = 'range',
							name = 'Castbar width',
							min = 20,
							max = 50,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_4_size_X = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_4_size_Y = {
							type = 'range',
							name = 'Castbar height',
							min = 15,
							max = 40,
							step = 1,
							order = 1.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_4_size_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "small",
						},
						cb_4_posun_X = {
							type = 'range',
							name = 'Castbar position X',
							min = -100,
							max = 100,
							step = 1,
							order = 2.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_4_posun_X = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_4_posun_Y = {
							type = 'range',
							name = 'Castbar position Y',
							min = -100,
							max = 100,
							step = 1,
							order = 2.2,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_4_posun_Y = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						spacer23 = {
							type = "description", order = 2.3, name = " ", fontSize = "small",
						},
						cb_texture = {
							type = "select",
							name = 'Statusbar texture',
							dialogControl = 'LSM30_Statusbar',
							order = 3.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_sb_alpha = {
							type = 'range',
							name = 'Statusbar alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 3.2,
							get = function() return L.config.cb_sb_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_alpha[L.config.cb_type] = val
							 end,
						},
						cb_sb_shadow = {
							type = 'toggle',
							name = 'Shadow',
							desc = 'Show shadow border on castBar. This setup is ignored if you have enabled School color.',
							order = 3.3,
							get = function() return L.config.cb_sb_shadow[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_sb_shadow[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},	
						spacer39 =  {
							type = "description", order = 3.9, name = " ", fontSize = "small",
						},
						cb_texture_bg = {
							type = "select",
							name = 'Background texture',
							dialogControl = 'LSM30_Statusbar',
							order = 4.1,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = function() return L.config.cb_texture_bg[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_texture_bg[L.config.cb_type] = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_bg_alpha = {
							type = 'range',
							name = 'Background alpha',
							min = 0,
							max = 1,
							step = .05,
							isPercent = true,
							order = 4.2,
							get = function() return L.config.cb_bg_alpha[L.config.cb_type] end,
							set = function(_, val)
								L.config.cb_bg_alpha[L.config.cb_type] = val
							 end,
						},
					},
				},
				cb_school_setup = {
					type = 'group',
					name = 'Cast bar schoolColor setup',
					inline = true,
					order = 9,
					hidden = function() return not L('cb_schoolColor') end,
					args = {
						selectSchool = {
							type = "select",
							name = "Select school",
							desc = 'Select spell school.',
							order = 1.1,
							get = function(_)
								if not selectedSchool then
									selectedSchool = 1
									return selectedSchool
								else
									return selectedSchool
								end
							end,
							set = function(_, value)
								selectedSchool = value
								L.colorSchool = L.config.cb_schoolColors[value].color
							end,
							values = function()
								local filters = {}
								for filter in pairs(L.config.cb_schoolColors) do
									local r, g, b, a = unpack(L.config.cb_schoolColors[filter].color)
									local stringColor = format("%.2x%.2x%.2x%.2x", a * 255, r * 255, g * 255, b * 255)
									filters[filter] = format("|c"..stringColor.."%s|r", L.config.cb_schoolColors[filter].name)
								end
								if not next(filters) then filters[''] = NONE end
								return filters
							end,
						},
						colorSchool = {
							type = "color",
							name = "Color",
							hasAlpha = true,
							width = "half",
							order = 1.2,
							hidden = function() return not (selectedSchool and selectedSchool ~= "") end,
							get = function()
								if selectedSchool then
									if L.config.cb_schoolColors[selectedSchool] then
										return unpack(L.config.cb_schoolColors[selectedSchool].color)
									end
								else
									return {0, 0, 0, 1}
								end
							end,
							set = function(_,...)
								L.config.cb_schoolColors[selectedSchool].color = {...}
							end,
						},
						cb_colorSchool_offset = {
							type = 'range',
							name = 'Shadow size',
							desc = 'Set shadow border offset.',
							min = 1,
							max = 12,
							step = 1,
							order = 1.3,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_colorSchool_offset = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
					},
				},
				cb_color_setup = {
					type = 'group',
					name = 'Cast bar color setup (/reload for apply)',
					inline = true,
					order = 10,
					args = {
						cb_startCastColor = {
							type = "color",
							name = "Cast",
							width = 'half',
							order = 1.1,
							get = function() return unpack(L.config.cb_startCastColor); end,
							set = function(_,...)
								L.config.cb_startCastColor = {...}
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_startChannelColor = {
							type = "color",
							name = "Channel",
							width = 'half',
							order = 1.2,
							get = function() return unpack(L.config.cb_startChannelColor); end,
							set = function(_,...)
								L.config.cb_startChannelColor = {...}
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_finishedCastColor = {
							type = "color",
							name = "Finished",
							width = 'half',
							order = 1.3,
							get = function() return unpack(L.config.cb_finishedCastColor); end,
							set = function(_,...)
								L.config.cb_finishedCastColor = {...}
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_failedCastColor = {
							type = "color",
							name = "Failed",
							width = 'half',
							order = 1.4,
							get = function() return unpack(L.config.cb_failedCastColor); end,
							set = function(_,...)
								L.config.cb_failedCastColor = {...}
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_nonInterruptibleColor = {
							type = "color",
							name = "nonInterruptible",
							order = 1.5,
							get = function() return unpack(L.config.cb_nonInterruptibleColor); end,
							set = function(_,...)
								L.config.cb_nonInterruptibleColor = {...}
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_finishedColorSameAsStart = {
							type = 'toggle',
							name = 'Finished color as start',
							desc = 'Finished color same as start',
							order = 2.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.cb_finishedColorSameAsStart = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_flashColorSameAsStart = {
							type = 'toggle',
							name = 'Flash color as start',
							desc = 'Flash color same as start',
							order = 2.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.cb_flashColorSameAsStart = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
					},
				},
				cb_spell_name_setup = {
					type = 'group',
					name = 'Cast bar spell name setup',
					inline = true,
					order = 11,
					hidden = function() return not L('cb_show_spellName') end,
					args = {
						cb_fontsize = {
							type = 'range',
							name = 'Font size',
							min = 2,
							max = 25,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_fontsize = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_font = {
							type = "select",
							name = 'Spell name font',
							dialogControl = 'LSM30_Font',
							order = 1.2,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_font = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_font_flag  = {
							type = 'select',
							name = 'Font flags',
							order = 1.3,
							style = 'dropdown',
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_font_flag  = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
					},
				},
				cb_kickername_setup = {
					type = 'group',
					name = 'Cast bar kicker name setup',
					inline = true,
					order = 12,
					hidden = function() return not L('cb_show_kickerName') end,
					args = {
						cb_kicker_fontsize = {
							type = 'range',
							name = 'Font size',
							min = 2,
							max = 25,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_kicker_fontsize = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_kicker_font = {
							type = "select",
							name = 'Kicker name font',
							dialogControl = 'LSM30_Font',
							order = 1.2,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_kicker_font = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_kicker_font_flag  = {
							type = 'select',
							name = 'Font flags',
							order = 1.3,
							style = 'dropdown',
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_kicker_font_flag  = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_kickerNameBGTexture = {
							type = "select",
							name = 'Kicker name BG texture',
							dialogControl = 'LSM30_Statusbar',
							order = 5.6,
							values = AceGUIWidgetLSMlists.statusbar,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_kickerNameBGTexture = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_kicker_texture_color = {
							type = "color",
							order = 5.7,
							name = "BG color",
							desc = 'Color for texture',
							width = 'half',
							hasAlpha = true,
							get = function() return unpack(L.config.cb_kicker_texture_color); end,
							set = function(_,...)
								L.config.cb_kicker_texture_color = {...}
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
					},
				},
				cb_CD_setup = {
					type = 'group',
					name = 'Player kick CD setup',
					inline = true,
					order = 13,
					hidden = function() return not L('cb_show_CD') end,
					args = {
						cb_CD_fontsize = {
							type = 'range',
							name = 'Font size',
							min = 2,
							max = 25,
							step = 1,
							order = 1.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_CD_fontsize = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_CD_font = {
							type = "select",
							name = 'Spell name font',
							dialogControl = 'LSM30_Font',
							order = 1.2,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_CD_font = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
						cb_CD_font_flag  = {
							type = 'select',
							name = 'Font flags',
							order = 1.3,
							style = 'dropdown',
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.cb_CD_font_flag  = val
								namePlateMixin:UpdateNamePlateByOptions("castbar")
							end,
						},
					},
				},
			},
		},
		auras = {
			type = 'group',
			name = "Auras",
			childGroups = "tab",
			inline = false,
			order = 9,
			args = {
				general_setup = {
					type = "group",
					order = 1,
					name = "General",
					args = {
						aura_bar_show = {
							type = 'toggle',
							name = 'Status bar mode',
							desc = 'Show aura buffs on nameplate that status bars',
							order = 1.5,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_bar_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end,
						},
						aura_show_timer_icon = {
							type = 'toggle',
							name = 'Enable timer in icon',
							desc = 'Show timer in icon auras.',
							order = 1.6,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_show_timer_icon = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						aura_show_timer_bar = {
							type = 'toggle',
							name = 'Enable timer in bar',
							desc = 'Show timer in bar auras.',
							order = 1.7,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_show_timer_bar = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						aura_show_cd = {
							type = 'toggle',
							name = 'Enable CD spiral',
							desc = 'Show spiral CD in auras.',
							order = 1.8,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_show_cd = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						aura_info = {
							type = 'toggle',
							name = 'New aura info',
							desc = 'Show new learned aura in infoPanel.',
							order = 1.9,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_info = val
							end,
						},
						aura_dispel_spam = {
							type = 'toggle',
							name = 'Enable dispel spam',
							desc = 'Only for me, show who dispel any aura in chat.',
							order = 2.0,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_dispel_spam = val
							end,
						},
						aura_space_X = {
							type = 'range',
							name = 'Space between auras',
							min = 0,
							max = 8,
							step = 1,
							order = 2.1,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								if L.config.aura_space_X ~= val then
									L.config.aura_space_X = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
					},
				},
				debuff_setup = {
					type = "group",
					order = 2,
					name = "Debuff",
					args = {
						aura_debuff_show = {
							type = 'toggle',
							name = 'Show debuff auras',
							desc = 'Show debuffs auras on nameplates.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_debuff_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						aura_stun_show = {
							type = 'toggle',
							name = 'Show CCs auras',
							desc = 'Show all defined CC auras on enemy nameplate from all friendly players.',
							order = 1.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_stun_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						auras_debuff_setup = {
							type = 'group',
							name = 'Setup debuff auras (default under nameplate)',
							inline = true,
							order = 4,
							hidden = function() return not L('aura_debuff_show') end,
							args = {
								aura_icon_debuff_width = {
									type = 'range',
									name = 'Debuff aura icon width',
									desc = 'Width for debuff aura icons and bars.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.1,
									disabled = function() return not L('aura_debuff_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_debuff_width ~= val then
											L.config.aura_icon_debuff_width = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_debuff_height = {
									type = 'range',
									name = 'Debuff aura icon height',
									desc = 'Height for debuff aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.2,
									disabled = function() return not L('aura_debuff_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_debuff_height ~= val then
											L.config.aura_icon_debuff_height = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_bar_debuff_height = {
									type = 'range',
									name = 'Debuff aura bar height',
									desc = 'Height for debuff aura bars.',
									min = 1,
									max = 10,
									step = 1,
									order = 1.3,
									disabled = function() return not L('aura_debuff_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_bar_debuff_height ~= val then
											L.config.aura_bar_debuff_height = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_debuff_max = {
									type = 'range',
									name = 'Max showed',
									desc = 'Max showed debuff auras.',
									min = 1,
									max = 8,
									step = 1,
									order = 1.4,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_debuff_max ~= val then
											L.config.aura_icon_debuff_max = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_bar_debuff_Y = {
									type = 'range',
									name = 'Position Y',
									min = -30,
									max = 30,
									step = 1,
									order = 1.5,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_bar_debuff_Y ~= val then
											L.config.aura_bar_debuff_Y = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								spacer19 =  {
									type = "description", order = 1.9, name = "", fontSize = "small",
								},
								selectAura = {
									type = "select",
									name = "Select player debuff",
									desc = 'Select player debuff aura from player aura list.',
									order = 2.1,
									get = function(_)
										if not selectedAura then
											if not L.AurasTable then return end
											for filter in pairs(L.AurasTable) do
												selectedAura = filter
											end
											return selectedAura
										else
											return selectedAura
										end
									end,
									set = function(_, value)
										selectedAura = value
										L.colorAura = L.AurasTable[value].color
										L.showAura = L.AurasTable[value].enable
									end,
									values = function()
										local filters = {}
										local list = L.AurasTable
										if not list then return end
										for filter in pairs(list) do
											local r, g, b = unpack(L.AurasTable[filter].color)
											local stringColor = format("ff%.2x%.2x%.2x", r * 255, g * 255, b * 255)
											if L.AurasTable[filter].enable then
												filters[filter] = format("|c"..stringColor.."%s|r", filter)
											else
												filters[filter] = format("|cFF808080%s|r", filter)
											end
										end
										if not next(filters) then filters[''] = NONE end
										return filters
									end,
								},
								addAura = {
									type = 'input',
									name = 'Add aura (by NAME)',
									desc = 'Add new aura to player aura list. Use aura name !!!',
									order = 2.2,
									get = function(_) return "" end,
									set = function(_, value)
										if value then
											L.AurasTable[value] = {}
											L.AurasTable[value].enable = true
											L.AurasTable[value].color = {1, 1, 1, 1}
										end
									end,
								},
								removeAura = {
									type = 'execute',
									name = "|cffFF0000Delete|r",
									desc = "Remove selected aura from player aura list.",
									width = "half",
									order = 2.3,
									func = function()
										if L.AurasTable[selectedAura] then
											L.AurasTable[selectedAura] = nil
											selectedAura = nil
										end
									end,
									disabled = function() return not (selectedAura and selectedAura ~= "") end,
								},
								colorAura = {
									type = "color",
									name = "Color",
									desc = 'Status bar color for this aura.',
									hasAlpha = true,
									width = "half",
									order = 2.4,
									hidden = function() return not (selectedAura and selectedAura ~= "") end,
									get = function()
										if selectedAura then
											if L.AurasTable[selectedAura] then
												return unpack(L.AurasTable[selectedAura].color)
											else
												return {1, 1, 1}
											end
										else
											return {1, 1, 1}
										end
									end,
									set = function(_,...)
										L.AurasTable[selectedAura].color = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								showAura = {
									type = 'toggle',
									name = 'Enable',
									desc = 'Enable showing this aura on nameplate.',
									width = "half",
									order = 2.5,
									hidden = function() return not (selectedAura and selectedAura ~= "") end,
									get = function(_)
										if selectedAura then
											if L.AurasTable[selectedAura] then
												return L.AurasTable[selectedAura].enable
											else
												return false
											end
										else
											return false
										end
									end,
									set = function(_, val)
										L.AurasTable[selectedAura].enable = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
						auras_stun_setup = {
							type = 'group',
							name = 'Setup CCs and taunts auras from all players on nameplate',
							inline = true,
							order = 5,
							hidden = function() return not L('aura_stun_show') end,
							args = {
								aura_stun_size_width = {
									type = 'range',
									name = 'CC aura icon width',
									desc = 'Width for CC aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.1,
									disabled = function() return not L('aura_stun_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_stun_size_width ~= val then
											L.config.aura_stun_size_width = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_stun_size_height = {
									type = 'range',
									name = 'CC aura icon height',
									desc = 'Height for CC aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.2,
									disabled = function() return not L('aura_stun_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_stun_size_height ~= val then
											L.config.aura_stun_size_height = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								spacer13 =  {
									type = "description", order = 1.3, name = " ", fontSize = "medium",
								},
								selectStun = {
									type = "select",
									name = "Select aura from ControlList",
									desc = 'Auras that will be displayed on nameplate from all players, with setuped border color.',
									order = 1.4,
									get = function(_)
										if not selectedStun then
											if not L.AurasList["Control"] then return end
											for filter in pairs(L.AurasList["Control"]) do
												selectedStun = filter
											end
											return selectedStun
										else
											return selectedStun
										end
									end,
									set = function(_, value)
										selectedStun = value
										L.colorStun = L.AurasList["Control"][value]
									end,
									values = function()
										local filters = {}
										local list = L.AurasList["Control"]
										if not list then return end
										for filter in pairs(list) do
											local r, g, b = unpack(L.AurasList["Control"][filter])
											local stringColor = format("ff%.2x%.2x%.2x", r * 255, g * 255, b * 255)
											filters[filter] = format("|c"..stringColor.."%s|r", filter)
										end
										if not next(filters) then filters[''] = NONE end
										return filters
									end,
								},
								addStun = {
									type = 'input',
									name = 'Add aura (by NAME)',
									desc = 'Add new aura to ControlList. Use aura name !!!',
									order = 1.5,
									get = function(_) return "" end,
									set = function(_, value)
										if value then
											L.AurasList["Control"][value] = {}
											L.AurasList["Control"][value] = {0, 1, 0, 1}
										end
									end,
								},
								removeStun = {
									type = 'execute',
									name = "|cffFF0000Delete|r",
									desc = "Remove selected aura from ControlList.",
									width = "half",
									order = 1.6,
									func = function()
										if L.AurasList["Control"][selectedStun] then
											L.AurasList["Control"][selectedStun] = nil;
											selectedStun = nil;
										end
									end,
									disabled = function() return not (selectedStun and selectedStun ~= "") end,
								},
								colorStun = {
									type = "color",
									name = "Color",
									hasAlpha = true,
									width = "half",
									order = 1.7,
									hidden = function() return not (selectedStun and selectedStun ~= "") end,
									get = function()
										if selectedStun then
											if L.AurasList["Control"][selectedStun] then
												return unpack(L.AurasList["Control"][selectedStun])
											else
												return {0, 1, 0, 1}
											end
										else
											return {0, 1, 0, 1}
										end
									end,
									set = function(_,...)
										L.AurasList["Control"][selectedStun] = {...}
									end,
								},
							},
						},
					},
				},
				buff_setup = {
					type = "group",
					order = 3,
					name = "Buff",
					args = {
						aura_buff_show = {
							type = 'toggle',
							name = 'Show buff auras',
							desc = 'Show buffs on nameplates. Enemy players buff is filtered by Enemy player aura filter..',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_buff_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						auras_buff_setup = {
							type = 'group',
							name = 'Setup buff auras (default over nameplate)',
							inline = true,
							order = 4,
							hidden = function() return not L('aura_buff_show') end,
							args = {
								aura_icon_buff_width = {
									type = 'range',
									name = 'Buff aura icon width',
									desc = 'Width for buff aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.1,
									disabled = function() return not L('aura_buff_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_buff_width ~= val then
											L.config.aura_icon_buff_width = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_buff_height = {
									type = 'range',
									name = 'Buff aura icon height',
									desc = 'Height for buff aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.2,
									disabled = function() return not L('aura_buff_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_buff_height ~= val then
											L.config.aura_icon_buff_height = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_buff_dispelable_size = {
									type = 'range',
									name = 'Dispelable aura size',
									desc = 'Increase aura size by this value is isStealable or dispelable for you.',
									min = 1,
									max = 2,
									step = 0.05,
									isPercent = true,
									order = 1.3,
									disabled = function() return not L('aura_buff_show') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_buff_dispelable_size ~= val then
											L.config.aura_icon_buff_dispelable_size = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_buff_max = {
									type = 'range',
									name = 'Max showed',
									desc = 'Max showed buff auras.',
									min = 1,
									max = 6,
									step = 1,
									order = 1.4,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_buff_max ~= val then
											L.config.aura_icon_buff_max = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_buff_Y = {
									type = 'range',
									name = 'Position Y',
									min = -30,
									max = 30,
									step = 1,
									order = 1.5,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_buff_Y ~= val then
											L.config.aura_buff_Y = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								spacer19 =  {
									type = "description", order = 1.9, name = "", fontSize = "small",
								},
								selectEPAura = {
									type = "select",
									name = "Enemy players aura filter",
									desc = "This auras will be displayed on nameplate when unit is player.",
									order = 2.1,
									get = function(_)
										if not selectedEPAura then
											if not L.AurasList["EnemyPlayer"] then return end
											for filter in pairs(L.AurasList["EnemyPlayer"]) do
												selectedEPAura = filter
											end
											return selectedEPAura
										else
											return selectedEPAura
										end
									end,
									set = function(_, value) selectedEPAura = value end,
									values = function()
										local filters = {}
										local list = L.AurasList["EnemyPlayer"]
										if not list then return end
										for filter in pairs(list) do
											filters[filter] = filter
										end
										if not next(filters) then filters[''] = NONE end
										return filters
									end,
								},
								addEPAura = {
									type = 'input',
									name = 'Add aura (by NAME)',
									desc = 'Add new aura to filter. Use aura name !!!',
									order = 2.2,
									get = function(_) return "" end,
									set = function(_, value)
										L.AurasList["EnemyPlayer"][value] = true
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								removeEPAura = {
									type = 'execute',
									name = "|cffFF0000Delete|r",
									desc = "Remove selected aura from filter.",
									width = "half",
									order = 2.3,
									func = function()
										if L.AurasList["EnemyPlayer"][selectedEPAura] then
											L.AurasList["EnemyPlayer"][selectedEPAura] = nil;
											selectedEPAura = nil;
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
									disabled = function() return not (selectedEPAura and selectedEPAura ~= "") end,
								},
								spacer29 =  {
									type = "description", order = 2.9, name = "", fontSize = "small",
								},
								selectNPCAura = {
									type = "select",
									name = "NPC aura filter",
									desc = "This auras will NOT be displayed on nameplate when unit is NPC.",
									order = 3.1,
									get = function(_)
										if not selectedNPCAura then
											if not L.AurasList["NPCBlackList"] then return end
											for filter in pairs(L.AurasList["NPCBlackList"]) do
												selectedNPCAura = filter
											end
											return selectedNPCAura
										else
											return selectedNPCAura
										end
									end,
									set = function(_, value) selectedNPCAura = value end,
									values = function()
										local filters = {}
										local list = L.AurasList["NPCBlackList"]
										if not list then return end
										for filter in pairs(list) do
											filters[filter] = filter
										end
										if not next(filters) then filters[''] = NONE end
											return filters
										end,
									},
								addNPCAura = {
									type = 'input',
									name = 'Add aura (by NAME)',
									desc = 'Add new aura to filter. Use aura name !!!',
									order = 3.2,
									get = function(_) return "" end,
									set = function(_, value)
										L.AurasList["NPCBlackList"][value] = true
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								removeNPCAura = {
									type = 'execute',
									name = "|cffFF0000Delete|r",
									desc = "Remove selected aura from filter.",
									width = "half",
									order = 3.3,
									func = function()
										if L.AurasList["NPCBlackList"][selectedNPCAura] then
											L.AurasList["NPCBlackList"][selectedNPCAura] = nil;
											selectedNPCAura = nil;
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
									disabled = function() return not (selectedNPCAura and selectedNPCAura ~= "") end,
								},
							},
						},
					},
				},
				self_setup = {
					type = "group",
					order = 4,
					name = "Self",
					args = {
						aura_self_show = {
							type = 'toggle',
							name = 'Show self auras',
							desc = 'Show self buffs on self nameplates.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.aura_self_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						auras_self_setup = {
							type = 'group',
							name = 'Setup self auras on self nameplate',
							inline = true,
							order = 4,
							hidden = function() return not L('aura_self_show') end,
							args = {
								aura_icon_self_width = {
									type = 'range',
									name = 'Self aura icon width',
									desc = 'Width for self aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_self_width ~= val then
											L.config.aura_icon_self_width = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_self_height = {
									type = 'range',
									name = 'Self aura icon height',
									desc = 'Height for self aura icons.',
									min = 10,
									max = 50,
									step = 1,
									order = 1.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_self_height ~= val then
											L.config.aura_icon_self_height = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_icon_self_max = {
									type = 'range',
									name = 'Max showed',
									desc = 'Max showed self auras.',
									min = 1,
									max = 6,
									step = 1,
									order = 1.4,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_icon_self_max ~= val then
											L.config.aura_icon_self_max = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								aura_self_Y = {
									type = 'range',
									name = 'position Y',
									min = -30,
									max = 30,
									step = 1,
									order = 1.5,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										if L.config.aura_self_Y ~= val then
											L.config.aura_self_Y = val
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
								},
								spacer19 =  {
									type = "description", order = 1.9, name = "", fontSize = "small",
								},
								selectSPAura = {
									type = "select",
									name = "Self player aura filter",
									desc = "This player auras will be displayed on self nameplate.",
									order = 3.1,
									get = function(_)
										if not selectedSPAura then
											if not L.AurasSelfPlayerList then return end
											for filter in pairs(L.AurasSelfPlayerList) do
												selectedSPAura = filter
											end
											return selectedSPAura
										else
											return selectedSPAura
										end
									end,
									set = function(_, value) selectedSPAura = value end,
									values = function()
										local filters = {}
										local list = L.AurasSelfPlayerList
										if not list then return end
										for filter in pairs(list) do
											if L.AurasSelfPlayerList[filter] then
												filters[filter] = format("|cFF00FF00%s|r", filter)
											else
												filters[filter] = format("|cFF808080%s|r", filter)
											end
										end
										if not next(filters) then filters[''] = NONE end
										return filters
									end,
								},
								addSPAura = {
									type = 'input',
									name = 'Add aura (by NAME)',
									desc = 'Add new aura to filter. Use aura name !!!',
									order = 3.2,
									get = function(_) return "" end,
									set = function(_, value) 
										L.AurasSelfPlayerList[value] = true
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								removeSPAura = {
									type = 'execute',
									name = "|cffFF0000Delete|r",
									desc = "Remove selected aura from filter.",
									width = "half",
									order = 3.3,
									func = function()
										if selectedSPAura then
											L.AurasSelfPlayerList[selectedSPAura] = nil;
											selectedSPAura = nil;
											namePlateMixin:UpdateNamePlateByOptions("nameplate")
										end
									end,
									disabled = function() return not (selectedSPAura and selectedSPAura ~= "") end,
								},
								showSPAura = {
									type = 'toggle',
									name = 'Enable',
									desc = 'Enable showing this aura on self nameplate.',
									width = "half",
									order = 3.4,
									hidden = function() return not (selectedSPAura and selectedSPAura ~= "") end,
									get = function(_)
										if selectedSPAura and L.AurasSelfPlayerList[selectedSPAura] then
											return L.AurasSelfPlayerList[selectedSPAura]
										else
											return false
										end
									end,
									set = function(_, val)
										L.AurasSelfPlayerList[selectedSPAura] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
					},
				},
			},
		},
		threat = {
			type = 'group',
			name = 'Threat setup',
			order = 10,
			args = {
				threat_value_setup = {
					type = 'group',
					name = 'Setup for extended threat (bar, text) setup',
					inline = true,
					order = 1,
					args = {
						threat_show = {
							type = 'toggle',
							name = 'Show threat',
							desc = 'Show threat on unit nameplate.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.threat_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						threat_show_as_bar = {
							type = 'toggle',
							name = 'Bar',
							desc = 'Show threat that bar or text on unit nameplate.',
							width = 'half',
							order = 1.2,
							disabled = function() return not L('threat_show') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.threat_show_as_bar = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						threat_show_onlyingroup = {
							type = 'toggle',
							name = 'In group',
							desc = 'Show threat bar or text value only if you are in group.',
							width = 'half',
							order = 1.3,
							disabled = function() return not L('threat_show') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
							L.config.threat_show_onlyingroup = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						threat_show_perc = {
							type = 'range',
							name = 'Percentage',
							desc = 'Show threat bar or value only if threat is highter that this value.',
							min = 0,
							max = 100,
							step = 1,
							order = 1.4,
							disabled = function() return not L('threat_show') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.threat_show_perc = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
					},
				},
				threat_flash_setup = {
					type = 'group',
					name = 'Extended setup for tanks.',
					inline = true,
					order = 2,
					args = {
						threat_flash = {
							type = 'toggle',
							name = 'Flash aggro',
							desc = 'Flash nameplate if you lose aggro',
							order = 1.5,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.threat_flash = val
							end,
						},
						threat_flash_time = {
							type = 'range',
							name = 'Flash time',
							min = 0.2,
							max = 2,
							step = 0.05,
							order = 1.6,
							disabled = function() return not L('threat_flash') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.threat_flash_time = val
							end,
						},
						threat_execute_value = {
							type = 'range',
							name = 'Execute range',
							desc = 'Change Securely tanking color to Execute color if unit is under this health points. Set to 0 disable this function and decrease number updates from threat.',
							min = 0,
							max = 1,
							step = .01,
							isPercent = true,
							order = 1.7,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.threat_execute_value = val
							end,
						},
					},
				},
				threat_colors_setup = {
					type = 'group',
					name = 'Setup colors by threat (for tanks spec)',
					inline = true,
					order = 3,
					args = {
						threat_color_noaggro = {
							type = "color",
							name = "No aggro",
							hasAlpha = true,
							width = 'half',
							order = 2.1,
							get = function() return unpack(L.config.threat_color_noaggro) end,
							set = function(_,...)
								L.config.threat_color_noaggro = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
						threat_color_1 = {
							type = "color",
							name = "Lower than tank",
							hasAlpha = true,
							width = 'half',
							order = 2.2,
							get = function() return unpack(L.config.threat_color_1) end,
							set = function(_,...)
								L.config.threat_color_1 = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
						threat_color_2 = {
							type = "color",
							name = "Higher than tank",
							hasAlpha = true,
							width = 'half',
							order = 2.3,
							get = function() return unpack(L.config.threat_color_2) end,
							set = function(_,...)
								L.config.threat_color_2 = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
						threat_color_3 = {
							type = "color",
							name = "Insecurely tanking",
							hasAlpha = true,
							width = 'half',
							order = 2.4,
							get = function() return unpack(L.config.threat_color_3) end,
							set = function(_,...)
								L.config.threat_color_3 = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
						threat_color_4 = {
							type = "color",
							name = "Securely tanking",
							hasAlpha = true,
							width = 'half',
							order = 2.5,
							get = function() return unpack(L.config.threat_color_4) end,
							set = function(_,...)
								L.config.threat_color_4 = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
						threat_color_offtank = {
							type = "color",
							name = "Off tank color",
							hasAlpha = true,
							width = 'half',
							order = 2.6,
							get = function() return unpack(L.config.threat_color_offtank) end,
							set = function(_,...)
								L.config.threat_color_offtank = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
						threat_color_execute = {
							type = "color",
							name = "Execute color",
							hasAlpha = true,
							width = 'half',
							order = 2.7,
							get = function() return unpack(L.config.threat_color_execute) end,
							set = function(_,...)
								L.config.threat_color_execute = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							 end,
						},
					},
				},
			},
		},
		extension = {
			type = 'group',
			name = "Extension",
			childGroups = "tab",
			inline = false,
			order = 12,
			args = {
				general = {
					type = "group",
					order = 1,
					name = "General",
					args = {
						menupanel = {
							type = 'toggle',
							name = 'Show menuPanel',
							desc = 'Enable or disable left side menuPanel.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.menupanel = val
								if L.config.menupanel then
									menuPanel:Show()
								else
									menuPanel:Hide()
								end
							end,
						},
						diminish_enable = {
							type = 'toggle',
							name = 'Diminish bar',
							desc = 'Enable or disable diminish bar setup and functions.',
							order = 1.3,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.diminish_enable = val
							end,
						},
						show_range = {
							type = 'toggle',
							name = 'Show range',
							desc = 'Show distance between player and unit on nameplate.',
							order = 1.4,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.show_range = val
								ButtonRange:SetButtonState(L.config.show_range and "PUSHED" or "NORMAL", L.config.show_range and true or false)
							end,
						},
						healer_detection = {
							type = 'toggle',
							name = 'Healer detection',
							desc = 'Show healer icon on nameplate if unit use predefined heal spell',
							order = 1.5,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.healer_detection = val
								namePlateMixin:UpdateNamePlateByOptions("healer_detection")
							end,
						},
						cut_scene = {
							type = 'toggle',
							name = 'Disable cutscene',
							desc = 'Enable or disable cutscene in wow, dont affected video.',
							order = 1.6,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.cut_scene = val
							end,
						},
						video_scene = {
							type = 'toggle',
							name = 'Disable video',
							desc = 'Enable or disable video in wow.',
							order = 1.7,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.video_scene = val
							end,
						},
						fizzle_sound = {
							type = 'toggle',
							name = 'Fizzle sound',
							desc = 'Enable or disable fizzle sound (spell is not on CD, ...).',
							order = 1.8,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.fizzle_sound = val
								if L.config.fizzle_sound then
									MuteSoundFile(569772)
									MuteSoundFile(569773)
									MuteSoundFile(569774)
									MuteSoundFile(569775)
									MuteSoundFile(569776)
								else
									UnmuteSoundFile(569772)
									UnmuteSoundFile(569773)
									UnmuteSoundFile(569774)
									UnmuteSoundFile(569775)
									UnmuteSoundFile(569776)
								end
							end,
						},
						spacer24 =  {
							type = "description", order = 2.4, name = " ", fontSize = "small",
						},	
						diminish_setup = {
							type = 'group',
							name = 'Setup for diminish bar.',
							inline = true,
							order = 5,
							hidden = function() return not L('diminish_enable') end,
							args = {
								diminish_type = {
									type = 'select',
									name = 'Selected diminish',
									desc = 'tank.',
									style = 'dropdown',
									order = 1.1,
									values = diminish_type_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.diminish_type = val
										namePlateMixin:UpdateNamePlateByOptions("colors")
									end,
								},
								diminish_spam_enable = {
									type = 'toggle',
									name = 'Enable chat spam',
									desc = 'Only for me, show who used stun ability.',
									order = 1.2,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.diminish_spam_enable = val
									end,
								},
								spacer14 = {
									type = "description", order = 1.4, name = " ", fontSize = "small",
								},
								diminish_color_1 = {
									type = "color",
									name = "First diminish",
									hasAlpha = true,
									order = 2.1,
									get = function() return unpack(L.config.diminish_color[1]) end,
									set = function(_,...)
										L.config.diminish_color[1] = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								diminish_color_2 = {
									type = "color",
									name = "Second diminish",
									hasAlpha = true,
									order = 2.2,
									get = function() return unpack(L.config.diminish_color[2]) end,
									set = function(_,...)
										L.config.diminish_color[2] = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								diminish_color_3 = {
									type = "color",
									name = "Third diminish",
									hasAlpha = true,
									order = 2.3,
									get = function() return unpack(L.config.diminish_color[3]) end,
									set = function(_,...)
										L.config.diminish_color[3] = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
						range_font_setup = {
							type = 'group',
							name = 'Range setup',
							inline = true,
							order = 8,
							hidden = function() return not L('show_range') end,
							args = {
								range_font = {
									type = "select",
									name = 'Range text font',
									dialogControl = 'LSM30_Font',
									order = 1.1,
									values = AceGUIWidgetLSMlists.font,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_font = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_fontsize = {
									type = 'range',
									name = 'Font size',
									min = 5,
									max = 30,
									step = 1,
									order = 1.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_fontsize = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_font_flag  = {
									type = 'select',
									name = 'Font flags',
									order = 1.3,
									style = 'dropdown',
									values = font_flags_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_font_flag  = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_font_color = {
									type = "color",
									name = "Color",
									hasAlpha = true,
									width = 'half',
									order = 1.4,
									get = function() return unpack(L.config.range_font_color); end,
									set = function(_,...)
										L.config.range_font_color = {...}
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_point = {
									type = 'select',
									name = 'Point',
									style = 'dropdown',
									order = 2.1,
									values = anchor_position_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_point  = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_relativePoint = {
									type = 'select',
									name = 'relativePoint',
									style = 'dropdown',
									order = 2.2,
									values = anchor_position_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_relativePoint  = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_format  = {
									type = 'select',
									name = 'Format',
									style = 'dropdown',
									order = 2.3,
									values = range_format_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_format  = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_posun_X = {
									type = 'range',
									name = 'HP position X',
									desc = 'Setup X position for healht points.',
									min = -20,
									max = 20,
									step = 1,
									order = 3.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_posun_X = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_posun_Y = {
									type = 'range',
									name = 'HP position Y',
									desc = 'Setup Y position for healht points.',
									min = -20,
									max = 20,
									step = 1,
									order = 3.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.range_posun_Y = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								range_only_on_target = {
									type = 'toggle',
									name = 'Target only',
									desc = 'Show distace only on target nameplate',
									--width = 'half',
									order = 3.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.range_only_on_target = val
										namePlateMixin:UpdateNamePlateByOptions("show_range")
									end,
								},
								
								
							},
						},
						healers_list_setup = {
							type = 'group',
							name = 'Healer detection setup',
							inline = true,
							order = 9,
							hidden = function() return not L('healer_detection') end,
							args = {
								healer_detection_sound = {
									name = 'Select sound',
									type = "select",
									dialogControl = 'LSM30_Sound',
									order = 1.1,
									disabled = function() return not L('healer_detection') end,
									values = AceGUIWidgetLSMlists.sound,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.healer_detection_sound = val
									end,
								},
								spacer12 = {
									type = "description", order = 1.2, name = " ", fontSize = "medium",
								},
								selectHSpell = {
									type = "select",
									name = "Select healer spell",
									order = 2.1,
									get = function(_) return selectedHealerSpell end,
									set = function(_, value) selectedHealerSpell = value end,
									values = function()
										local filters = {}
										local list = L.HealersSpellsList
										if not list then return end
										for filter in pairs(list) do
											filters[filter] = filter
										end
										if not next(filters) then filters[''] = NONE end
										return filters
									end,
								},
								addHSpell = {
									type = 'input',
									name = 'Add spell',
									desc = 'Add new healer spell to HealersSpellsList. Use spell name name !!!',
									order = 2.2,
									get = function(_) return "" end,
									set = function(_, value) L.HealersSpellsList[value] = true	end,
								},
								removeHSpell = {
									type = 'execute',
									name = "|cffFF0000Delete|r",
									desc = "Remove selected healer spell from HealersSpellsList.",
									width = 'half',
									order = 2.3,
									func = function()
										if L.HealersSpellsList[selectedHealerSpell] then
											L.HealersSpellsList[selectedHealerSpell] = nil;
											selectedHealerSpell = nil;
										end
									end,
									disabled = function() return not (selectedHealerSpell and selectedHealerSpell ~= "") end,
								},
							},
						},
					},
				},
				questsetup = {
					type = "group",
					order = 2,
					name = "Quest",
					args = {
						quest_detection = {
							type = 'toggle',
							name = 'Quest detection',
							desc = 'Enable quest detection.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_detection = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "medium",
						},
						quest_text = {
							type = 'toggle',
							name = 'Show quest text',
							desc = 'Show quest text on nameplate, if quest have only text is displayed regardless of this option.',
							order = 2.1,
							disabled = function() return not L('quest_detection') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_text = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_value = {
							type = 'toggle',
							name = 'Show quest value',
							desc = 'Show quest value under nameplate.',
							order = 2.2,
							disabled = function() return not L('quest_detection') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_value = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_value_full = {
							type = 'toggle',
							name = 'Value format',
							desc = 'Show quest progress that X/Y value, or only X.',
							order = 2.3,
							disabled = function() return not L('quest_detection') or not L('quest_value') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_value_full = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_icon = {
							type = 'toggle',
							name = 'Show quest icon',
							desc = 'Show quest mark on nameplate for me quests.',
							order = 2.4,
							disabled = function() return not L('quest_detection') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_icon = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_icon_extended = {
							type = 'toggle',
							name = 'Extended icons',
							desc = 'Show different quest mark by quest type.',
							order = 2.5,
							disabled = function() return not L('quest_detection') or not L('quest_icon') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_icon_extended = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_max_alpha = {
							type = 'toggle',
							name = 'Max alpha',
							desc = 'Show unit nameplate for quest with max alpha.',
							order = 2.6,
							disabled = function() return not L('quest_detection') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_max_alpha = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer29 =  {
							type = "description", order = 2.9, name = " ", fontSize = "medium",
						},
						quest_sound_enable = {
							type = 'toggle',
							name = 'Sound',
							desc = 'Play this sound file if quest is detected.',
							width = 'half',
							order = 3.1,
							disabled = function() return not L('quest_detection') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.quest_sound_enable = val
							end,
						},
						quest_sound = {
							type = "select",
							name = 'Select sound',
							dialogControl = 'LSM30_Sound',
							order = 3.2,
							disabled = function() return not L('quest_detection') or not L('quest_sound_enable') end,
							values = AceGUIWidgetLSMlists.sound,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.quest_sound = val
							end,
						},
						quest_icon_x = {
							type = 'range',
							name = 'Icon position X',
							min = -20,
							max = 20,
							step = 1,
							order = 3.3,
							disabled = function() return not L('quest_detection') or not L('quest_icon') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.quest_icon_x = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_icon_y = {
							type = 'range',
							name = 'Icon position Y',
							min = -20,
							max = 20,
							step = 1,
							order = 3.4,
							disabled = function() return not L('quest_detection') or not L('quest_icon') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.quest_icon_y = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						quest_icon_type_setup = {
							type = 'group',
							name = 'Quest icon type setup',
							inline = true,
							order = 4,
							disabled = function() return not L('quest_detection') or not L('quest_icon_extended') end,
							args = {
								quest_icon_1 = {
									type = 'toggle',
									name = 'Default : '..CreateAtlasMarkup("questlegendary", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.1,
									get = function() return L.config.quest_icon_type["default"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["default"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_2 = {
									type = 'toggle',
									name = 'Item : '..CreateAtlasMarkup("Banker", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.2,
									get = function() return L.config.quest_icon_type["item"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["item"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_3 = {
									type = 'toggle',
									name = 'Object : '..CreateAtlasMarkup("ChallengeMode-icon-chest", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.3,
									get = function() return L.config.quest_icon_type["object"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["object"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_4 = {
									type = 'toggle',
									name = 'Monster : '..CreateAtlasMarkup("jailerstower-scenario-skull3", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.4,
									get = function() return L.config.quest_icon_type["monster"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["monster"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},				
								quest_icon_5 = {
									type = 'toggle',
									name = 'Reputation : '..CreateAtlasMarkup("objectivewidget-icon-left", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.5,
									get = function() return L.config.quest_icon_type["reputation"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["reputation"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_6 = {
									type = 'toggle',
									name = 'Log : '..CreateAtlasMarkup("Callings-Available", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.6,
									get = function() return L.config.quest_icon_type["log"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["log"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_7 = {
									type = 'toggle',
									name = 'Event : '..CreateAtlasMarkup("titleprestige-starglow", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.7,
									get = function() return L.config.quest_icon_type["event"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["event"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_8 = {
									type = 'toggle',
									name = 'Player : '..CreateAtlasMarkup("trivialquests", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.8,
									get = function() return L.config.quest_icon_type["player"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["player"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_icon_9 = {
									type = 'toggle',
									name = 'Progressbar : '..CreateAtlasMarkup("vignetteloot", 22, 22),
									desc = 'Use this icon for quest.',
									order = 1.9,
									get = function() return L.config.quest_icon_type["progressbar"][2]; end,
									set = function(_, val)
										L.config.quest_icon_type["progressbar"][2] = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
						quest_font_setup = {
							type = 'group',
							name = 'Quest font setup',
							inline = true,
							order = 5,
							disabled = function() return not L('quest_detection') end,
							args = {
								quest_font = {
									type = 'select',
									name = 'Quest text font',
									dialogControl = 'LSM30_Font',
									order = 1.1,
									values = AceGUIWidgetLSMlists.font,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.quest_font = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_fontsize = {
									type = 'range',
									name = 'Quest text size',
									min = 2,
									max = 25,
									step = 1,
									order = 1.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.quest_fontsize = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_font_flag  = {
									type = 'select',
									name = 'Quest text flags',
									order = 1.3,
									style = 'dropdown',
									values = font_flags_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.quest_font_flag = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_color = {
									type = 'toggle',
									name = 'Name color',
									desc = 'Change name color for quest unit.',
									order = 1.4,
									disabled = function() return not L('quest_detection') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.quest_color = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								quest_name_color = {
									type = "color",
									name = "Color",
									hasAlpha = true,
									width = "half",
									order = 1.5,
									disabled = function() return not L('quest_detection') or not L('quest_color') end,
									get = function() return unpack(L.config.quest_name_color); end,
									set = function(_,...)
										L.config.quest_name_color = {...};
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
					},
				},
				raidmarks = {
					type = "group",
					order = 3,
					name = "Raid marks",
					args = {
						mark_animation = {
							type = 'toggle',
							name = 'Border animation',
							desc = 'Enable border animation for marked nameplates.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mark_animation = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_healthbar = {
							type = 'toggle',
							name = 'Healthbar color',
							desc = 'Change healthbar color for marked nameplates. Dont enable if you are tank, you lose thread color on health bar.',
							order = 1.2,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mark_healthbar = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_border = {
							type = 'toggle',
							name = 'Border color',
							desc = 'Change border color for marked nameplates.',
							order = 1.3,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mark_border = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_show = {
							type = 'toggle',
							name = 'Raid mark',
							desc = 'Enable disable raid mark on nameplates. Dont work if nameplate dont exist',
							order = 1.4,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mark_show = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_type = {
							type = 'select',
							name = 'Marks type',
							desc = 'Select raid mark type scheme',
							style = 'dropdown',
							order = 1.5,
							disabled = function() return not L('mark_show') end,
							values = mark_type_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mark_type = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_size = {
							type = 'range',
							name = 'Mark size',
							desc = 'Raid marks size.',
							min = 10,
							max = 40,
							step = 1,
							order = 1.6,
							disabled = function() return not L('mark_show') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								if L.config.mark_size ~= val then
									L.config.mark_size = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						mark_point = {
							type = 'select',
							name = 'Point',
							style = 'dropdown',
							order = 2.1,
							disabled = function() return not L('mark_show') end,
							values = anchor_position_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mark_point  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_relativePoint = {
							type = 'select',
							name = 'relativePoint',
							style = 'dropdown',
							order = 2.2,
							disabled = function() return not L('mark_show') end,
							values = anchor_position_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mark_relativePoint  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer23 =  {
							type = "description", order = 2.3, name = " ", fontSize = "small",
						},
						mark_posun_X = {
							type = 'range',
							name = 'position X',
							desc = 'Setup X position for raidMarks.',
							min = -20,
							max = 20,
							step = 1,
							order = 2.4,
							disabled = function() return not L('mark_show') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mark_posun_X = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_posun_Y = {
							type = 'range',
							name = 'position Y',
							desc = 'Setup Y position for raidMarks.',
							min = -20,
							max = 20,
							step = 1,
							order = 2.5,
							disabled = function() return not L('mark_show') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mark_posun_Y = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},						
						spacer29 =  {
							type = "description", order = 2.9, name = "", fontSize = "small",
						},
						mark_color_1 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.1,
							get = function() return unpack(L.config.mark_color[1]); end,
							set = function(_,...)
								L.config.mark_color[1] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_2 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_2:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.2,
							get = function() return unpack(L.config.mark_color[2]); end,
							set = function(_,...)
								L.config.mark_color[2] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_3 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.3,
							get = function() return unpack(L.config.mark_color[3]); end,
							set = function(_,...)
								L.config.mark_color[3] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_4 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_4:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.4,
							get = function() return unpack(L.config.mark_color[4]); end,
							set = function(_,...)
								L.config.mark_color[4] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_5 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.5,
							get = function() return unpack(L.config.mark_color[5]); end,
							set = function(_,...)
								L.config.mark_color[5] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_6 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_6:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.6,
							get = function() return unpack(L.config.mark_color[6]); end,
							set = function(_,...)
								L.config.mark_color[6] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_7 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.7,
							get = function() return unpack(L.config.mark_color[7]); end,
							set = function(_,...)
								L.config.mark_color[7] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mark_color_8 = {
							type = "color",
							name = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:14:14|t",
							hasAlpha = true,
							width = 'half',
							order = 3.8,
							get = function() return unpack(L.config.mark_color[8]); end,
							set = function(_,...)
								L.config.mark_color[8] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
					},
				},
				creature = {
					type = "group",
					order = 4,
					name = "Creature icons",
					args = {
						creature_icon_enable = {
							type = 'toggle',
							name = 'Enable extension',
							desc = 'Enable or disable creature icons. (boss, rare, elite, ....)',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.creature_icon_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "small",
						},
						creature_icon_point = {
							type = 'select',
							name = 'Point',
							style = 'dropdown',
							order = 2.1,
							disabled = function() return not L('creature_icon_enable') end,
							values = anchor_position_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.creature_icon_point  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_icon_relativePoint = {
							type = 'select',
							name = 'relativePoint',
							style = 'dropdown',
							order = 2.2,
							disabled = function() return not L('creature_icon_enable') end,
							values = anchor_position_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.creature_icon_relativePoint  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer29 =  {
							type = "description", order = 2.9, name = " ", fontSize = "small",
						},
						creature_icon_posun_X = {
							type = 'range',
							name = 'position X',
							desc = 'Setup X position for raidMarks.',
							min = -20,
							max = 20,
							step = 1,
							order = 3.1,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.creature_icon_posun_X = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_icon_posun_Y = {
							type = 'range',
							name = 'position Y',
							desc = 'Setup Y position for raidMarks.',
							min = -20,
							max = 20,
							step = 1,
							order = 3.2,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.creature_icon_posun_Y = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},						
						spacer39 =  {
							type = "description", order = 3.9, name = "", fontSize = "small",
						},
						creature_new_style = {
							type = 'toggle',
							name = 'Creature type icon',
							desc = 'Show creature icons by creature type (undead, humanoid, ...), or by clasification type (boss, rare, ...).',
							order = 4.1,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.creature_new_style = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer49 =  {
							type = "description", order = 4.9, name = " ", fontSize = "small",
						},
						creature_boss_enable = {
							type = 'toggle',
							name = 'Boss icon',
							desc = 'Show icon on boss units.',
							order = 5.1,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.creature_boss_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_color_boss = {
							type = "color",
							name = "Boss color",
							hasAlpha = true,
							order = 5.2,
							disabled = function() return not L('creature_icon_enable') or not L('creature_boss_enable') end,
							get = function() return unpack(L.config.creature_color["boss"]) end,
							set = function(_,...)
								L.config.creature_color["boss"] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_size_boss = {
							type = 'range',
							name = 'Boss icon size',
							desc = '',
							min = 8,
							max = 25,
							step = 1,
							order = 5.3,
							disabled = function() return not L('creature_icon_enable') or not L('creature_boss_enable') end,
							get = function() return L.config.creature_size["boss"] end,
							set = function(_, val)
								if L.config.creature_size["boss"] ~= val then
									L.config.creature_size["boss"] = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						creature_rare_enable = {
							type = 'toggle',
							name = 'Rare icon',
							desc = 'Show icon on rare units.',
							order = 6.1,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.creature_rare_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_color_rare = {
							type = "color",
							name = "Rare color",
							hasAlpha = true,
							order = 6.2,
							disabled = function() return not L('creature_icon_enable') or not L('creature_rare_enable') end,
							get = function() return unpack(L.config.creature_color["rare"]) end,
							set = function(_,...)
								L.config.creature_color["rare"] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_size_rare = {
							type = 'range',
							name = 'Rare icon size',
							desc = '',
							min = 8,
							max = 25,
							step = 1,
							order = 6.3,
							disabled = function() return not L('creature_icon_enable') or not L('creature_rare_enable') end,
							get = function() return L.config.creature_size["rare"] end,
							set = function(_, val)
								if L.config.creature_size["rare"] ~= val then
									L.config.creature_size["rare"] = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						creature_elite_enable = {
							type = 'toggle',
							name = 'Elite icon',
							desc = 'Show icon on elite units.',
							order = 7.1,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.creature_elite_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_color_elite = {
							type = "color",
							name = "Elite color",
							hasAlpha = true,
							order = 7.2,
							disabled = function() return not L('creature_icon_enable') or not L('creature_elite_enable') end,
							get = function() return unpack(L.config.creature_color["elite"]) end,
							set = function(_,...)
								L.config.creature_color["elite"] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_size_elite = {
							type = 'range',
							name = 'Elite icon size',
							desc = '',
							min = 8,
							max = 25,
							step = 1,
							order = 7.3,
							disabled = function() return not L('creature_icon_enable') or not L('creature_elite_enable') end,
							get = function() return L.config.creature_size["elite"] end,
							set = function(_, val)
								if L.config.creature_size["elite"] ~= val then
									L.config.creature_size["elite"] = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
						creature_other_enable = {
							type = 'toggle',
							name = 'Other icon',
							desc = 'Show icon on others units.',
							order = 8.1,
							disabled = function() return not L('creature_icon_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.creature_other_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_color_other = {
							type = "color",
							name = "Other color",
							hasAlpha = true,
							order = 8.2,
							disabled = function() return not L('creature_icon_enable') or not L('creature_other_enable') end,
							get = function() return unpack(L.config.creature_color["other"]) end,
							set = function(_,...)
								L.config.creature_color["other"] = {...}
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						creature_size_other = {
							type = 'range',
							name = 'Other icon size',
							desc = '',
							min = 8,
							max = 25,
							step = 1,
							order = 8.3,
							disabled = function() return not L('creature_icon_enable') or not L('creature_other_enable') end,
							get = function() return L.config.creature_size["other"] end,
							set = function(_, val)
								if L.config.creature_size["other"] ~= val then
									L.config.creature_size["other"] = val
									namePlateMixin:UpdateNamePlateByOptions("nameplate")
								end
							end,
						},
					},
				},
				GCDframe = {
					type = "group",
					order = 5,
					name = "GCD frame",
					args = {
						gcd_showSpellActivity = {
							type = 'toggle',
							name = 'Enable GCD frame',
							desc = 'Show player spell activity on personal bar.',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.gcd_showSpellActivity = val
								namePlateMixin:UpdateSelfNamePlate()
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = "", fontSize = "small",
						},
						gcd_anim_speed = {
							type = 'range',
							name = 'Speed',
							desc = 'Animation speed',
							min = 0.1,
							max = 1,
							step = 0.05,
							order = 2.1,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.gcd_anim_speed = val
							end,
						},
						gcd_anim_duration = {
							type = 'range',
							name = 'Duration',
							desc = 'Animation duration',
							min = 1,
							max = 8,
							step = 1,
							order = 2.2,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.gcd_anim_duration = val
							end,
						},
						gcd_anim_max = {
							type = 'range',
							name = 'Max showed spells',
							desc = 'Max showed spells in row.',
							min = 2,
							max = 10,
							step = 1,
							order = 2.3,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.gcd_anim_max = val
							end,
						},
						gcd_anim_icon_size = {
							type = 'range',
							name = 'Icon size',
							desc = 'Set icon size.',
							min = 15,
							max = 40,
							step = 1,
							order = 2.4,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.gcd_anim_icon_size = val
							end,
						},
						gcd_anim_icon_scale = {
							type = 'range',
							name = 'Icon scale',
							desc = 'Set scale for first spell icon.',
							min = 1,
							max = 5,
							step = .05,
							order = 2.5,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.gcd_anim_icon_scale = val
							end,
						},
						spacer29 =  {
							type = "description", order = 2.9, name = "", fontSize = "small",
						},
						selectBLSpell = {
							type = "select",
							name = "BlackList",
							desc = 'Spells in Blacklist dont be used for GCD frame animation.',
							width = "double",
							order = 3.1,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = function(_) return selectedBLSpell end,
							set = function(_, value)
								selectedBLSpell = tonumber(value)
							end,
							values = function()
								local filters = {}
								local list = L.BlackListSpellTable
								if not list then return end
								for filter in pairs(list) do
									local spellName = GetSpellInfo(tonumber(filter))
									if spellName then
										filters[filter] = format("%s (%s)", spellName, filter)
									else
										filters[filter] = format("%s (%s)", "|cffFF0000Dont exist in 9.0.1|r", filter)
									end
								end
								if not next(filters) then filters[''] = NONE end
								return filters
							end,
						},
						addBLSpell = {
							type = 'input',
							name = 'Add spellID',
							desc = 'Add new spellID to BlackList!!!',
							order = 3.2,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = function(_) return "" end,
							set = function(_, value)
								if tonumber(value) then
									local spellID = tonumber(value)
									if spellID < 2147483648 then
										local name = GetSpellInfo(spellID)
										if name	then
											L.BlackListSpellTable[spellID] = name
											print("|cff00bbffSpell |r|cffcccccc"..name.."|r |cff808080("..spellID..")|r |cff00bbffhas been added to BlackList database.|r")
										else
											print("|cffFF0000Incorrect spellID!!!|r")
										end
									else
										print("|cffFF0000Incorrect spellID, number is to high!!|r")
									end
								else
									print("|cffFF0000Incorrect spellID, it is rly hard using correct number?|r")
								end
							end,
						},
						removeBLSpell = {
							type = 'execute',
							name = "|cffFF0000Delete|r",
							desc = "Remove selected spellID from BlackList.",
							width = "half",
							order = 3.3,
							disabled = function() return not L('gcd_showSpellActivity') end,
							func = function()
								if L.BlackListSpellTable[selectedBLSpell] then
									local name = GetSpellInfo(selectedBLSpell)
									print("|cff00bbffSpell |r|cffcccccc"..name.."|r |cff808080("..selectedBLSpell..")|r |cff00bbffhas been removed from BlackList database.|r")
									L.BlackListSpellTable[selectedBLSpell] = nil
									selectedBLSpell = nil
								end
							end,
							disabled = function() return not (selectedBLSpell and selectedBLSpell ~= "") end,
						},
						gcd_showSpellActivity_spam = {
							type = 'toggle',
							name = 'Spam spellID',
							desc = 'Your used ability start spam spellID to chat frame (only for player).',
							order = 3.4,
							disabled = function() return not L('gcd_showSpellActivity') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.gcd_showSpellActivity_spam = val
							end,
						},
					},
				},
				classframe = {
					type = "group",
					order = 6,
					name = "Class setup",
					args = {
						selectClass = {
							type = "select",
							name = "Class",
							desc = 'Select class for setup.',
							order = 1.1,
							get = function(_)
								if not selectedClass then
									for i=1, #CLASS_SORT_ORDER do
										local className, classFile, classID = GetClassInfo(i)
										if classFile == L.config.selfPlayerInfo.myClass then
											selectedSpec = L.config.selfPlayerInfo.mySpec
											return i
										end
									end
								else
									return selectedClass
								end
							end,
							set = function(_, value)
								selectedClass = value
								selectedSpec = 1
							end,
							values = function()
								local filters = {}
								
								for i=1, #CLASS_SORT_ORDER do
									local className, classFile, classID = GetClassInfo(i)
									local classColor = RAID_CLASS_COLORS[classFile]
									filters[i] = format("%s", "|c" .. classColor.colorStr .. classFile .."|r")
								end
								
								return filters
							end,
						},
						selectSpec = {
							type = "select",
							name = "Specialization",
							desc = 'Select specialization for setup.',
							order = 1.2,
							get = function(_)
								if not selectedSpec then
									selectedSpec = L.config.selfPlayerInfo.mySpec
									return L.config.selfPlayerInfo.mySpec
								else
									return selectedSpec
								end
							end,
							set = function(_, value)
								selectedSpec = tonumber(value)
							end,
							values = function()
								local filters = {}
								if not selectedClass then
									for i=1, #CLASS_SORT_ORDER do
										local className, classFile, classID = GetClassInfo(i)
										if classFile == L.config.selfPlayerInfo.myClass then
											selectedClass = i
										end
									end
								end
								for filter in pairs(L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))]) do
									local id, name, description, icon, role, isRecommended, isAllowed = GetSpecializationInfoForClassID(selectedClass, filter)
									if name then
										filters[filter] = format("%s", name)
									end
								end
								
								return filters
							end,
						},
						class_kickspell_setup = {
							type = 'group',
							name = 'Kick spell setup',
							inline = true,
							order = 4,
							args = {
								class_kickspell = {
									type = 'input',
									name = 'Kick spell name',
									desc = 'Set kick ability spell name for this class and specialization.',
									order = 1.1,
									get = function(_)
										--if not selectedSpec then
										--	selectedSpec = L.config.selfPlayerInfo.mySpec
										--end
										--print(selectedClass,selectedSpec)
										return L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].kickSpell
									end,
									set = function(_, value)
										L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].kickSpell = value
									end,
								},
								spacer29 =  {
									type = "description",
									order = 2.1,
									name = '\n|cff808080* This setting is used in Cast bar > Show kick CD for showing your kick spell CD in cast bar.|r',
									fontSize = "small",
								},
							},
						},
						class_dispel_setup = {
							type = 'group',
							name = 'Class dispel setup',
							inline = true,
							order = 5,
							args = {
								class_dispel = {
									type = 'toggle',
									name = 'Show dispel',
									desc = 'Change border color for party player if is posible for your dispell.',
									order = 1.1,
									get = function(_)
										return L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.classHasDispell
									end,
									set = function(_, val)
										L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.classHasDispell = val
										classBarMixin:UpdateClassBar()
									end,
								},
								class_magic = {
									type = 'toggle',
									name = 'Magic',
									desc = 'Enable if this class and secialization have friendly magic dispel.',
									width = 'half',
									order = 1.2,
									disabled = function() return not L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.classHasDispell end,
									get = function(_)
										return L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Magic
									end,
									set = function(_, val)
										L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Magic = val
									end,
								},
								class_curse = {
									type = 'toggle',
									name = 'Curse',
									desc = 'Enable if this class and secialization have friendly curse dispel.',
									width = 'half',
									order = 1.3,
									disabled = function() return not L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.classHasDispell end,
									get = function(_)
										return L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Curse
									end,
									set = function(_, val)
										L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Curse = val
									end,
								},
								class_disease = {
									type = 'toggle',
									name = 'Disease',
									desc = 'Enable if this class and secialization have friendly disease dispel.',
									width = 'half',
									order = 1.4,
									disabled = function() return not L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.classHasDispell end,
									get = function(_)
										return L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Disease
									end,
									set = function(_, val)
										L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Disease = val
									end,
								},
								class_poison = {
									type = 'toggle',
									name = 'Poison',
									desc = 'Enable if this class and secialization have friendly poison dispel.',
									width = 'half',
									order = 1.5,
									disabled = function() return not L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.classHasDispell end,
									get = function(_)
										return L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Poison
									end,
									set = function(_, val)
										L.config.selfPlayerInfo[select(2, GetClassInfo(selectedClass))][selectedSpec].dispelableDebuffTable.Poison = val
									end,
								},
								spacer29 =  {
									type = "description",
									order = 2.1,
									name = '\n|cff808080* This setting is used in Resource Bar > Party Health Bars for colorize party health bar border if is dispelable by you.|r',
									fontSize = "small",
								},
							},
						},
						class_monk = {
							type = 'group',
							name = 'Monk',
							inline = true,
							order = 8,
							hidden = function()
								local className, classFile, classID = GetClassInfo(selectedClass)
								if classFile == "MONK" then
									return false
								else
									return true
								end
							end,
							args = {
								classSpell_ToD = {
									type = 'toggle',
									name = 'Touch of Death',
									desc = 'Set health bar color by spell Touch of Death',
									order = 1.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.classSpell_ToD = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								classSpell_ToD_color = {
									type = "color",
									name = "Color",
									desc = 'Select color when Touch of Death is ready for use.',
									hasAlpha = true,
									width = 'half',
									order = 1.2,
									disabled = function() return not L.config.classSpell_ToD end,
									get = function() return unpack(L.config.classSpell_ToD_color) end,
									set = function(_,...)
										L.config.healthbar_class_spell_execute_color = {...}
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
						class_warrior = {
							type = 'group',
							name = 'Warrior',
							inline = true,
							order = 9,
							hidden = function()
								local _, classFile = GetClassInfo(selectedClass)
								if classFile == "WARRIOR" then
									return false
								else
									return true
								end
							end,
							args = {	
								classSpell_SR = {
									type = 'toggle',
									name = 'Spell Reflect',
									desc = 'For warrior check if Spell Reflect is ready',
									order = 1.1,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.classSpell_SR = val
									end,
								},
								classSpell_SR_sound_file = {
									type = "select",
									name = 'Select sound',
									dialogControl = 'LSM30_Sound',
									order = 1.2,
									disabled = function() return not L('classSpell_SR') end,
									values = AceGUIWidgetLSMlists.sound,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.classSpell_SR_sound_file = val
									end,
								},
								classSpell_SR_odkaz = {
									type = 'input',
									name = 'Spell reflect table spreadsheets',
									desc = '',
									width = 'full',
									order = 1.3,
									get = function(_)
										return "https://docs.google.com/spreadsheets/d/e/2PACX-1vQgrszRE22Brb0f5k761vUXVe7MD1-qHThpalxzn0zWFRdQqrh0hM5LcQNoa-lLz4781S5rH2e9tRXG/pubhtml#"
									end,
									set = function(_, value)
									end,
								},
							},
						},
					},
				},
			},
		},
		M_plus = {
			type = 'group',
			name = "M+ Setup",
			childGroups = "tab",
			inline = false,
			order = 13,
			args = {
				general_setup = {
					type = "group",
					order = 1,
					name = "General",
					args = {
						mythic_plus_enable = {
							type = 'toggle',
							name = 'M+ extensions',
							desc = 'Enable or Disable all mythic extensions in M+',
							order = 1.1,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_plus_enable = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer13 =  {
							type = "description", order = 1.3, name = " ", fontSize = "medium",
						},
						mythic_kicker_prediction = {
							type = 'toggle',
							name = 'Kicker prediction',
							desc = 'Enable kicker prediction functions and setup.',
							order = 1.4,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_kicker_prediction = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_percent_show = {
							type = 'toggle',
							name = 'Show % value',
							desc = 'Show percentage value on NPC nameplate in M+ challenges.',
							order = 1.7,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_percent_show = val
								ButtonValue:SetButtonState(L.config.mythic_percent_show and "PUSHED" or "NORMAL", L.config.mythic_percent_show and true or false)
							end,
						},
						mythic_desc = {
							type = 'toggle',
							name = 'Description',
							desc = 'Enable NPC description on nameplate.',
							order = 1.8,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_desc = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_scale = {
							type = 'toggle',
							name = 'Scale',
							desc = 'Enable change scale function for NPC in M+.',
							order = 1.9,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_scale = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_sound = {
							type = 'toggle',
							name = 'Enable sounds',
							desc = 'Enable sounds effect function when NPC nameplate is showed.',
							order = 2.0,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_sound = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_colored = {
							type = 'toggle',
							name = 'Enable colors',
							desc = 'Enable color function for NPC name in nameplate.',
							order = 2.1,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_colored = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_stack_bolster = {
							type = 'toggle',
							name = 'Stack Bolster',
							desc = 'Show multiple Bolster auras that one with count.',
							order = 2.2,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_stack_bolster = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_push_key = {
							type = 'toggle',
							name = 'Insert key',
							desc = 'Push key to challenging window slot, if you are owner.',
							order = 2.3,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_push_key = val
							end,
						},
						mythic_NPC_infoPanel = {
							type = 'toggle',
							name = 'NPC infoPanel',
							desc = 'Show NPC infoPanel in M+ Dungeons',
							order = 2.4,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_NPC_infoPanel = val
								if not L.config.mythic_NPC_infoPanel then
									npcInfoPanelMixin:HideNPCInfoPanel()
								else
									namePlateMixin:UpdateMyTarget()
								end
							end,
						},
						mythic_text_panel_unlock = {
							type = 'toggle',
							name = 'Unlock textPanel',
							desc = 'Unlock textPanel and change his position.',
							order = 2.6,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_text_panel_unlock = val
								if L.config.mythic_text_panel_unlock then
									textPanelMixin:ShowText(LMB.."- move "..RMB.."- save")
									textPanel:EnableMouse(true)
								else
									textPanel:EnableMouse(false)
									textPanelText:SetText(nil)
									textPanel:Hide()
								end
							end,
						},
						myhtic_mark_setup = {
							type = 'group',
							name = 'Setup for marking function',
							inline = true,
							order = 3,
							args = {
								mythic_auto_mark = {
									type = 'toggle',
									name = 'Enable auto marking',
									desc = 'Addon marking predefined units when start combat in M+ dungeons.',
									order = 1.1,
									disabled = function() return not L('mythic_plus_enable') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_auto_mark = val
										ButtonAutoMark:SetButtonState(L.config.mythic_auto_mark and "PUSHED" or "NORMAL", L.config.mythic_auto_mark and true or false)
									end,
								},
								mythic_auto_mark_groupleader = {
									type = 'toggle',
									name = 'Only group leader',
									desc = 'Only if you are group leader',
									order = 1.2,
									disabled = function() return not L('mythic_plus_enable') or not L('mythic_auto_mark') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_auto_mark_groupleader = val
									end,
								},
								mythic_mark_maxDistance = {
									type = 'range',
									name = 'Max marks distance',
									desc = 'Max distance for marking predefined units.',
									min = 0,
									max = 100,
									step = 1,
									order = 1.3,
									disabled = function() return not L('mythic_plus_enable') end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_mark_maxDistance = val
									end,
								},
							},
						},
						mythic_kicker_prediction_setup = {
							type = 'group',
							name = 'Kicker prediction setup',
							inline = true,
							order = 4,
							hidden = function() return not L('mythic_kicker_prediction') end,
							disabled = function() return not L('mythic_plus_enable') end,
							args = {
								mythic_kicker_bar_show = {
									type = 'toggle',
									name = 'Show kick CD bar',
									desc = 'Show predicted CD bar on specific nameplates. In M+ Database enable kick bar on NPC .',
									order = 1.1,
									disabled = function() return not L('mythic_plus_enable') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_kicker_bar_show = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
								mythic_kicker_mark_show = {
									type = 'toggle',
									name = 'Mark NPC',
									desc = 'Mark nameplate with predefined mark (config.lua, L.inperruptSpellTable, mark = XX) by new predicted kicker. Only if you are group leader',
									order = 1.2,
									disabled = function() return not L('mythic_plus_enable') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_kicker_mark_show = val
									end,
								},
								mythic_kicker_mark_groupleader = {
									type = 'toggle',
									name = 'Only group leader',
									desc = 'Only if you are group leader',
									order = 1.3,
									disabled = function() return not L('mythic_plus_enable') or not L('mythic_kicker_mark_show') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_kicker_mark_groupleader = val
									end,
								},
								mythic_kicker_info_show = {
									type = 'toggle',
									name = 'Info panel',
									desc = 'When anyone in party use kick ability, search and show new predicted kicker in infoPanel window.',
									order = 1.4,
									disabled = function() return not L('mythic_plus_enable') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_kicker_info_show = val
									end,
								},
								mythic_kicker_no_long_CD = {
									type = 'toggle',
									name = 'Remove long CD',
									desc = 'Remove Shadow priest and Boomkin from prediction.',
									order = 1.5,
									disabled = function() return not L('mythic_plus_enable') end,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_kicker_no_long_CD = val
										namePlateMixin:UpdateNamePlateByOptions("nameplate")
									end,
								},
							},
						},
						mythic_percent_font_setup = {
							type = 'group',
							name = 'Font setup for M+ value',
							inline = true,
							order = 8,
							disabled = function() return not L('mythic_plus_enable') end,
							hidden = function() return not L('mythic_percent_show') end,
							args = {
								mythic_percent_font = {
									type = "select",
									name = 'Font name',
									dialogControl = 'LSM30_Font',
									order = 1.1,
									values = AceGUIWidgetLSMlists.font,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_percent_font = val
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
								mythic_percent_fontsize = {
									type = 'range',
									name = 'Font size',
									min = 2,
									max = 25,
									step = 1,
									order = 1.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_percent_fontsize = val
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
								
								mythic_percent_font_flag  = {
									type = 'select',
									name = 'Font flag',
									style = 'dropdown',
									order = 1.3,
									values = font_flags_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_percent_font_flag  = val
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
								mythic_percent_color = {
									type = "color",
									name = "Color",
									hasAlpha = true,
									width = "half",
									order = 1.4,
									get = function() return unpack(L.config.mythic_percent_color); end,
									set = function(_,...)
										L.config.mythic_percent_color = {...};
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
							},
						},
						mythic_desc_font_setup = {
							type = 'group',
							name = 'Font setup for description text',
							inline = true,
							order = 9,
							disabled = function() return not L('mythic_plus_enable') end,
							hidden = function() return not L('mythic_desc') end,
							args = {
								mythic_desc_font = {
									type = "select",
									name = 'Font name',
									dialogControl = 'LSM30_Font',
									order = 1.1,
									values = AceGUIWidgetLSMlists.font,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_desc_font = val
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
								mythic_desc_fontsize = {
									type = 'range',
									name = 'Font size',
									min = 2,
									max = 25,
									step = 1,
									order = 1.2,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_desc_fontsize = val
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
								mythic_desc_font_flag  = {
									type = 'select',
									name = 'Font flag',
									style = 'dropdown',
									order = 1.3,
									values = font_flags_table,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_desc_font_flag  = val
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
								mythic_desc_color = {
									type = "color",
									name = "Color",
									hasAlpha = true,
									width = "half",
									order = 1.4,
									get = function() return unpack(L.config.mythic_desc_color); end,
									set = function(_,...)
										L.config.mythic_desc_color = {...};
										namePlateMixin:UpdateNamePlateByOptions("mythic")
									end,
								},
							},
						},
					},
				},
				mythic_spell_warning = {
					type = "group",
					order = 2,
					name = "Spell warnings",
					disabled = function() return not L('mythic_plus_enable') end,
					args = {
						mythic_target_warning = {
							type = 'toggle',
							name = 'Spell cast warning',
							desc = 'Enable warnings if player is target for spell cast',
							order = 1.1,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_target_warning = val
							end,
						},
						mythic_focus_warning  = {
							type = 'toggle',
							name = 'Focus cast warning',
							desc = 'Play this sound file if your focus unit cast spell from M+ Database with enabled sound warning and is interruptible.',
							order = 1.2,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_focus_warning  = val
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "medium",
						},
						mythic_target_cast_setup = {
							type = 'group',
							name = 'Setup warnings if player is target for spell cast',
							inline = true,
							order = 2,
							hidden = function() return not L('mythic_target_warning') end,
							disabled = function() return not L('mythic_plus_enable') end,
							args = {
								mythic_target_show_all = {
									type = 'toggle',
									name = 'Target name',
									desc = 'Show target name for tracking spell cast all time. Font setup is from castbar kickername setup.',
									order = 1.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_show_all = val
									end,
								},
								mythic_target_cast_sound = {
									type = 'toggle',
									name = 'Play sound',
									desc = 'Play sound warning if i am target for tested spell cast enabled in M+ Database.',
									order = 1.2,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_cast_sound = val
									end,
								},
								mythic_target_cast_sound_file = {
									name = 'Select sound',
									type = "select",
									dialogControl = 'LSM30_Sound',
									order = 1.3,
									values = AceGUIWidgetLSMlists.sound,
									style = "dropdown",
									disabled = function() return not L('mythic_target_cast_sound') or not L('mythic_plus_enable')end,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_cast_sound_file  = val
									end,
								},
								mythic_target_cast_mark = {
									type = 'toggle',
									name = 'Skull mark',
									desc = 'Set skull mark on me if i am target for tested spell cast enabled in M+ Database.',
									order = 1.4,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_cast_mark = val
									end,
								},
								mythic_target_say = {
									type = 'toggle',
									name = 'Enable SPAM',
									desc = 'Say text TARGET ME! if i am target for tested spell cast enabled in M+ Database.',
									order = 1.5,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_say = val
									end,
								},
								mythic_target_text = {
									type = 'input',
									name = "Text",
									desc = "Say this text if you are target.",
									order = 1.6,
									disabled = function() return not L('mythic_target_say') or not L('mythic_plus_enable')end,
									get = function(_)
										return L.config.mythic_target_text
									end,
									set = function(_, value)
										L.config.mythic_target_text = value
									end,
								},
								mythic_target_flash = {
									type = 'toggle',
									name = 'Flash screen',
									desc = 'Flash screen if i am target for tested spell cast enabled in M+ Database.',
									order = 1.7,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_flash = val
									end,
								},
								mythic_target_flash_color = {
									type = "color",
									width = "half",
									name = "Color",
									hasAlpha = true,
									order = 1.8,
									disabled = function() return not L('mythic_target_flash') or not L('mythic_plus_enable')end,
									get = function() return unpack(L.config.mythic_target_flash_color); end,
									set = function(_,...)
										L.config.mythic_target_flash_color = {...};
									end,
								},
								mythic_target_flash_speed = {
									type = 'range',
									name = 'Flash speed',
									min = .1,
									max = .4,
									step = .01,
									order = 1.9,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_flash_speed = val
									end,
								},
								mythic_target_flash_test = {
									type = 'execute',
									name = 'Flash test',
									order = 2.0,
									func = function()
										myFlashFrame.bg:SetVertexColor(unpack(L.config.mythic_target_flash_color))
										UIFrameFlash(myFlashFrame, L.config.mythic_target_flash_speed, L.config.mythic_target_flash_speed, 4 * L.config.mythic_target_flash_speed, false)
									end,
								},
								mythic_target_cb_border = {
									type = 'toggle',
									name = 'Cast bar border',
									desc = 'Change cast bar border, if i am target for tested spell cast enabled in M+ Database.',
									order = 2.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_cb_border = val
									end,
								},
								mythic_target_cb_border_color = {
									type = "color",
									width = "half",
									name = "Color",
									hasAlpha = true,
									order = 2.2,
									disabled = function() return not L('mythic_target_cb_border') or not L('mythic_plus_enable')end,
									get = function() return unpack(L.config.mythic_target_cb_border_color); end,
									set = function(_,...)
										L.config.mythic_target_cb_border_color = {...};
									end,
								},
								mythic_target_maxAlpha = {
									type = 'toggle',
									name = 'Max alpha',
									desc = 'Set max alpha for nameplate if cast to you.',
									order = 2.3,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_target_maxAlpha = val
									end,
								},
							},
						},
						mythic_focus_cast_setup = {
							type = 'group',
							name = 'Setup warnings if focus unit cast interruptible spell.',
							inline = true,
							order = 3,
							hidden = function() return not L('mythic_focus_warning') end,
							disabled = function() return not L('mythic_plus_enable') end,
							args = {
								mythic_focus_sound_file = {
									name = 'Select sound',
									type = "select",
									dialogControl = 'LSM30_Sound',
									order = 1.1,
									values = AceGUIWidgetLSMlists.sound,
									style = "dropdown",
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_focus_sound_file  = val
									end,
								},
								spacer13 =  {
									type = "description", order = 1.3, name = " ", fontSize = "medium",
								},
								mythic_focus_flash = {
									type = 'toggle',
									name = 'Flash screen',
									desc = 'Flash screen if your focus unit cast spell from M+ Database with enabled sound warning and is interruptible.',
									order = 2.1,
									get = L.GetFromSavedVariabiles,
									set = function(_, val)
										L.config.mythic_focus_flash = val
									end,
								},
								mythic_focus_flash_color = {
									type = "color",
									width = "half",
									name = "Color",
									hasAlpha = true,
									order = 2.2,
									disabled = function() return not L('mythic_focus_flash') or not L('mythic_plus_enable')end,
									get = function() return unpack(L.config.mythic_focus_flash_color); end,
									set = function(_,...)
										L.config.mythic_focus_flash_color = {...};
									end,
								},
								mythic_focus_flash_speed = {
									type = 'range',
									name = 'Flash speed',
									min = .1,
									max = .4,
									step = .01,
									order = 2.3,
									get = L.GetFromDefaultOrSavedVariabiles,
									set = function(_, val)
										L.config.mythic_focus_flash_speed = val
									end,
								},
								mythic_focus_flash_test = {
									type = 'execute',
									name = 'Flash test',
									order = 2.4,
									func = function()
										myFlashFrame.bg:SetVertexColor(unpack(L.config.mythic_focus_flash_color))
										UIFrameFlash(myFlashFrame, L.config.mythic_focus_flash_speed, L.config.mythic_focus_flash_speed, 4 * L.config.mythic_focus_flash_speed, false)
									end,
								},
							},
						},
					},
				},
				mythic_spellCD_setup = {
					type = "group",
					name = "NPC Spell CD",
					order = 3,
					disabled = function() return not L('mythic_plus_enable') end,
					args = {
						mythic_spellCD = {
							type = 'toggle',
							name = 'Spell CD',
							desc = 'Show NPC spell CD.',
							order = 1.1,
							disabled = function() return not L('mythic_plus_enable') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						spacer19 =  {
							type = "description", order = 1.9, name = " ", fontSize = "medium",
						},
						mythic_spellCD_trackedOnly = {
							type = 'toggle',
							name = 'Only tracked',
							desc = 'Show NPC spell CD only for tracked spell and spells with unknow timer. Check Tracked for spell in M+ Database.',
							order = 2.1,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_trackedOnly = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_iconSize = {
							type = 'toggle',
							name = 'Icon size',
							desc = 'Use icon size from castBar setup in M+ Database.',
							order = 2.2,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_iconSize = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_CD = {
							type = 'toggle',
							name = 'Enable CD spiral',
							desc = 'Show CD spiral in spellCD icon.',
							order = 2.3,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_CD = val
							end,
						},
						mythic_spellCD_timer = {
							type = 'toggle',
							name = 'Enable timer',
							desc = 'Show timer in spellCD icon.',
							order = 3.1,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_timer = val
							end,
						},
						mythic_spellCD_desaturated = {
							type = 'toggle',
							name = 'Desaturated',
							desc = 'Desaturated icon if is on spell CD.',
							order = 3.2,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_desaturated = val
							end,
						},
						mythic_spellCD_border = {
							type = 'toggle',
							name = 'Shadow border',
							desc = 'Change shadow border color if spell is ready.',
							order = 3.3,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_border = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_border_color = {
							type = "color",
							name = "Color",
							hasAlpha = true,
							width = 'half',
							order = 3.4,
							disabled = function() return not L('mythic_spellCD') or not L('mythic_spellCD_border') end,
							get = function() return unpack(L.config.mythic_spellCD_border_color); end,
							set = function(_,...)
								L.config.mythic_spellCD_border_color = {...};
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_flash = {
							type = 'toggle',
							name = 'Enable flash',
							desc = 'Flash spell CD icon 2 sec before end cooldown.',
							order = 4.1,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_flash = val
							end,
						},
						mythic_spellCD_flash_time = {
							type = 'range',
							name = 'Flash time',
							desc = 'Flash time.',
							min = 1,
							max = 10,
							step = 1,
							order = 4.2,
							disabled = function() return not L('mythic_spellCD') or not L('mythic_spellCD_flash') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_flash_time = val
							end,
						},
						spacer49 =  {
							type = "description", order = 4.9, name = " ", fontSize = "medium",
						},
						mythic_spellCD_minTime = {
							type = 'range',
							name = 'Minimal time',
							desc = 'Minimal spell CD time for showing icon.',
							min = 0,
							max = 30,
							step = 1,
							order = 5.1,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_minTime = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_alpha_noCD = {
							type = 'range',
							name = 'Alpha not on CD',
							desc = 'Spell CD icon alpha if is not on CD.',
							min = 0,
							max = 1,
							step = .05,
							order = 5.2,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_alpha_noCD = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_alpha_onCD = {
							type = 'range',
							name = 'Alpha if is CD',
							desc = 'Spell CD icon alpha if is on CD.',
							min = 0,
							max = 1,
							step = .05,
							order = 5.3,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_alpha_onCD = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_width = {
							type = 'range',
							name = 'Icon width',
							min = 10,
							max = 30,
							step = 1,
							order = 6.1,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_width = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_height = {
							type = 'range',
							name = 'Icon height',
							min = 10,
							max = 30,
							step = 1,
							order = 6.2,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_height = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_space = {
							type = 'range',
							name = 'Icon space',
							min = 0,
							max = 10,
							step = 1,
							order = 6.3,
							disabled = function() return not L('mythic_spellCD') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_space = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_font = {
							type = "select",
							name = 'Timer font name',
							dialogControl = 'LSM30_Font',
							order = 7.1,
							disabled = function() return not L('mythic_spellCD') or not L('mythic_spellCD_timer') end,
							values = AceGUIWidgetLSMlists.font,
							style = "dropdown",
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_font = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_fontsize = {
							type = 'range',
							name = 'Timer font size',
							min = 2,
							max = 25,
							step = 1,
							order = 7.2,
							disabled = function() return not L('mythic_spellCD') or not L('mythic_spellCD_timer') end,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_fontsize = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_font_flag  = {
							type = 'select',
							name = 'Font flag',
							style = 'dropdown',
							order = 7.3,
							disabled = function() return not L('mythic_spellCD') or not L('mythic_spellCD_timer') end,
							values = font_flags_table,
							get = L.GetFromDefaultOrSavedVariabiles,
							set = function(_, val)
								L.config.mythic_spellCD_font_flag  = val
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
						mythic_spellCD_font_color = {
							type = "color",
							name = "Color",
							hasAlpha = true,
							width = "half",
							order = 7.4,
							disabled = function() return not L('mythic_spellCD') or not L('mythic_spellCD_timer') end,
							get = function() return unpack(L.config.mythic_spellCD_font_color); end,
							set = function(_,...)
								L.config.mythic_spellCD_font_color = {...};
								namePlateMixin:UpdateNamePlateByOptions("nameplate")
							end,
						},
					},
				},
			},
		},
	},
}
						
L.UpdateNPCDatabase = function(mapID, npcID, spellID, call)
	--print(mapID, npcID, spellID, call)
	L.options.args.NPC_DB = {
		type = 'group',
		name = 'M+ Database',
		order = 22,
		args = {
			selectDungeon = {
				type = 'select',
				name = '',
				desc = 'Select instance from database.',
				width = "double",
				order = 1.1,
				get = function(_)
					if not mapID then
						if not L.MythicNPCData then return end
						for filter in pairs(L.MythicNPCData) do
							if tonumber(filter) then
								mapID = tonumber(filter)
								break
							end
						end
						if not mapID then mapID = '' end
						L.UpdateNPCDatabase(mapID, nil, nil, "SelectDungeon GET")
					end
										
					return mapID
				end,
				set = function(_, value)
					mapID = tonumber(value)
					L.UpdateNPCDatabase(mapID, nil, nil, "Select Dungeon SET")
				end,
				values = function()
					local filters = {}
					local instanceName
					if not L.MythicNPCData then return end
					for filter in pairs(L.MythicNPCData) do
						if tonumber(filter) then
							instanceName = C_ChallengeMode.GetMapUIInfo(filter)
							if not instanceName then
								instanceName = GetRealZoneText(filter)
							end
							
							filters[filter] = format("|cff"..L.MythicNPCData[filter].instColor.."%s|r", filter > 0 and instanceName or "For all zones")
						end
					end
					if not next(filters) then filters[''] = NONE end
					return filters
				end,
			},
			addInstance = {
				type = 'execute',
				name = "Add instance",
				desc = function(_)
					local instanceName, _, _, _, _, _, _, instanceID = GetInstanceInfo()
					return 'Add this instance |cff0080FF'..instanceName..'|r(|cff00FF00'..instanceID..'|r) to M+ Database.'
				end,
				order = 1.2,
				disabled = function() return not (IsInInstance()) end,
				func = function()
					if L.MythicNPCData[L.mapID] then 
						print("|cffFF0000Instance with this instance ID exist in database!!!|r")
					else
						local instanceName, _, _, _, _, _, _, instanceID = GetInstanceInfo()
										
						if instanceID then
							if not L.MythicNPCData[instanceID] then
								mapID = tonumber(instanceID)
								L.MythicNPCData[mapID] = {}
								L.MythicNPCData[mapID].instColor = "00FFFF"
								namePlateMixin:OnCheckChallengeMode()
								print("Instance |cff"..L.MythicNPCData[mapID].instColor..""..instanceName.."|r("..mapID..") has been added to M+ Database.")
								L.UpdateNPCDatabase(mapID, nil, nil, "Add instance")
							end
						else
							print("|cffFF0000Hm bad INSTANCE ID???|r")
						end
					end
				end,
			},
			removeData = {
				type = 'execute',
				name = "|cffFF0000Delete|r",
				desc = "Delete all data from M+ Database for selected dungeon.",
				width = "half",
				order = 1.3,
				func = function()
					local instanceName = C_ChallengeMode.GetMapUIInfo(mapID)
					if not instanceName then
						instanceName = GetRealZoneText(mapID)
					end
					StaticPopupDialogs["DELETE_DUNGEON_DATA"] = {
						text = "You still want to delete instance |cff"..L.MythicNPCData[mapID].instColor..""..instanceName.."|r("..mapID..") data from M+ Database ?",
						button1 = "Yes",
						button2 = "No",
						OnAccept = function()
							L.MythicNPCData[mapID] = nil
							mapID = nil
							namePlateMixin:OnCheckChallengeMode()
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
							L.UpdateNPCDatabase(mapID, nil, nil, "removeData")
							--LibStub("AceConfigRegistry-3.0"):NotifyChange("Nameplates")
							LibStub('AceConfigDialog-3.0'):Open("Nameplates")
						end,
						timeout = 0,
						whileDead = true,
						showAlert = true,
						exclusive = true,
						hideOnEscape = true,
						preferredIndex = 3,
					}
					StaticPopup_Show("DELETE_DUNGEON_DATA")
				end,
				hidden = function() return not (mapID and mapID ~= "") end,
			},
			selectNPC = {
				type = 'select',
				name = 'Select NPC',
				desc = 'Select NPC from database.',
				width = "double",
				order = 1.4,
				hidden = function() return not (mapID and mapID ~= "") end,
				get = function(_)
					if not npcID then
						if not L.MythicNPCData[mapID] then return end
						for filter in pairs(L.MythicNPCData[mapID]) do
							if tonumber(filter) then
								npcID = tonumber(filter)
								break
							end
						end
						if not npcID then npcID = '' end
						L.UpdateNPCDatabase(mapID, npcID, nil, "SelectNPC GET")
					end										
				
					return npcID
				end,
				set = function(_, value)
					npcID = tonumber(value)
					L.UpdateNPCDatabase(mapID, npcID, nil, "SelectNPC SET")
				end,
				values = function()
					local filters = {}
					if not L.MythicNPCData[mapID] then return end
					for filter in pairs(L.MythicNPCData[mapID]) do
						if tonumber(filter) then
							local npcName = L.MythicNPCData[mapID][filter].destName
							if npcName then
								if L.MythicNPCData[mapID][filter].colored then
									local r, g, b, a = unpack(L.MythicNPCData[mapID][filter].color)
									local stringColor = format("ff%.2x%.2x%.2x", r * 255, g * 255, b * 255)
									filters[filter] = format("|c"..stringColor.."%s|r (%s)", npcName, filter)
								else
									filters[filter] = format("|cffffffff%s|r (%s)", npcName, filter)
								end
							end
						end	
					end
					if not next(filters) then filters[''] = NONE end
					return filters
				end,
			},
			addNPC = {
				type = 'input',
				name = 'Add new NPC',
				desc = 'Add new NPC to M+ Database. |cff00FF00Use NPC ID|r.',
				order = 1.5,
				hidden = function() return not (mapID and mapID ~= "") end,
				get = function(_) return "" end,
				set = function(_, value)
					if tonumber(value) then
						npcID = tonumber(value)
						L.MythicNPCData[mapID][npcID] = {}
						L.MythicNPCData[mapID][npcID].desc = ""
						L.MythicNPCData[mapID][npcID].colored = false
						L.MythicNPCData[mapID][npcID].color = {.7, .1, .9, .6}
						L.MythicNPCData[mapID][npcID].value = 0
						L.MythicNPCData[mapID][npcID].scale = 1
						L.MythicNPCData[mapID][npcID].destName = "unknow"
						L.MythicNPCData[mapID][npcID].kickbar = false
						L.MythicNPCData[mapID][npcID].powerbar = false
						L.MythicNPCData[mapID][npcID].hb = true
						L.MythicNPCData[mapID][npcID].hb_color = {0, 1, 0, 1}
						L.MythicNPCData[mapID][npcID].br = true
						L.MythicNPCData[mapID][npcID].br_color = {0, 1, 0, 1}
						L.MythicNPCData[mapID][npcID].gl = true
						L.MythicNPCData[mapID][npcID].gl_color = {0, 1, 0, 1}
						L.MythicNPCData[mapID][npcID].sound = 'None'
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
						L.UpdateNPCDatabase(mapID, npcID, nil, "addNPC")
					end
				end,
			},
			removeNPC = {
				type = 'execute',
				name = "|cffFF0000Delete|r",
				desc = "Remove selected a NPC from the database.",
				width = "half",
				order = 1.6,
				hidden = function() return not (mapID and mapID ~= "") or not (npcID and npcID ~= "") end,
				func = function()
					if tonumber(npcID) then
						if L.MythicNPCData[mapID][npcID] then
							L.MythicNPCData[mapID][npcID] = nil
							npcID = nil
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
							L.UpdateNPCDatabase(mapID, npcID, nil, "removeNPC")
						end
					end
				end,
			},
		},
	}
	
	if not mapID or L.MythicNPCData[mapID] == nil or not npcID or L.MythicNPCData[mapID][npcID] == nil then
		L.options.args.NPC_DB.args.set_npc = nil
		L.options.args.NPC_DB.args.set_spell = nil
		return
	else
		LibStub("AceConfigRegistry-3.0"):NotifyChange("Nameplates")
	end
	
	
	
	L.options.args.NPC_DB.args.set_npc = {
		type = "group",
		name = "Selected NPC",
		guiInline = true,
		inline = false,
		order = 2,
		args = {
			npc_destName = {
				type = 'input',
				name = "NPC name",
				desc = "Show this unit name in nameplate.",
				order = 1.1,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].destName
				end,
				set = function(_, destName)
					if (destName) then
						L.MythicNPCData[mapID][npcID].destName = destName
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end
				end,
			},
			npc_descText = {
				type = 'input',
				name = function(_)
					local text = "Description: "		
						for i, texture in pairs(L.TEX_WORLD_RAID_MARKERS) do
							text = text .. i .. texture .." "
						end
					return text
				end,
				desc = "Extended description for NPC.",
				width = "double",
				order = 1.2,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].desc
				end,
				set = function(_, npc_descText)
					if (npc_descText) then
						L.MythicNPCData[mapID][npcID].desc = npc_descText
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end
				end,
			},
			npc_value = {
				type = 'input',
				name = "NPC value",
				desc = "Change a NPC value in database.",
				width = "half",
				order = 1.3,
				hidden = function() return not C_ChallengeMode.GetMapUIInfo(mapID) end,
				get = function(_)
					return tostring(L.MythicNPCData[mapID][npcID].value)
				end,
				set = function(_, npc_value)
					if tonumber(npc_value) then
						npc_value = tonumber(npc_value)
						L.MythicNPCData[mapID][npcID].value = npc_value
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end
				end,
			},
			npc_size = {
				type = 'range',
				name = 'NPC scale',
				desc = 'Set NPC nameplate scale.',
				min = 0.05,
				max = 2,
				step = 0.05,
				isPercent = true,
				order = 2.1,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].scale
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].scale = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_sound = {
				type = "select",
				name = 'NPC sound',
				desc = 'Play this sound if this nameplate is showed.',
				order = 2.2,
				style = "dropdown",
				dialogControl = 'LSM30_Sound',
				values = AceGUIWidgetLSMlists and AceGUIWidgetLSMlists.sound or soundList,
				get = function(_)
					if L.MythicNPCData[mapID][npcID].sound then
						return L.MythicNPCData[mapID][npcID].sound
					else
						return ''
					end
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].sound = val
				end,
			},
			npc_kickbar = {
				type = "toggle",
				name = "kickBar",
				desc = "Show kick prediction bar on this NPC. Prediction must be enabled in |cff00ffffM+ Setup > Kicker prediction|r.",
				width = "half",
				order = 2.3,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].kickbar
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].kickbar = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_powerbar = {
				type = "toggle",
				name = "powerBar",
				desc = "Always show power bar for this NPC unit.",
				order = 2.4,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].powerbar
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].powerbar = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_healthbar_enable = {
				type = "toggle",
				name = "healthBar",
				desc = "Change healthBar color for this unit.",
				width = "half",
				order = 4.1,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].hb
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].hb = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_healthbar_color = {
				type = "color",
				name = "Color",
				width = "half",
				hasAlpha = true,
				order = 4.2,
				hidden = function() return not L.MythicNPCData[mapID][npcID].hb end,
				get = function()
					if L.MythicNPCData[mapID][npcID].hb_color then
						return unpack(L.MythicNPCData[mapID][npcID].hb_color)
					else
						return 0, 1, 0, 1
					end
				end,
				set = function(_,...)
					L.MythicNPCData[mapID][npcID].hb_color = {...}
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_border_enable = {
				type = "toggle",
				name = "Border",
				desc = "Change border color for this unit.",
				width = "half",
				order = 4.3,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].br
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].br = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_border_color = {
				type = "color",
				name = "Color",
				width = "half",
				hasAlpha = true,
				order = 4.4,
				hidden = function() return not L.MythicNPCData[mapID][npcID].br end,
				get = function()
					if L.MythicNPCData[mapID][npcID].br_color then
						return unpack(L.MythicNPCData[mapID][npcID].br_color)
					else
						return 0, 1, 0, 1
					end
				end,
				set = function(_,...)
					L.MythicNPCData[mapID][npcID].br_color = {...}
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_glow_enable = {
				type = "toggle",
				name = "Glow",
				desc = "Enable glow border for this unit.",
				width = "half",
				order = 4.5,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].gl
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].gl = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_animation_color = {
				type = "color",
				name = "Color",
				hasAlpha = true,
				order = 4.6,
				hidden = function() return not L.MythicNPCData[mapID][npcID].gl end,
				get = function()
					if L.MythicNPCData[mapID][npcID].gl_color then
						return unpack(L.MythicNPCData[mapID][npcID].gl_color)
					else
						return 0, 1, 0, 1
					end
				end,
				set = function(_,...)
					L.MythicNPCData[mapID][npcID].gl_color = {...}
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},	
			npc_colored = {
				type = "toggle",
				name = "Colorize name",
				desc = "Change name color for this unit.",
				order = 5.1,
				get = function(_)
					return L.MythicNPCData[mapID][npcID].colored
				end,
				set = function(_, val)
					L.MythicNPCData[mapID][npcID].colored = val
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
			npc_color = {
				type = "color",
				name = "Color",
				desc = "Select color for unit name",
				width = "half",
				hasAlpha = true,
				order = 5.2,
				hidden = function() return not L.MythicNPCData[mapID][npcID].colored end,
				get = function() return unpack(L.MythicNPCData[mapID][npcID].color) end,
				set = function(_,...)
					L.MythicNPCData[mapID][npcID].color = {...}
					namePlateMixin:UpdateNamePlateByOptions("nameplate")
				end,
			},
		},
	}
	
	L.options.args.NPC_DB.args.set_spell = {
		type = "group",
		name = "Selected spell",
		guiInline = true,
		inline = false,
		order = 3,
		args = {
			selectSpell = {
				type = "select",
				name = "Select Spell",
				width = "double",
				order = 1.1,
				desc = function(_)
					local text = "Unknown description, try again."
					if tonumber(spellID) then											
						local spell = Spell:CreateFromSpellID(tonumber(spellID))
						spell:ContinueOnSpellLoad(function()
							text = spell:GetSpellDescription()
						end)
					end
					return text
				end,
				get = function(_)
					if not spellID then
						if not L.MythicNPCData[mapID][npcID] then return end
						for filter in pairs(L.MythicNPCData[mapID][npcID]) do		
							if tonumber(filter) then
								spellID = tonumber(filter)
								break
							end
						end
						if not spellID then spellID = '' end
						--L.UpdateNPCDatabase(mapID, npcID, spellID, "selectSpell GET")
						return spellID
					end
					
					return spellID
				end,
				set = function(_, value)
					spellID = tonumber(value)
					--L.UpdateNPCDatabase(mapID, npcID, spellID, "SelectSpell SET")
				end,
				values = function()
					local filters = {}
					if not L.MythicNPCData[mapID][npcID] then return end
					for filter in pairs(L.MythicNPCData[mapID][npcID]) do
						if tonumber(filter) then
							local spellName, _, spellTexture = GetSpellInfo(filter)
							if spellName then
								if L.MythicNPCData[mapID][npcID][filter].notInterruptible or L.MythicNPCData[mapID][npcID][filter].notInterruptible == nil then
									filters[filter] = format("|cffFF0000%s|r |T" .. spellTexture .. ":20|t (%s)", spellName, filter)
								else
									filters[filter] = format("|cff00FF00%s|r |T" .. spellTexture .. ":20|t (%s)", spellName, filter)
								end
							end
						end	
					end
					if not next(filters) then filters[''] = NONE end
					return filters
				end,
			},
			addSpell = {
				type = 'input',
				name = "Add Spell ID",
				desc = "Add a spell to the datbase. |cff00FF00Use Spell ID|r.",
				order = 1.2,
				get = function(_) return "" end,
				set = function(_, spellID)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						local spellName = GetSpellInfo(spellID)
						if spellName then
							namePlateMixin:AddSpellToDatabase(mapID, npcID, spellID, nil)
							--namePlateMixin:UpdateNamePlateByOptions("nameplate")
							L.UpdateNPCDatabase(mapID, npcID, spellID)
						end
					end
				end,
			},
			removeSpell = {
				type = 'execute',
				name = "|cffFF0000Delete|r",
				desc = "Remove a spell from the database.",
				width = "half",
				order = 1.3,
				func = function()
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						if L.MythicNPCData[mapID][npcID][spellID] then
							L.MythicNPCData[mapID][npcID][spellID] = nil;
							spellID = nil;
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
							L.UpdateNPCDatabase(mapID, npcID, spellID)
						end
					end
				end,
				hidden = function() return not (spellID and spellID ~= "") end,
			},
			size = {
				type = 'range',
				name = 'Castbar scale',
				desc = 'Increase cast bar size for this spell.',
				min = 1,
				max = 2,
				step = 0.1,
				isPercent = true,
				order = 2.1,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].size
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].size = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end
				end,
			},
			sound = {
				type = "select",
				name = 'Spell sound',
				desc = 'Play this selected sound file if this spell casted.',
				style = "dropdown",
				order = 2.2,
				dialogControl = 'LSM30_Sound',
				values = AceGUIWidgetLSMlists and AceGUIWidgetLSMlists.sound or soundList,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].sound
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].sound = val
					end
				end,
			},
			scan_combat_log = {
				type = "toggle",
				name = "Combatlog",
				desc = "Scan combatlog and play sound if this spell is detected in CombatLog. Nameplate dont must by created.",
				width = "half",
				order = 3.1,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].combatLog
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].combatLog = val
					end
				end,
			},
			tank_sound = {
				type = "toggle",
				name = "Only tank",
				desc = "Play selected sound file only if player is TANK.",
				width = "half",
				order = 3.2,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].tanksound
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].tanksound = val
					end
				end,
			},
			target_me = {
				type = "toggle",
				name = "Target",
				desc = "Enable special functions for detection who is target for this spell. For warning setup use |cff00ffffM+ Setup > Spell warning|r.",
				width = "half",
				order = 3.3,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].targetme
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].targetme = val
					end
				end,
			},
			spell_tracked_time = {
				type = "input",
				name = "Predicted time",
				desc = "Change predicted spell CD",
				width = 'half',
				order = 4.1,
				disabled = function() return not (spellID and spellID ~= "") or L.MythicNPCData[mapID][npcID][spellID].timelock end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						--[[if L.MythicNPCData[mapID][npcID][spellID].trackedtime == nil then
							L.MythicNPCData[mapID][npcID][spellID].trackedtime = 0
							return tostring(L.MythicNPCData[mapID][npcID][spellID].trackedtime)
						else
							return tostring(L.MythicNPCData[mapID][npcID][spellID].trackedtime)
						end]]--
						if L.MythicNPCData[mapID][npcID][spellID].trackedtime ~= nil then
							return tostring(L.MythicNPCData[mapID][npcID][spellID].trackedtime)
						end
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						if tonumber(val) then
							predicted = tonumber(val)
							L.MythicNPCData[mapID][npcID][spellID].trackedtime = predicted
							namePlateMixin:UpdateNamePlateByOptions("nameplate")
						end
					end
				end,
			},
			spell_tracked_lock = {
				type = "toggle",
				name = "Lock time",
				desc = "Lock this time, and dont change him by addon prediction.",
				width = "half",
				order = 4.2,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].timelock
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].timelock = val
					end
				end,
			},
			spell_never = {
				type = "toggle",
				name = "Never",
				desc = "Never show this spell in tracked spell function.",
				width = 'half',
				order = 4.3,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].never
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].never = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end
				end,
			},
			spell_tracked = {
				type = "toggle",
				name = "Tracked",
				desc = "Show this spell in tracked spell function.",
				width = 'half',
				order = 4.4,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].tracked
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].tracked = val
						namePlateMixin:UpdateNamePlateByOptions("nameplate")
					end
				end,
			},
			spell_tracked_speach = {
				type = "toggle",
				name = "CDsound",
				desc = "Play sound 5, 4, 3, 2, 1.",
				width = 'half',
				order = 4.5,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].CDsound
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].CDsound = val
					end
				end,
			},
			spell_reflect = {
				type = "toggle",
				name = "Reflect",
				desc = "Play sound REFLECT if npc cast reflectable spell on you. Only if you are warrior and Spell Reflect is ready.",
				width = 'half',
				order = 4.6,
				disabled = function() return not (spellID and spellID ~= "") end,
				get = function(_)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						return L.MythicNPCData[mapID][npcID][spellID].reflect
					end
				end,
				set = function(_, val)
					if tonumber(spellID) then
						spellID = tonumber(spellID)
						L.MythicNPCData[mapID][npcID][spellID].reflect = val
					end
				end,
			},
		},
	}
end

--[[
NamePlateHorizontalScale	1	1
NamePlateVerticalScale	1	1
nameplateShowAll	1	0
nameplateShowDebuffsOnFriendly	1
nameplateShowEnemies	1
nameplateShowFriends	0
nameplateShowOnlyNames	0
nameplateShowSelf	0	1
ShowClassColorInFriendlyNameplate	1
ShowClassColorInNameplate	1
ShowNamePlateLoseAggroFlash	0	1
]]--